2011-03-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	Version 1.26
	* NEWS, configure.ac: Update.
	* po/POTFILES.in: Remove paxexit.c (see bb971a1e).

2011-03-08  Paul Eggert  <eggert@cs.ucla.edu>

	--atime-preserve=replace: fix correctness and performance bugs
	reported by Eric Blake in
	<http://lists.gnu.org/archive/html/bug-tar/2011-03/msg00000.html>.
	* src/compare.c (diff_file): Do not restore atime of size-zero
	files.
	* src/create.c (dump_file0): Likewise.	Also, do not restore atime
	when fd is zero, because that indicates a file we haven't opened.

2011-02-23  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/tar.texi: Adjust example commands and output for accuracy.
	The original problem was reported by Michael Witten in
	<http://lists.gnu.org/archive/html/bug-tar/2011-02/msg00033.html>.

2011-02-16  Paul Eggert  <eggert@cs.ucla.edu>

	tar: if (p) free (p); -> free (p);
	There is no longer (since SunOS 4) any need to guard against
	free (NULL), so replace each "if (p) free (p);" with "free (p);".
	From Jim Meyering in
	<http://lists.gnu.org/archive/html/bug-tar/2011-01/msg00026.html>.
	* src/incremen.c (scan_directory, read_directory_file): As above.
	(try_purge_directory): Likewise.
	* src/list.c (read_header): Likewise.
	* src/misc.c (assign_string): Likewise.

2010-12-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	Correctly store long sparse file names in PAX archives.
	* src/sparse.c (pax_dump_header_1): Make sure the created header
	name is
	shorter than NAME_FIELD_SIZE bytes.
	* tests/sparse04.at: New testcase.
	* tests/Makefile.am (TESTSUITE_AT): Add sparse04.at.
	* tests/testsuite.at: Include sparse04.at.
	* NEWS: Update.

2010-12-07  Paul Eggert  <eggert@cs.ucla.edu>

	tests: make the truncate test smaller and less buggy (tiny change)
	Reported by Solar Designer in
	<http://lists.gnu.org/archive/html/bug-tar/2010-12/msg00003.html>.
	* tests/truncate.at: Use a smaller test case, and make its
	race condition less likely.

2010-11-27  Paul Eggert  <eggert@cs.ucla.edu>

	tests: skip SIGPIPE-dependent tests in environments ignoring
	SIGPIPE
	Problem reported by Sven Joachim in
	<http://lists.gnu.org/archive/html/bug-tar/2010-11/msg00043.html>.
	* tests/remfiles01.at: Use AT_SIGPIPE_PREREQ.
	* tests/sigpipe.at: Likewise.
	* tests/testsuite.at (AT_SIGPIPE_PREREQ): New macro.

2010-11-25  Paul Eggert  <eggert@cs.ucla.edu>

	tar: work around NetBSD and Tru64 symlink incompatibility
	with POSIX
	Problem reported by Bruno Haible in
	<http://lists.gnu.org/archive/html/bug-gnulib/2010-11/msg00306.html>.
	* src/extract.c (maybe_recoverable):  Also treat EFTYPE (if
	defined)
	and ENOTSUP like ELOOP.

2010-11-24  Paul Eggert  <eggert@cs.ucla.edu>

	tar: adjust to paxutils change: paxexit.c -> paxexit-status.c
	* lib/Makefile.am (libtar_a_SOURCES): paxexit.c renamed to
	paxexit-status.c.

	tar: remove unused function dir_removed_diag
	* src/common.h (dir_removed_diag): Remove unused decl.
	* src/misc.c (dir_removed_diag): Remove unused function.

2010-11-23  Paul Eggert  <eggert@cs.ucla.edu>

	tar: work around FreeBSD symlink incompatibility with POSIX
	* src/extract.c (maybe_recoverable): Treat EMLINK like ELOOP, for
	FreeBSD.  Problem reported by Christian Weisgerber in
	<http://lists.gnu.org/archive/html/bug-tar/2010-11/msg00080.html>.

	* src/names.c: tar: fix bug with --one-file-system
	--listed-incremental
	Problem (and idea for fix) reported by Martin Weigel
	<http://lists.gnu.org/archive/html/bug-tar/2010-11/msg00071.html>.
	* src/common.h (is_individual_file): Remove decl.
	* src/create.c (dump_file0): Replace "is_individual_file (p)"
	with "top_level".
	* src/incremen.c (procdir): Replace "!is_individual_file
	(name_buffer)" with "st->parent".  Fix bug with --one-file-system
	and --listed-incremental.
	* src/names.c (individual_file_table, register_individual_file):
	(is_individual_file): Remove.  All uses removed.

	tests: new test listed04 for --one-file-system
	--listed-incremental
	* tests/Makefile.am (TESTSUITE_AT): Add listed04.at.
	* tests/listed04.at: New file.
	* tests/testsuite.at: Include it.

	scripts: fix option parsing
	Problem reported by Dennis Wydra in
	<http://lists.gnu.org/archive/html/bug-tar/2010-11/msg00082.html>.
	* scripts/backup.in: Accept "-l LEVEL".  Be more systematic about
	backslashes inside ``; it shouldn't matter for modern shells but
	it might matter for older ones.
	* scripts/restore.in: Likewise.
	* scripts/backup.in: Adjust implementation of -t/--time to match
	the new implementation of -l/--level.

2010-11-15  Sergey Poznyakoff  <gray@gnu.org.ua>

	Issue a warning if the archive being compared contais transformed
	file names.
	* src/common.h (transform_program_p): New proto.
	* src/transform.c (transform_program_p): New function.
	* src/compare.c (verify_volume): Warn if the archive contains
	transformed file names.

	Minor change.
	* doc/tar.texi: Reword the description of decompress-program.

2010-11-15  Paul Eggert  <eggert@cs.ucla.edu>

	tar: fix --verify option, which broke in 1.24
	* NEWS: Document this.
	* src/compare.c (verify_volume): Decode the header before invoking
	diff_archive, as diff_archive no longer does this as of the
	2010-06-28 commit.  Also, don't try to invoke diff_archive on a
	zero block.
	* tests/Makefile.am (TESTSUITE_AT): Add verify.at.
	* tests/testsuite.at: Include verify.at.
	* tests/verify.at: New file.

2010-11-08  Paul Eggert  <eggert@cs.ucla.edu>

	Merge branch 'master' of ssh://git.sv.gnu.org/srv/git/tar

2010-11-08  Jim Meyering  <meyering@redhat.com>

	tests: avoid spurious failure when VERSION_CONTROL envvar is set
	* tests/backup01.at: Unset VERSION_CONTROL.  Otherwise,
	when set to e.g., 'always', it would cause this test to fail.

2010-11-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	Version 1.25
	* configure.ac: Version 1.25
	* NEWS: Describe the changes.

2010-11-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	Run alternative decompression programs if the principal one is
	not available.
	Some compression programs are able to handle various compression
	formats
	(e.g. `gzip' can decompress files created by `compress', `xz'
	is able
	to handle lzma, etc.)  Tar tries to use such programs for
	decompression
	if the principal decompressor cannot be started.

	* src/buffer.c (compress_type): Swap ct_none and ct_tar.
	(archive_compression_type): New static variable.
	(zip_magic): Remove program and option fields.
	(zip_program): New structure and static.
	(compress_program): Remove macro.
	(find_zip_program): New static function.
	(first_decompress_program,next_decompress_program): New functions.
	(open_compressed_archive): Set archive_compression_type instead of
	use_compress_program_option.
	* src/common.h (first_decompress_program)
	(next_decompress_program): New functions.
	(WARN_DECOMPRESS_PROGRAM): New flag.
	(WARN_VERBOSE_WARNINGS): Include WARN_DECOMPRESS_PROGRAM.
	* src/warning.c (warning_args): Add "decompress-program".
	(warning_types): Add WARN_DECOMPRESS_PROGRAM.
	* src/system.c (run_decompress_program): New function.
	(sys_child_open_for_uncompress): Use run_decompress_program
	instead of calling execlp directly.

2010-11-02  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix some issues with signals, timestamps, "test" typo
	* tests/extrac17.at: Add --warning=no-timestamp, to avoid
	bogus warning due to NFS clock skew.
	* tests/remfiles01.at: Discard diagnostics that some shells
	generate about broken pipes.
	* tests/sigpipe.at: Likewise.
	* tests/remfiles01.at: Fix typo: "test $EC" was written where
	"test $EC -ne 0" was intended.

2010-11-01  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix extraction of device nodes.
	* src/extract.c (extract_node): Do not mask out node type.
	The bug was introduced in commit ea964cce.

2010-10-28  Paul Eggert  <eggert@cs.ucla.edu>

	tar: don't cross struct member boundaries with OLDGNU_MAGIC
	* src/create.c (write_gnu_long_link, start_header): Access
	header->buffer + offsetof (struct posix_header, magic), instead of
	header->header.magic, when reading or writing the OLDGNU_MAGIC
	pattern.  The code violates the C standard without this change,
	and GCC warns about this if fortify checking is enabled.  It's not
	a bug on traditional (i.e., non-debugging) platforms, but it does
	violate the C standard so it should be fixed.  Problem originally
	reported by John Emil Karlson in
	<http://lists.gnu.org/archive/html/bug-tar/2010-04/msg00023.html>.
	* src/list.c (decode_header): Likewise.

	tests: port to sh variants that squirrel away file descriptors
	OpenBSD /bin/sh, and some other sh variants, squirrel away file
	descriptors before closing them.  For example, for "cat 3<&-" they
	first dup file descriptor 3 to a fd that is 10 or greater, then
	close 3 (because if "cat" had been a builtin command like ":" then
	they would have wanted to avoid the fork and restore the fd after
	":" finished); and they treat ordinary (forking) commands the same
	as builtin commands.  This approach fails after "ulimit -n 10".
	Work around this deficiency by closing the file descriptors before
	invoking ulimit.  Problem reported by Christian Weisgerber in
	<http://lists.gnu.org/archive/html/bug-tar/2010-10/msg00041.html>;
	solution suggested by Jilles Tjoelker in
	<http://article.gmane.org/gmane.comp.shells.dash/415>.

	* tests/extrac11.at (scarce file descriptors): Close file
	descriptors before invoking ulimit -n.

2010-10-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	Transform file names when updating and appendig to archives.
	This complements 28e91b48.

	* src/common.h (transform_stat_info): New prototype.
	* src/list.c (transform_stat_info): Remove static qualifier.
	* src/update.c (update_archive): Call transform_stat_info.
	* tests/Makefile.am (TESTSUITE_AT): Add append03.at
	* tests/testsuite.at: Include append03.at

2010-10-27  Paul Eggert  <eggert@cs.ucla.edu>

	tests: port to Solaris diff
	* tests/extrac13.at: Don't assume that "diff -c" outputs nothing
	when there are no differences.	This is not true on Solaris,
	where it outputs "No differences encounted".

	tar: fix -x --overwrite bug (no --dereference, ! O_NOFOLLOW)
	This bug was discovered on Solaris 8.  On older hosts lacking
	O_NOFOLLOW, tar -x --overwrite (without --dereference) follows
	symbolic links, causing the "extract over symlinks" test to fail.

	* src/extract.c (open_output_file): If O_NOFOLLOW is needed but
	does not work, check for a symlink separately.

	tar: don't use "((" in shell scripts
	* tests/extrac11.at: Replace "((" with "( (" in shell scripts, as
	"((" is not portable to the Korn shell, and POSIX 1003.1-2008 says
	that "((" is not portable.

2010-10-26  Sergey Poznyakoff  <gray@gnu.org.ua>

	Make sure name matching occurs before name transformation.
	The commit 9c194c99 altered that order.

	* src/list.c (transform_stat_info): New function.  Split off from
	decode_header.
	(read_and): Call transform_stat_info right before do_something,
	and after deciding if we should proceed with this member name,
	so that name matching occurs before name transformation.

	* tests/extrac17.at: New file.
	* tests/Makefile.am (TESTSUITE_AT): Add extrac17.at
	* tests/testsuite.at: Include extrac17.at.

2010-10-26  Paul Eggert  <eggert@cs.ucla.edu>

	tar: don't assume stdin is open when testing fd limits
	* tests/extrac11.at: Redirect stdin from /dev/null, in case
	the parent 'make' is running with stdin closed.

2010-10-26  Sergey Poznyakoff  <gray@gnu.org.ua>

	Further fixes in bootstrap.
	* bootstrap: Restore the default for gnulib_path
	(symlink_to_dir): Re-apply 67cad07.

2010-10-26  Paul Eggert  <eggert@cs.ucla.edu>

	tar: fix bug with -C and extracting directories
	Problem reported by Denis Excoffier in
	<http://lists.gnu.org/archive/html/bug-tar/2010-10/msg00034.html>.

	* src/extract.c (extract_dir): Use mkdirat, not mkdir.
	* tests/extrac16.at: New file, to test for this bug.
	* tests/Makefile.am (TESTSUITE_AT): Add it.
	* tests/testsuite.at: Include it.

	This file is a placeholder. It will be replaced with the actual
	ChangeLog
	by make dist.  Run make ChangeLog if you wish to create it
	earlier.

2010-10-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	Version 1.24
	* configure.ac, NEWS: Version 1.24
	* bootstrap: Restore tar-specific code lost during last
	sync from gnulib (241b72ffad).
	* src/misc.c (chdir_do): Remove unused automatic variable.

2010-10-16  Paul Eggert  <eggert@cs.ucla.edu>

	tar: use more-accurate diagnostic when intermediate mkdir fails
	Without this change, if tar tried to extract a file A/B/C, noticed
	that A/B didn't exist, attempted to mkdir A/B, and the mkdir
	failed, it did not diagnose the mkdir failure, but simply reported
	the failure to open A/B/C.  This sometimes led to confusion
	because it wasn't clear what tar was trying to do, in particular
	that tar tried to mkdir A/B.  With this patch, tar issues two
	diagnostics in this case: one for A/B and the other for A/B/C.
	Problem reported by Hauke Laging in
	<http://lists.gnu.org/archive/html/bug-tar/2010-10/msg00020.html>.
	* gnulib.modules: Remove faccessat.
	* src/extract.c (make_directories): New arg INTERDIR_MADE.
	Diagnose mkdir failure.  Return 0 on success, nonzero on failure,
	as opposed to nonzero iff some directory was created.  All callers
	changed.  Simplify the code when mkdir fails, by checking whether
	the desired file exists unless errno==EEXIST: this is more robust.
	* tests/extrac15.at: New test, to check this.
	* tests/Makefile.am (TESTSUITE_AT): Add it.
	* tests/testsuite.at: Include it.

	tests: port to NFS file servers with clock skew
	Several of the tests assumed that a newly created file cannot
	have a time stamp dated in the future.	This assumption is not
	true when files are served by a remote host whose clock is
	slightly in advance of ours.  Fix the problems that I observed
	when running "make check" a couple of times on such a server.

	* tests/backup01.at: Use --warning=no-timestamp to suppress
	clock-skew warnings.
	* tests/chtype.at, tests/comprec.at, tests/exclude06.at:
	* tests/extrac01.at, tests/extrac03.at, tests/extrac05.at:
	* tests/extrac06.at, tests/extrac08.at, tests/extrac13.at:
	* tests/extrac14.at, tests/incr01.at, tests/incr03.at,
	tests/link01.at:
	* tests/multiv01.at, tests/multiv02.at, tests/multiv03.at:
	* tests/pipe.at, tests/rename02.at, tests/rename03.at:
	* tests/rename05.at, tests/same-order01.at, tests/same-order02.at:
	* tests/sparse01.at:
	Likewise.

2010-10-12  Paul Eggert  <eggert@cs.ucla.edu>

	gnulib: sync from latest gnulib, notably bootstrap and
	parse-datetime
	* bootstrap: Sync from gnulib.
	* doc/.gitignore: Rename getdate.texi to parse-datetime.texi.
	* doc/Makefile.am (tar_TEXINFOS): Likewise.
	* doc/tar.texi (Top): Adjust to renaming of getdate to
	parse-datetime.
	* gnulib.modules: Likewise.  Also, remove ftruncate (now
	obsolete).
	And add inttostr (we missed this dependency).
	* src/tar.c: Include parse-datetime.h, not getdate.h.  All calls
	to get_date replaced with parse_datetime.

2010-09-24  Paul Eggert  <eggert@cs.ucla.edu>

	tar: -x -C symlink fix
	* src/misc.c (chdir_do): Don't use O_NOFOLLOW when opening the
	argument to -C.  This is for consistency with "tar -c -C FOO", and
	matches the new documentation.
	* tests/extrac14.at: New file.
	* tests/Makefile.am (TESTSUITE_AT): Add it.
	* tests/testsuite.at: Include it.

	tar: --dereference consistency
	This closes another race condition, that occurs when overwriting a
	symlink with a regular file.
	* NEWS (--dereference consistency): New section.
	* doc/tar.texi (Option Summary): Describe new --deference
	behavior.
	(dereference): Likewise.  Remove discussion that I didn't follow,
	even before --dereference was changed.
	* src/common.h (deref_stat, set_file_atime): Adjust signatures.
	* src/compare.c (diff_file, diff_multivol): Respect
	open_read_flags
	instead of rolling our own flags.  This implements the new
	behavior
	for --dereference.
	(diff_file, diff_dumpdir): Likewise, for fstatat_flags.
	* src/create.c: Adjust to set_file_atime signature change.
	* src/extract.c (mark_after_links, file_newer_p, extract_dir):
	Likewise.
	* src/incremen.c (try_purge_directory): Likewise.
	* src/misc.c (maybe_backup_file): Likewise.
	* src/extract.c (file_newer_p): New arg STP.  All callers changed.
	(maybe_recoverable): New arg REGULAR.  All callers changed.
	Handle the case of overwriting a symlink with a regular file,
	when --overwrite is specified but --dereference is not.
	(open_output_file): Add O_CLOEXEC, O_NOCTTY, O_NONBLOCK for
	consistency with file creation.  Add O_NOFOLLOW if
	overwriting_old_files && ! dereference_option.
	* src/incremen.c (update_parent_directory): Use fstat, not
	fstatat;
	there's less to go wrong.
	* src/misc.c (deref_stat): Remove DEREF arg.  All callers changed.
	Instead, use fstatat_flags.
	(set_file_atime): Remove ATFLAG arg.  All callers changed.
	Instead, use fstatat_flags.
	* src/names.c, src/update.c: Adjust to deref_stat signature
	change.
	* src/tar.c (get_date_or_file): Use stat, not deref_stat, as this
	is not a file to be archived.
	* tests/Makefile.am (TESTSUITE_AT): Add extrac13.at.
	* tests/extrac13.at: New file.
	* tests/testsuite.at: Include it.

2010-09-20  Paul Eggert  <eggert@cs.ucla.edu>

	tar: do not crash with --listed-incremental
	Problem reported by Frantisek Hanzlik in
	<https://bugzilla.redhat.com/635318> via Kamil Dudka in
	<http://lists.gnu.org/archive/html/bug-tar/2010-09/msg00066.html>.
	I don't understand this code either, but Sergey can take a look at
	this patch, and perhaps install a better one, when he has
	the time.
	* src/incremen.c (append_incremental_renames): Don't actually
	append
	anything to DIR if DIR is null.

2010-09-19  Paul Eggert  <eggert@cs.ucla.edu>

	tar: prefer openat-style functions
	This change replaces traditional functions like 'open' with the
	POSIX.1-2008 functions like 'openat'.  Mostly this is an internal
	refactoring change, in preparation for further changes to close
	some races.
	* gnulib.modules: Add faccessat, linkat, mkfifoat, renameat,
	symlinkat.
	Remove save-cwd.
	* src/Makefile.am (tar_LDADD): Add $(LIB_EACCESS).
	* tests/Makefile.am (LDADD): Likewise.
	* src/common.h (chdir_fd): New extern var.
	* src/compare.c (diff_file, diff_multivol): Use openat instead
	of open.
	* src/create.c (create_archive, restore_parent_fd): Likewise.
	* src/extract.c (create_placeholder_file): Likewise.
	* src/names.c (collect_and_sort_names): Likewise.
	* src/update.c (append_file): Likewise.
	* src/compare.c (diff_symlink): Use readlinkat instead of
	readlink.
	* src/compare.c (diff_file): Use chdir_fd instead of AT_FDCWD.
	* src/create.c (subfile_open, dump_file0): Likewise.
	* src/extract.c (fd_chmod, fd_chown, fd_stat, set_stat):
	(repair_delayed_set_stat, apply_nonancestor_delayed_set_stat):
	Likewise.
	* src/extract.c (mark_after_links, file_newer_p, extract_dir):
	(extract_link, apply_delayed_links):
	Use fstatat rather than stat or lstat.
	* src/misc.c (maybe_backup_file, deref_stat): Likewise.
	* src/extract.c (make_directories): Use mkdirat rather than mkdir.
	Use faccessat rather than access.  This fixes a minor permissions
	bug when tar is running setuid (who would want to do that?!).
	(open_output_file): Use openat rather than open.
	In the process, this removes support for Masscomp's O_CTG files,
	which aren't compatible with openat's signature.  Masscomp!  Wow!
	That's a blast from the past.  As far as I know, that operating
	system hasn't been supported for more than 20 years.
	(extract_link, apply_delayed_links):
	Use linkat rather than link.
	(extract_symlink, apply_delayed_links):
	Use symlinkat rather than symlink.
	(extract_node): Use mknodat rather than mknod.
	(extract_fifo): Use mkfifoat rather than mkfifo.
	(apply_delayed_links): Use unlinkat rather than unlink or rmdir.
	* src/misc.c (safer_rmdir, remove_any_file): Likewise.
	* src/unlink.c (flush_deferred_unlinks): Likewise.
	* src/extract.c (rename_directory): Use renameat rather than
	rename.
	* src/misc.c (maybe_backup_file, undo_last_backup): Likewise.
	* src/misc.c: Don't include <save-cwd.h>; no longer needed now
	that we're using openat etc.
	(struct wd): Add member fd.  Remove members err and fd.  All uses
	changed.
	(CHDIR_CACHE_SIZE): New constant.
	(wdcache, wdcache_count, chdir_fd): New vars.
	(chdir_do): Use openat rather than save_cwd.  Keep the cache up
	to date.  This code won't scale well, but is good enough for now.
	* src/update.c (update_archive): Use openat + fdopendir +
	streamsavedir rather than savedir.

	This file is a placeholder. It will be replaced with the actual
	ChangeLog
	by make dist.  Run make ChangeLog if you wish to create it
	earlier.

2010-09-18  Paul Eggert  <eggert@cs.ucla.edu>

	tar: add utimens.h includes
	* src/extract.c: Include <utimens.h>, needed for fdutimens
	prototype.
	* src/misc.c: Likewise.

	tar: switch to gnulib fdutimensat module
	* gnulib.modules: Add fdutimensat.
	* src/common.h (fd_utimensat): Remove decl.
	* src/extract.c (set_stat): Call fdutimensat, not fd_utimensat.
	* src/misc.c (set_file_atime): Likewise.
	(fd_utimensat): Remove.

2010-09-17  Paul Eggert  <eggert@cs.ucla.edu>

	tar: extract permissions for . last
	* src/common.h (must_be_dot_or_slash): New decl.
	* src/extract.c (mark_after_links): New function, taking code
	that used to be in create_placeholder_file.
	(create_placeholder_file): Use it.
	(delay_set_stat): Always delay setting status for . and /.
	* src/misc.c (must_be_dot_or_slash): Now extern.
	* tests/extrac12.at: New file.
	* tests/Makefile.am (TESTSUITE_AT): Add it.
	* tests/testsuite.at: Likewise.

	tar: don't check for getdtablesize; use AC_CHECK_FUNCS_ONCE
	* configure.ac: Don't check for getdtablesize; no longer needed.
	Use AC_CHECK_FUNCS_ONCE rather than AC_CHECK_FUNCS, for
	efficiency.

	tar: extract symlink attributes, close some symlink-related races
	* NEWS: Describe symlink-extraction improvements.
	* src/extract.c (enum permstatus): Remove.
	(fchmod, fchown): Define dummy replacement macros if the system
	does not supply them.
	(implemented): New function.
	(struct delayed_set_stat): Remove members invert_permissions,
	permstatus.  They were too confusing, and tried to do too much
	in too-little space.  Instead, add members current_mode,
	current_mode_mask, interdir, atflag.  All users changed.
	(struct delayed_link): Add members mode, atime, mtime, to support
	platforms such as BSD where symlinks have these attributes.
	All users changed.
	(fd_chmod): Renamed from fdchmod.  New argument atflag.  Check for
	operation not supported at run-time, not at configure-time.  Put
	fd argument first.  All callers changed.
	(fd_chown): Likewise, renaming from fdchown.
	(fd_stat): Likewise, renaming from fdstat.
	(set_mode): Remove args stat_info, cur_info, invert_permissions,
	permstatus.  Add args mode, mode_mask, current_mode,
	current_mode_mask,
	atflag.  All callers changed.  Close some races.  Use an easier-to
	understand method for computing permissions.  Work around POSIX
	incompatibility in Linux fchmodat.  Support extraction of symlink
	modes, if the OS allows it.
	(set_stat): Remove args cur_info, invert_permissions, permstatus.
	Add args current_mode, current_mode_mask, interdir, atflag.
	All callers changed.  Close some races.  Support extraction of
	attributes on symlinks, if the OS allows it.
	(delay_set_stat): Remove args invert_permissions, permstatus.
	Add args current_mode, current_mode_mask, mode, atflag.
	The ST arg can be null now, indicating that it's an intermediate
	directory.  All callers changed.
	(repair_delayed_set_stat, apply_nonancestor_delayed_set_stat):
	Close some races.
	(extract_dir): Also be paranoid if only --same-permissions, due
	to semantics of setgid and setuid directories on some hosts.
	This closes a race on those hosts.  Simplify calculation of
	delay_set_stat arguments; the old code was truly strange and
	probably wrong in some border cases.
	(extract_dir, extract_file, extract_node, extract_fifo): Don't
	rely on
	unspecified behavior in mode arg of open, mknod, etc.  Instead,
	mask out those bits when creating the file, and add them later via
	fchmod or chmodat.
	(open_output_file): file_name is now const.  Add arg current_mode,
	current_mode_mask.  All callers changed.  When overwriting
	old files,
	refuse to overwrite something that is not a regular file, since
	we're extracting a regular file.
	(extract_file): Remove the FIXME comment.  Whatever the protection
	issues were, they should be fixed now.	As a result of all
	the other
	API changes, we now use fchmod etc. rather than chmod etc.,
	closing
	some races.
	(create_placeholder_file, apply_delayed_links): Record desired
	mode and times for symlinks, for OSes that support that.

2010-09-16  Paul Eggert  <eggert@cs.ucla.edu>

	tar: tar -x without --incremental no longer sets atime again
	* src/extract.c (set_stat): Use UTIME_OMIT rather than UTIME_NOW.
	The UTIME_NOW was there only to emulate the previous behavior of
	using the current time, and the previous behavior was there only
	because before we started assuming POSIX.1-2008 there was no
	portable way to get the effect of UTIME_NOW.

	tar: another --atime-preserve race fix
	* src/common.h (set_file_atime): Add parentfd arg.
	* src/compare.c (diff_file): Use it.
	* src/create.c (dump_file0): Likewise.	This closes yet another
	race condition with symbolic links.
	* src/misc.c (set_file_atime): Add parentfd arg.

	tar: --atime-preserve fixes for races etc.
	This patch fixes a race condition in the --atime-preserve=replace
	option, which might cause tar to improperly follow a symbolic
	link.

	It also drops the use of the _FIOSATIME ioctl of Solaris 2.x
	and later, which loses resolution on time stamps.  Modern Solaris
	systems support full-resolution time stamps in the kernel, and
	it's not worth the hassle of testing this call, useful only in
	no-longer-supported Solaris variants.

	Also, it undoes a change I recently introduced to the --compare
	option, which caused it to not follow symbolic links unless the
	--dereference option was also used.  Quite possibly this change is
	a good idea, but the old behavior was documented and the change
	should not have been installed casually.

	* configure.ac: Don't check for stropts.h and sys/filio.h.
	* gnulib.modules: Add futimens, utimensat.  Remove futimens.
	* src/common.h (fd_utimensat): New decl.
	* src/compare.c (diff_file, diff_multivol):
	Don't use open_read_flags: those are for --create only.
	* src/create.c (dump_file0): Adjust to set_file_atime changes.
	Pass fstatat_flags to set_file_atime, so that symbolic links are
	not followed inadvertantly.
	* src/extract.c: Don't include utimens.h.
	(set_stat): Use fd_utimensat ant UTIME_NOW rather than fdutimens.
	* src/misc.c: Don't include utimens.h, stropts.h, sys/filio.h.
	(fd_utimensat): New function.
	(set_file_atime): Use it.  New arg atflag, controlling symlink
	handling.  All callers changed.

2010-09-14  Paul Eggert  <eggert@cs.ucla.edu>

	* configure.ac: tar: close some race conditions when extracting
	* configure.ac: Check for fchmod and fchown.  Don't check
	for utimes.
	* src/extract.c (fdchmod, fdchown, fdstat): New functions.
	(set_mode, set_stat): New arg FD.  All callers changed.
	This avoids some race conditions between closing a regular file
	and setting its metadata, and it's a bit faster.

2010-09-13  Paul Eggert  <eggert@cs.ucla.edu>

	tar: don't worry about fdopendir closing its argument
	* NEWS: Don't mention dirfd; no longer needed.
	* gnulib.modules: Remove dirfd.
	* src/create.c (get_directory_entries): Remove the code dealing
	with dirfd failures, as the new fdopendir replacement doesn't
	close its argument so we don't need to call dirfd.  See
	<http://lists.gnu.org/archive/html/bug-gnulib/2010-09/msg00208.html>
	and gnulib commit 970c9038e4cca46e1b037ae0a6d574dfae6a7327.

	* NEWS: Fix wording typo in previous change.
	Reported by Jim Meyering.

	tar: live within system-supplied limits on file descriptors
	* NEWS: Note the change.  Mention dirfd and fdopendir.
	* gnulib.modules: Add dirfd and fdopendir.  The code was already
	using fdopendir; dirfd is a new need.
	* src/common.h (open_searchdir_flags, get_directory_entries):
	(subfile_open, restore_parent_fd, tar_stat_close): New decls.
	(check_exclusion_tags): Adjust signature to match code change.
	* src/create.c (IMPOSTOR_ERRNO): New constant.
	(check_exclusion_tags): First arg is now a struct tar_stat_info
	const *, not an fd.  All callers changed.
	(dump_regular_file, dump_file0): A zero fd represents an unused
	slot, so play it safe if the fd member is zero here.  A negative
	fd represents the negation of an errno value, so play it safe and
	do not assign -1 to fd merely because an open fails.
	(open_failure_recover, get_directory_entries, restore_parent_fd):
	(subfile_open): New functions.	These help to recover from file
	descriptor exhaustion.
	(dump_dir, dump_file0): Use them.
	(dump_file0): Use tar_stat_close instead of rolling our own close.
	* src/incremen.c (scan_directory): Use get_directory_entries,
	subfile_open, etc., to recover from file descriptor exhaustion.
	* src/names.c (add_hierarchy_to_namelist): Likewise.
	(collect_and_sort_names): A negative fd represents the negation
	of an errno value, so play it safe and do not assign -1 to fd.
	* src/tar.c (decode_options): Set open_searchdir_flags.
	Add O_CLOEXEC to all the open flags.
	(tar_stat_close): New function, which knows how to deal with
	new convention for directory streams and file descriptors.
	Diagnose 'close' failures.
	(tar_stat_destroy): Use it.
	* src/tar.h (struct tar_stat_info): New member dirstream.
	fd now has the negative of an errno value, not merely -1, if
	the file could not be opened, so that failures to reopen
	directories
	are better-diagnosed later.
	* tests/Makefile.am (TESTSUITE_AT): Add extrac11.at.
	* tests/testsuite.at: Likewise.
	* tests/extrac11.at: New file.

2010-09-08  Paul Eggert  <eggert@cs.ucla.edu>

	tar: improve documentation of reliability and security issues
	* doc/tar.texi (Reliability and security, Reliability):
	(Permissions problems, Data corruption and repair, Race
	conditions):
	(Security, Privacy, Integrity, Live untrusted data):
	(Security rules of thumb): New nodes.

2010-09-06  Paul Eggert  <eggert@cs.ucla.edu>

	tar: more reliable directory traversal when creating archives
	* NEWS: Document this.
	* gnulib.modules: Add openat, readlinkat.
	* src/common.h (open_read_flags, fstatat_flags): New global
	variables.
	(cachedir_file_p, dump_file, check_exclusion_tags,
	scan_directory):
	Adjust to new signatures, described below.
	(name_fill_directory): Remove.
	* src/compare.c (diff_file, diff_multivol): Use open_read_flags.
	* src/create.c (struct exclusion_tag): Exclusion predicates
	now take
	a file descriptor, not a file name.
	(add_exclusion_tag): Likewise.	All uses changed.
	(cachedir_file_p): Likewise.
	(check_exclusion_tags): The directory is now a file descriptor,
	not a file name.  All uses changed.  Use openat for better
	traversal.
	(file_dumpable_p): Arg is now a struct stat, not a struct
	tar_stat_info.	All uses changed.  Check the arg's file types too.
	(dump_dir0, dump_dir, dump_file0, dump_file): Omit top_level and
	parent_device args, since st->parent tells us that now.  All uses
	changed.
	(dump_dir): Likewise.  Also, omit fd arg for similar reasons.
	Apply fdsavedir to a dup of the file descriptor, since we need a
	file descriptor for openat etc. as well, and fdsavedir (perhaps
	unwisely) consumes its file descriptor when successful.
	Do not consume st->fd when successful; this simplifies the caller.
	(create_archive): Allocate a file descriptor when retraversing
	a directory, during incremental dumps.
	(dump_file0): Use fstatat, openat, and readlinkat for better
	traversal.
	When opening a file, use the result of fstat on the file
	descriptor
	rather than the fstatat on the directory entry, to avoid some race
	conditions.  No need to reopen the directory since we now
	no longer
	close it.  Change "did we open the file?" test from 0 <= fd to
	0 < fd since fd == 0 now represents uninitialized.
	(dump_file): Now accepts struct tar_stat_info describing parent,
	not parent_device.  Also, accept basename and fullname of entry.
	All uses changed.
	* src/incremen.c (update_parent_directory): Accept struct
	tar_stat_info for parent, not name.  All callers changed.
	Use fstatat for safer directory traversal.
	(procdir): Accept struct tar_stat_info, not struct stat and
	dev_t, for info about directory.  All callers changed.
	(scan_directory): Accept struct tar_stat_info, not name,
	device, and cmdline, for info about directory.	All callers
	changed.  Do not consume the file descriptor, since caller
	might need it.	Use fstatat and openat for safer directory
	traversal; also, use fstat after opening to double-check.
	(name_fill_directory): Remove.
	* src/names.c (add_hierarchy_to_namelist): Accept struct
	tar_stat_info instead of device and cmdline.  All callers changed.
	When descending into a subdirectory, use openat and fstat for
	safer directory traversal.
	(collect_and_sort_names): Use open and fstat for safer directory
	traversal.  Set up struct tar_stat_info for callee's new API.
	* src/tar.c (decode_options): Initialize open_read_flags
	and fstatat_flags.
	(tar_stat_destroy): Close st->fd if it is positive (not zero!).
	* src/tar.h (struct tar_stat_info): New members parent, fd.
	* src/update.c (update_archive): Adjust to dump_file's API change.
	* tests/filerem02.at: Ignore stderr since its contents now depend
	on the file system implementation.

2010-09-05  Paul Eggert  <eggert@cs.ucla.edu>

	tar: remove lint discovered by Sun C compiler
	* src/common.h (WARN_ALL): Don't mask with 0xffffffff; on a 32-bit
	host, 0xffffffff is of type 'unsigned int', which makes WARN_ALL
	an unsigned int value that is too large to fit into an int, and
	the C standard says that this has undefined behavior.  The mask is
	not needed, so omit it.

2010-09-04  Paul Eggert  <eggert@cs.ucla.edu>

	tar: restore macros that are used in some cases
	* src/tar.c (LOW_DENSITY_NUM, MID_DENSITY_NUM, HIGH_DENSITY_NUM):
	Restore these macros, undoing the previous change to this file.
	The macros are used after all, in some cases.  Sorry about that.

2010-09-03  Paul Eggert  <eggert@cs.ucla.edu>

	tar: remove unused macros
	* src/create.c (UINTMAX_TO_CHARS): Remove; no longer used.
	* src/tar.c (LOW_DENSITY_NUM, MID_DENSITY_NUM, HIGH_DENSITY_NUM):
	Likewise.
	* src/incremen.c (DIR_IS_NEW): Comment out; not used.
	Mark this with a FIXME, since it looks like it should be used.

2010-08-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix --remove-files in update/append mode.
	* src/update.c (update_archive): Call finish_deferred_unlinks when
	done.

2010-08-26  Paul Eggert  <eggert@cs.ucla.edu>

	tar: avoid assumptions about root access and chmod -w in test
	cases
	* tests/extrac07.at, tests/extrac09.at, tests/listed03.at: Use
	AT_UNPRIVILEGED_PREREQ, since this test requires non-root
	privileges.
	* tests/extrac07.at: Don't use "chmod -w", as POSIX says it's not
	portable to start a chmod permissions-list with "-" as it may be
	confused with an option.  Use "chmod a-w" instead.

	tar: fix bug with -C and delayed setting of metadata
	* src/common.h (chdir_current): New decl.
	* src/extract.c (struct delayed_set_stat, struct delayed_link):
	New member change_dir.
	(delay_set_stat, create_placeholder_file): Set it.
	(apply_nonancestor_delayed_set_stat, apply_delayed_links): Use it.
	(extract_link): Check that the links are all relative to the same
	directory.
	(extract_archive): Restore the current directory after
	apply_nonancestor_delayed_set_stat has possibly changed it.
	* src/misc.c (chdir_current): New external var; this used to
	be the private static variable 'previous' inside chdir_dir.
	All uses changed.
	* tests/Makefile.am (TESTSUITE_AT): New test extrac10.at.
	* tests/extrac10.at: New file.
	* tests/testsuite.at: Include it.

2010-08-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	Don't apply file transformations to volume names.
	* src/list.c (decode_header): Don't apply file transformations
	to volume names.
	* tests/xform01.at: New testcase.
	* tests/xform-h.at (xform): Rename macro to xformtest. Use
	pushdef/popdef.
	* tests/Makefile.am, tests/testsuite.at: Add xform01.at

2010-08-25  Paul Eggert  <eggert@cs.ucla.edu>

	tar: optimize -c --sparse when file is entirely sparse
	* src/sparse.c (sparse_scan_file): If the file is entirely sparse,
	that is, if ST_NBLOCKS is zero, don't bother scanning for nonzero
	blocks.  Idea by Kit Westneat, communicated by Bernd Schubert in
	<http://lists.gnu.org/archive/html/bug-tar/2010-08/msg00038.html>.
	Also, omit unnecessary lseek at start of file.

	tar: don't assume size of a sparse file chunk fits in size_t
	* src/tar.h (struct sp_array): Change numbytes from size_t
	to off_t.
	All uses changed.
	* scripts/xsparse.c (struct sp_array): Likewise.
	Include <stdint.h>, for SIZE_MAX.
	(expand_sparse): Don't try to allocate a buffer bigger than
	SIZE_MAX bytes.
	* src/common.h (SIZE_TO_CHARS, size_to_chars, SIZE_FROM_HEADER):
	(size_from_header): Remove decls.
	* src/create.c (size_to_chars): Remove.
	* src/list.c (size_from_header): Remove.
	* src/sparse.c (sparse_extract_region, check_data_region):
	(oldgnu_add_sparse, oldgnu_store_sparse_info, pax_decode_header):
	Don't assume chunk sizes fit in size_t.
	(oldgnu_add_sparse): Check for off_t overflow.
	* src/xheader.c (sparse_numbytes_decoder, sparse_map_decoder):
	Likewise.

	tar: use ctime, not mtime, when checking placeholders
	* src/extract.c (struct delayed_link): Rename member mtime
	to ctime.
	All uses changed to use ctime rather than mtime.

2010-08-24  Paul Eggert  <eggert@cs.ucla.edu>

	tar: add comment to link04.at test
	* tests/link04.at: Add explanatory comment at head.

	tar: fix 1.23 Solaris regression related to PRIV_SYS_LINKDIR
	The idea was suggested by Petr Sumbera in the thread starting
	here:
	http://lists.gnu.org/archive/html/bug-tar/2010-08/msg00000.html
	* src/extract.c (set_mode): Save the errno of the chmod that
	failed, for the benefit of chmod_error_details.  Do not bother
	retrying chmod unless the mode suggests setuid is the issue.
	(extract_archive): Remove redundant call to
	priv_set_remove_linkdir.
	* src/system.c: Include priv-set.h.
	(sys_spawn_shell, sys_child_open_for_compress):
	(sys_child_open_for_uncompress, sys_exec_command):
	(sys_exec_info_script, sys_exec_checkpoint_script):
	Invoke priv_set_restore_linkdir before execv or execlp, so that
	the subprocess has the same privileges that tar originally did.

	tar: handle files that occur multiple times but have link count 1
	This patch was inspired by the following patch that addressed a
	similar problem in GNU coreutils du:
	http://git.savannah.gnu.org/gitweb/?p=coreutils.git;h=efe53cc72b599979ea292754ecfe8abf7c839d22
	* src/common.h (name_count): New decl.
	* src/create.c (trivial_link_count): New static var.
	(create_archive): Initialize it.
	(dump_hard_link, file_count_links): Use it, so that files with
	link count 1 are handled correctly when they are found multiple
	times.
	* src/names.c (allocated_entries): Renamed from allocated_names,
	since the identifier's name was misleading.  All uses changed.
	(entries): Renamed from names.	All uses changed.
	(scanned): Renamed from name_index.  All uses changed.
	(name_count): New var.
	(name_add_name): Increment it.
	* tests/link04.at: New file.
	* tests/testsuite.at: Add it.
	* tests/Makefile.am (TESTSUITE_AT): Likewise.

2010-08-23  Paul Eggert  <eggert@cs.ucla.edu>

	tar: use nlink_t for link counts
	* src/create.c (struct link): nlink is now of type nlink_t,
	not size_t.

	tar: don't export names that aren't used elsewhere
	* src/common.h (file_dumpable_p, gid_to_chars, major_to_chars):
	(minor_to_chars, mode_to_chars, uid_to_chars, uintmax_to_chars):
	(string_to_chars, dumpdir_creat0, dumpdir_create, dumpdir_free):
	(dumpdir_locate, dumpdir_next, dumpdir_first, gid_from_header):
	(major_from_header, minor_from_header, mode_from_header):
	(time_from_header, uid_from_header, quote_copy_string,
	request_stdin):
	(xheader_init, transform_header_name):
	Remove declarations; these are no longer exported from their
	modules.
	(GID_TO_CHARS, MAJOR_TO_CHARS, MINOR_TO_CHARS, MODE_TO_CHARS):
	(UID_TO_CHARS, UINTMAX_TO_CHARS, UNAME_TO_CHARS, GNAME_TO_CHARS):
	Move to src/create.c, since no other module uses these.
	(GID_FROM_HEADER, MAJOR_FROM_HEADER, MINOR_FROM_HEADER):
	(MODE_FROM_HEADER, TIME_FROM_HEADER, UID_FROM_HEADER):
	Move to src/extract.c, since no other module uses these.
	(dumpdir_t, dumpdir_iter_t): Remove; no longer used.
	* src/create.c (gid_to_chars, major_to_chars, minor_to_chars):
	(mode_to_chars, uid_to_chars, uintmax_to_chars, string_to_chars):
	(file_dumpable_p): Now static.
	* src/incremen.c (dumpdir_create0, dumpdir_create, dumpdir_free):
	(dumpdir_locate, dumpdir_next, dumpdir_first): Now static.
	(scan_directory, write_directory_file_entry):
	Use struct dumpdir_iter * rather than dumpdir_iter_t.
	* src/list.c (gid_from_header, major_from_header,
	minor_from_header):
	(mode_from_header, time_from_header, uid_from_header):
	(transform_member_name): Now static.
	* src/misc.c (quote_copy_string): #if 0 out, as it's not used
	anywhere.
	* src/system.c (wait_for_grandchild): Now static.
	* src/tar.c (request_stdin): Now static.
	* src/xheader.c (xheader_init): Now static.

	tar: fix misspelled identifier "set_comression_program_by_suffix"
	* src/suffix.c (set_compression_program_by_suffix): Renamed from
	set_comression_program_by_suffix.
	* src/buffer.c, src/common.h, src/tar.c: All uses changed.

2010-08-20  Paul Eggert  <eggert@cs.ucla.edu>

	tar: change interdir_made from int to bool
	* src/extract.c (maybe_recoverable, create_placeholder_file):
	Change interdir_made from int * to bool *, since the flag has just
	two values 0 and 1.  All uses changed.	This does not affect tar's
	behavior.

	tar: remove trailing white space from source files
	* ChangeLog.1, ChangeLog.CVS, Makefile.am, NEWS, README:
	* README-hacking, directory, doc/Makefile.am, doc/dumpdir.texi:
	* doc/gendocs_template, doc/intern.texi, doc/mastermenu.el:
	* doc/snapshot.texi, doc/sparse.texi, doc/tar-snapshot-edit.texi:
	* doc/value.texi, lib/Makefile.am, scripts/backup-specs:
	* scripts/dump-remind.in, scripts/tar-snapshot-edit,
	scripts/tarcat:
	* scripts/xsparse.c, src/arith.h, src/buffer.c, src/compare.c:
	* src/create.c, src/delete.c, src/exit.c, src/suffix.c, src/tar.c:
	* src/tar.h, src/update.c, src/warning.c, src/xheader.c:
	* tests/append01.at, tests/append02.at, tests/atlocal.in:
	* tests/delete03.at, tests/exclude.at, tests/exclude06.at:
	* tests/extrac04.at, tests/extrac05.at, tests/extrac06.at:
	* tests/extrac07.at, tests/filerem01.at, tests/filerem02.at:
	* tests/incr01.at, tests/incr02.at, tests/incr03.at,
	tests/incr06.at:
	* tests/label02.at, tests/label03.at, tests/label04.at:
	* tests/label05.at, tests/link02.at, tests/link03.at:
	* tests/listed01.at, tests/listed02.at, tests/long01.at:
	* tests/longv7.at, tests/multiv01.at, tests/multiv02.at:
	* tests/multiv03.at, tests/multiv05.at, tests/multiv06.at:
	* tests/multiv07.at, tests/multiv08.at, tests/options.at:
	* tests/options02.at, tests/remfiles03.at, tests/rename01.at:
	* tests/rename02.at, tests/rename03.at, tests/rename04.at:
	* tests/rename05.at, tests/same-order01.at, tests/same-order02.at:
	* tests/shortfile.at, tests/shortupd.at, tests/sparse01.at:
	* tests/sparse02.at, tests/sparsemv.at, tests/sparsemvp.at:
	* tests/star/README, tests/star/gtarfail2.at:
	* tests/star/multi-fail.at:
	* tests/star/pax-big-10g.at, tests/star/quicktest.sh:
	* tests/star/ustar-big-2g.at, tests/star/ustar-big-8g.at:
	* tests/update01.at, tests/update02.at, tests/volsize.at:
	* tests/volume.at:
	Remove trailing spaces and tabs from lines, and remove
	trailing empty lines from files.  This makes it a bit easier
	to share code among coreutils and other projects that do this.

2010-08-19  Paul Eggert  <eggert@cs.ucla.edu>

	tar: update licenses to latest versions from www.gnu.org
	* COPYING: Update to latest version; this is just minor
	formatting.
	* doc/fdl.texi: Update from GFDL 1.2 to 1.3.
	* doc/tar.texi: Adjust to new format of fdl.texi.  Omit trailing
	white space.

2010-07-18  Paul Eggert  <eggert@cs.ucla.edu>

	* src/misc.c (struct wd): Fix comment to match code.

2010-07-18  Paul R. Eggert  <eggert@cs.ucla.edu>

	tar: no need to report getcwd error if never using the result
	* src/misc.c (struct wd): Rename 'saved' to 'err', with new
	semantics.
	(chdir_arg, chdir_do): Adjust to new semantics.  Do not report an
	error merely because save_cwd fails; report an error only if
	save_cwd's result is needed later.
	* tests/extrac09.at: New file, to test for bug that was fixed.
	* tests/testsuite.at: Include it.
	* tests/Makefile.am (TESTSUITE_AT): Add it.

	tar: go back to absolutifying filenames in normalize_filename
	for now
	* src/misc.c (normalize_filename): For now, go back to making
	filenames absolute, even though this causes 'tar' to fail when
	getcwd fails.  However, do not attempt to resolve ".." as this
	does not work with symlinks.  Also, do the right thing with
	leading file system prefixes and on hosts where // != /.

2010-07-17  Sergey Poznyakoff  <gray@gnu.org.ua>

	Allow for size suffixes in -L and --record-size options.
	* src/tar.c (TAR_SIZE_SUFFIXES): New define.
	(parse_opt): Allow for size suffixes in arguments to
	-L and --record-size options.
	* NEWS, doc/tar.texi: Update.

2010-07-15  Paul R. Eggert  <eggert@cs.ucla.edu>

	tar: don't crash if getcwd fails
	* src/extract.c: Don't include xgetcwd.h.
	(extract_dir): stat "." rather than statting getcwd's output.
	* src/misc.c (normalize_filename_x): Rewrite so as not to resolve
	/../, which can't be done reliably in the presence of symlinks.
	Don't reject valid names such as ".".
	(normalize_filename): Don't make it absolute; that way, we don't
	have to invoke xgetcwd which might fail.  Don't bother to realloc
	at the end, since that uses time and now saves little space.
	(chdir_do): Don't crash if xgetcwd fails.
	* tests/Makefile.am (TESTSUITE_AT): Add listed03.at.
	* tests/listed03.at: New file.
	* tests/testsuite.at: Include listed03.at.

2010-07-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Keep a detailed map of archive members stored in the record
	buffer.
	A separate map (bufmap) provides information for creating
	multi-volume continuation headers.

	* src/buffer.c (bufmap): New struct.
	(bufmap_head, bufmap_tail, inhibit_map): New variables.
	(mv_begin_write): New function.
	(mv_begin): Rename to mv_begin_read. Rewrite using mv_begin_write.
	All callers changed.
	(mv_total_size): Remove.
	(bufmap_locate, bufmap_free, bufmap_reset): New functions.
	(_flush_write): Update bufmap.
	(close_archive): Free bufmap.
	(add_chunk_header): Take a bufmap argument.
	(gnu_add_multi_volume_header): Likewise.
	(add_multi_volume_header): Likewise.
	(_gnu_flush_write): Rewrite using bufmap.
	(real_s_name, real_s_totsize)
	(real_s_sizeleft)
	(save_name, save_totsize, save_sizeleft): Removed. All
	uses updated.
	(mv_size_left): Update bufmap_head.
	(mv_end): Rewrite.
	(multi_volume_sync): Remove.

	* src/common.h (mv_begin_write): New prototype.
	(mv_begin): Rename to mv_begin_read.
	* src/create.c: Use mv_begin_write instead of mv_begin.
	Remove calls to mv_size_left and mv_end.
	* src/sparse.c: Likewise.

	* tests/multiv07.at: Close stdin.
	* tests/spmvp00.at: Update AT_KEYWORDS.
	* tests/spmvp10.at: Likewise.

	* tests/multiv08.at: New testcase.
	* tests/Makefile.am, tests/testsuite.at: Add multiv08.at.

	Version 1.23.90
	* NEWS, configure.ac: Version 1.23.90
	* doc/tar.texi: Document the use of lbzip2.

2010-06-28  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix exclusion of long file names when extracting from pax format
	archives.
	* src/list.c (read_and): Call decode_header before attempting
	name_match.
	(list_archive): Remove call to decode_header.

	* src/compare.c (diff_archive): Remove call to decode_header.
	* src/extract.c (extract_archive): Likewise.

	* test/exclude06.at: New test case.
	* tests/testsuite.at: Include exclude06.at.
	* tests/Makefile.am (TESTSUITE_AT): Add exclude06.at.

	Minor fix.
	* src/buffer.c (magic): Split the character constant to help
	cc recognize character boundaries (7 is a valid hex character).

2010-06-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fix.
	* src/buffer.c (magic): Fix xz magic.

2010-06-16  Paul Eggert  <eggert@cs.ucla.edu>

	Remove some lint, found by gcc -W etc.
	* src/common.h (label_notfound): New decl.
	* src/buffer.c (set_volume_start_time, compress_type):
	(guess_seekable_archive, open_compressed_archive, init_buffer):
	(_flush_write, archive_is-dev, increase_volume_number):
	(change_tape_menu, try_new_volume, add_chunk_header):
	(multi_volume_sync):
	Declare as 'static' if it's not exported.
	Use function prototype (void) rather than old-style ().
	* src/checkpoint.c (expand_checkpoint_string): Likewise.
	* src/incremen.c (dirlist_replace_prefix, makedumpdir,
	read_incr_db_2):
	Likewise.
	* src/list.c (print_volume_label): Likewise.
	* src/misc.c (normalize_filename_x): Likewise.
	* src/names.c (make_name, free_name, check_name_alloc,
	name_next_elt):
	Likewise.
	* src/tar.c (tar_list_quoting_style, add_exclude_array):
	(set_stat_signal): Likewise.
	* src/transform.c (new_transform,
	_single_transform_name_to_obstack):
	(_transform_name_to_obstack): Likewise.
	* src/unlink.c (dunlink_alloc): Likewise.

	* src/buffer.c (struct zip_magic): Use const when appropriate.
	* src/incremen.c (obstack_code_rename,
	write_directory_file_entry):
	Likewise.
	* src/sparse.c (COPY_STRING): Likewise.
	* src/system.c (dec_to_env, time_to_env, oct_to_env, str_to_env):
	(chr_to_env): Likewise.
	* src/tar.c (tar_list_quoting_style, set_stat_signal): Likewise.

	* src/extract.c (extract_node): Don't return garbage.

	* src/names.c: Remove old-style declarations of getgrnam etc.
	All modern systems declare these, and it's not worth the hassle
	of ignoring the warnings on modern systems for old-style decls.

2010-05-17  Sergey Poznyakoff  <gray@gnu.org.ua>

	Bugfix.
	* src/incremen.c (make_directory): Retain the slash if it is the
	only character in a filename.

2010-04-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	Recode NEWS back to UTF-8

2010-04-01  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix the gzip.at test case.
	* tests/gzip.at: Suppress gzip error output, as it can differ
	depending on its version etc. Bug reported by Ludovic Courtès.

2010-03-28  Sergey Poznyakoff  <gray@gnu.org.ua>

	New option --full-time.
	* src/common.h (full_time_option): New global.
	* src/tar.c (FULL_TIME_OPTION): New constant.
	(options): New option --full-time.
	(parse_opt): Handle the --full-time option.
	* src/list.c (simple_print_header): Pass full_time_option
	as the 2nd argument to tartime.
	* doc/tar.texi: Update.
	* NEWS: Update.

2010-03-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fixes in the testsuite.
	* tests/extrac07.at: Fix a typo (invalid number
	of arguments before format list).
	* tests/link02.at: Use `ln' instead of `link'.
	* tests/link03.at: Likewise.

	Fix coredump.
	* src/names.c (collect_and_sort_names): Remove
	entry from the table before freeing it.

	Fix dead loop on extracting existing symlinks with the -k option.
	* src/extract.c (create_placeholder_file)
	(extract_link, extract_symlink)
	(extract_node, extract_fifo): Handle all possible
	return values from maybe_recoverable. This complements
	8f390db92fc. Reported by Ico Doornekamp <bug-tar@zevv.nl>.
	* NEWS: Update.

2010-03-20  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix undesired error exit on receiving SIGPIPE.
	* src/tar.c: Do not ignore SIGPIPE.
	* tests/sigpipe.at: New testcase.
	* tests/Makefile.am, tests/testsuite.at: Add sigpipe.at
	* tests/remfiles01.at: Fix error code expectation.
	* NEWS: Update.

2010-03-17  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix --remove-files.
	Tar --remove-files relied on canonicalize_file_name,
	which replaces symlinks in file name components with
	the directories they point to. Due to this, tar
	effectively ignored existence of symbolic links and
	was unable to remove a directory that contained any
	(Alexander Kozlov <akozlov@nada.kth.se>, 2010-03-15).

	* gnulib.modules: Remove canonicalize.
	* src/misc.c (normalize_filename): Rewrite
	from scratch. The function operates only on
	its input string, it makes no attempt to test
	components for existence or to resolve symbolic
	links.
	* tests/Makefile.am (TESTSUITE_AT): Add remfiles03.at.
	* tests/testsuite.at: Likewise.
	* tests/remfiles03.at: New test case.
	* NEWS: Update.

2010-03-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	Bugfixes.
	* src/buffer.c (check_label_pattern): Initialize result.
	* tests/remfiles01.at: Skip if run with root privileges.

2010-03-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix `--test-label' and `--label -r' behavior.
	* doc/tar.texi (Including a Label in the Archive): Revise
	the section.
	* NEWS: Update

	* src/buffer.c (open_archive): Check volume label on
	ACCESS_UPDATE as well.
	* src/list.c (test_archive_label): Rewrite to match the
	documentation.
	* src/names.c (regex_usage_warning): Return int.
	(names_notfound): Rewrite the conditional.
	(label_notfound): New function.

	* tests/label03.at: New testcase.
	* tests/label04.at: New testcase.
	* tests/label05.at: New testcase.
	* tests/Makefile.am: Add new testcases.
	* tests/testsuite.at: Likewise.

	Doc fixes.
	* doc/tar.texi: Consistently use lowercase `see' within sentences.
	More fixes spotted by Denis Excoffier.
	* THANKS: Update.

	Shut up a gcc warning message.
	* src/tar.c (tar_help_filter): Use a separate const
	variable to hold returns from gettext. Reported by
	Peter Breitenlohner.

	Bugfix.
	* src/names.c (collect_and_sort_names): Initialize prev_name.
	Reported by Dmitry V. Levin.

2010-03-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Version 1.23
	* configure.ac, NEWS: Update version number.

	Doc changes.
	* NEWS: Update.
	* THANKS: Update.
	* doc/snapshot.texi, doc/snapshot.texi,
	doc/sparse.texi, doc/tar-snapshot-edit.texi,
	doc/tar.texi: Spellchecked and proof-read. Thanks
	to Denis Excoffier.
	* gnulib.modules: Remove utime.

2010-03-08  Kamil Dudka  <kdudka@redhat.com>

	Fix possible overflow in code_timespec (tiny change)
	* src/misc.c (code_timespec): ignore invalid values of ns

2010-03-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fix in the testsuite.
	* tests/extrac05.at: Skip test if creating
	sparse file fails.

	Fix eventual memory override and fd exhaustion in create.c Both
	bugs reported by Kamil Dudka.
	* src/create.c (check_exclusion_tags): Do not keep
	pointer to a location within tagname: it may change
	after xrealloc. Use byte offset instead.
	(dump_file0): Close fd before returning without
	dumping the directory.

2010-03-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor change.
	* doc/tar.texi: Improve some wording.

2010-03-02  Antonio Diaz Diaz  <ant_diaz@teleline.es>

	Add Lzip support
	* configure.ac: Add TAR_COMPR_PROGRAM(lzip)
	* doc/tar.texi: Reflect lzip support.
	* src/buffer.c (compress_type) <ct_lzip>: New constant.
	(magic): Add magic for lzip.
	* src/suffix.c (compression_suffixes): Add lz.
	* src/tar.c: New option --lzip.

2010-03-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fix.
	* tests/exclude05.at: Rewrite awk invocation to avoid
	overflowing awk's file table on Solaris.

2010-03-02  Eric Blake	<ebb9@byu.net>

	Fix large file support.
	* scripts/xsparse.c (read_map): Use fseeko.
	* src/incremen.c (write_directory_file): Likewise.

2010-03-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	Bugfix
	* src/buffer.c (seek_archive): Rewrite size computation
	to prevent it from reaching negative values. Based on
	report by Denis Excoffier <Denis.Excoffier@free.fr>.

2010-02-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	Supply more information to the --to-command script.
	* src/system.c (stat_to_env): Pass information about the current
	volume in variables TAR_ARCHIVE, TAR_VOLUME, TAR_BLOCKING_FACTOR,
	TAR_FORMAT.
	* doc/tar.texi: Document new environment variables.
	* NEWS: Likewise.
	* configure.ac: Version number 1.22.91.

2010-02-17  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor change.
	* src/names.c (regex_usage_warning): Fix warning message.

2010-02-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	Update THANKS

2010-02-05  Ondřej Vašík  <ovasik@redhat.com>

	Bugfix (tiny change)
	* src/xheader.c (xheader_read): Remove unnecessary call
	to xheader_init.

2010-01-26  Sergey Poznyakoff  <gray@gnu.org.ua>

	Enable silent build mode.
	* configure.ac: Require automake 1.11, autoconf 2.63. Enable
	silent rules.
	* NEWS: Update.
	* lib/Makefile.am (rmt-command.h): Silent the rule.

2010-01-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	Read POSIX multivolume archives split at the header boundary.
	* src/common.h (read_header_mode): New enum.
	(read_header): Change type of the 3rd argument.
	* src/list.c (read_header): Change type of the 3rd argument.
	All callers updated.
	* src/buffer.c (try_new_volume): Allow for volumes split at the
	extended/ustar header boundary. This is against POSIX specs, but
	we must be able to read such archives anyway.

	* tests/multiv07.at: New test case.
	* tests/Makefile.am: Add multiv07.at
	* tests/testsuite.at: Likewise.

	* src/compare.c: Update calls to read_header.
	* src/delete.c: Likewise.
	* src/update.c: Likewise.

2010-01-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor change.
	* NEWS: Update.
	* doc/tar.texi: Update.
	* src/create.c (finish_header): Minor change.

2010-01-24  Rob Vermaas  <rob.vermaas@gmail.com>

	Bugfix (tiny change).
	* src/tar.c (format_default_settings)[REMOTE_SHELL]: Fix
	misplaced comma.

2010-01-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fix.
	* src/incremen.c (read_incr_db_01)
	(read_directory_file): Initialize bufsize to 0.
	Suggested by noordsij@cs.helsinki.fi.

	Improve handling of --test-label.
	* src/list.c (print_volume_label): New function.
	(print_header): Call print_volume_label.
	(test_archive_label): New function.
	* src/buffer.c (VOLUME_LABEL_APPEND): Remove.
	(VOLUME_TEXT, VOLUME_TEXT_LEN): New macros
	(drop_volume_label_suffix): New function.
	(check_label_pattern): Use drop_volume_label_suffix.
	* src/common.h (subcommand): New constant TEST_LABEL_SUBCOMMAND.
	(test_label_option): Remove.
	(drop_volume_label_suffix): New proto.
	(test_archive_label): New proto.
	* src/names.c (all_names_found): Remove test for
	test_label_option.
	* src/tar.c (subcommand_string): Handle TEST_LABEL_SUBCOMMAND.
	(set_subcommand_option): Improve diagnostics.
	(parse_opt): Set subcommand if --test-label is given.
	(main): Handle TEST_LABEL_SUBCOMMAND.

	Fix listing of volume labels (in particular in PAX archives).
	* src/buffer.c (match_volume_label): Call set_volume_label.
	(check_label_pattern): Get label string
	as argument.
	(match_volume_label): Handle volume labels stored in
	global PAX headers.
	* src/common.c (print_header,read_header): Change signature.
	(read_header_primitive): Remove prototype.
	* src/list.c (recent_global_header): New static.
	(list_archive): Always print volume labels.
	(read_header_primitive): Remove.
	(read_header): Change the signature (all callers updated)
	Save the recent global header.
	(volume_label_printed): New static.
	(simple_print_header): New function (ex-print_header).
	(print_header): Change the signature (all callers updated).
	For POSIX formats, print first volume header (if set).
	* src/xheader.c (xheader_write_global): Write the data
	accumulated in xhdr->stk even if keyword_global_override_list
	is empty.
	(xheader_read): On unexpected EOF, report error instead of
	coredumping.
	(XHDR_PROTECTED, XHDR_GLOBAL): New defines.
	(struct xhdr_tab): Remove `protected' with `flags'. All uses
	updated.
	(decg): If XHDR_GLOBAL bit is set, call the keyword's decode
	method instead of adding it to `kwl'.

	* src/compare.c: Update calls to read_header.
	* src/create.c: Likewise.
	* src/delete.c: Likewise.
	* src/update.c: Likewise.
	* src/extract.c: Likewise.
	(extract_volhdr): Do not print "Reading <label>" statement,
	because
	it is inconsistent: it is not printed if the volume begins with a
	member continued from the previous volume.

	* tests/label01.at: New testcase.
	* tests/label02.at: New testcase.
	* tests/Makefile.am, tests/testsuite.at: Add new testcases.

2010-01-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix prefix length calculation in ustar mode.
	* src/create.c (split_long_name): Fix prefix length
	calculation.
	(write_ustar_long_name): Improve ustar mode compatibility
	with the Sun version.

2009-10-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	Rewrite update algorithm.
	* src/common.h (namebuf_t): New typedef.
	(namebuf_create, namebuf_free)
	(namebuf_name): New prototypes.
	(remname): New prototype.
	* src/misc.c (struct namebuf): New structure.
	(namebuf_create, namebuf_free)
	(namebuf_name): New functions.
	* src/create.c (dup_dir0): Remove is_avoided_name
	checks. This is taken care of in update_archive.
	* src/incremen.c (scan_directory): Use namebuf
	to produce full file names.
	* src/names.c (nametail): Remove extra level of
	indirection. All uses updated.
	(avoided_name_table, add_avoided_name)
	(is_avoided_name): Remove.
	* src/update.c (update_archive): Change algorithm.
	Instead of adding unmodified files to the avoided_name
	table, create namelist so that it contains only
	modified files.

	* tests/Makefile.am: Add update01.at, update02.at
	* tests/testsuite.at: Likewise.
	* tests/update.at (AT_KEYWORDS): Add update00.

	Minor changes.
	* src/tar.c (main): Ignore SIGPIPE.
	* src/system.c (sys_child_open_for_compress)
	(sys_child_open_for_uncompress): Reset SIGPIPE
	in child to default.
	* tests/remfiles01.at: Avoid race conditions.
	* tests/remfiles02.at: Likewise.

	Bugfix.
	* src/buffer.c (_open_archive): Call guess_seekable_archive
	only if the call to open_compressed_archive succeeded.

2009-10-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Improve previous changes.
	* acinclude.m4: Fix typos.
	* gnulib.modules: Add xvasprintf.
	* src/common.h: Include xvasprintf.h.
	* src/tar.c (options): Remove docstrings for --gzip, --bzip2,
	--compress, --lzop, --lzma and --xz.
	(tar_help_filter): Generate these using actual values of
	*_PROGRAM constants.
	(format_default_settings): Use xasprintf.
	(parse_opt): Use *_PROGRAM defines instead of hardcoded
	program names.

	Allow installers to specify alternative program names for
	compression programs.
	This adds --with-gzip, --with-bzip2 etc. switches to the
	configure, so that
	one can do, e.g. ./configure --with-bzip2=lbzip2 and have
	lbzip2 executed
	whenever user calls `tar --bzip2'.

	* acinclude.m4: New file.
	* configure.ac: Add TAR_COMPR_PROGRAM invocations for
	the supported compressors.
	* src/buffer.c (magic): Use *_COMPRESSOR defines instead
	of hardcoded program names.
	* src/suffix.c (compression_suffixes): Likewise.

2009-10-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fix.
	* src/buffer.c (magic): Fix `xz' entry: add the name of the
	program.
	* src/suffix.c (compression_suffixes, nsuffixes): Mark as static.

2009-10-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	Provide a way to explicitly set mtime for extended header
	ustar blocks.
	* src/tar.c (struct textual_date): ts is a copy of the structure,
	not a pointer to it. Date is a copy as well, hence the `const' is
	taken away.
	(get_date_or_file): Return 0/1 depending on success/failure.
	Copy timestamp to the `ts' member. Store a copy of the string
	in `date'.
	(report_textual_dates): Report only if verbose_option is set,
	but always free the list.
	(expand_pax_option): New function.
	(parse_opt): Preprocess the argument to xheader_set_option with
	expand_pax_option.
	(decode_options): Call report_textual_dates unconditionally.
	* src/xheader.c (exthdr_mtime_option, exthdr_mtime)
	(globexthdr_mtime_option, globexthdr_mtime): New statics.
	(xheader_set_keyword_equal): handle exthdr.mtime and
	globexthdr.mtime.
	(xheader_write): Override `t' argument if a corresponding
	exthdr.mtime or globexthdr.mtime option is set.
	* NEWS: Update
	* doc/tar.texi: Document the changes.

	Use file's mtime as mtime for its extended header.
	This makes two pax archives binary equivalent if they
	have the same contents and care is taken to make extended
	headers otherwise reproducible, e.g. by using:

	  --pax-option=exthdr.name=%d/PaxHeaders/%f,atime:=0

	Proposed by Michael D. Adams <mdmkolbe@gmail.com>.

	* src/common.h (start_private_header): Take time_t as 3rd param.
	(xheader_write): Likewise.
	* src/create.c (start_private_header): Take time_t as 3rd param.
	All callers updated.
	(write_extended): Use file's mtime as mtime for its extended
	header,
	Use current time stamp as mtime for global headers.
	(xheader_write): Take time_t as 3rd param.

	Fix bugs in handling the --remove-files option.
	Make sure the files are deleted only if they were succesfully
	stored
	to the archive.

	* src/exit.c: New file.
	* src/unlink.c: New file.
	* src/Makefile.am (tar_SOURCES): Add exit.c and unlink.c.
	* src/common.h: Include progname.h
	(program_name): Remove global.
	(records_written): New extern.
	(queue_deferred_unlink, finish_deferred_unlinks): New prototypes.
	(fatal_exit_hook): New extern.
	* src/create.c (create_archive): Call finish_deferred_unlinks.
	(dump_hard_link, dump_file0): Don't actually unlink the file,
	queue it to deferred_unlinks instead.
	* src/delete.c (records_written): Remove extern: declared in
	common.h.
	* src/extract.c (extract_archive): Set fatal_exit_hook.
	(fatal_exit, xalloc_die): Move to exit.c
	* src/system.c (sys_wait_for_child): Exit immediately
	if the child dies or exits with a non-zero status.
	(sys_child_open_for_compress)
	(sys_child_open_for_uncompress): Use set_program_name,
	instead of setting program_name directly.
	* src/tar.c (main): Use set_program_name,
	instead of setting program_name directly.

	* tests/Makefile.am (TESTSUITE_AT): Add remfiles01.at
	and remfiles02.at.
	* tests/testsuite.at: Likewise.
	* tests/gzip.at: Reflect the above changes.

2009-10-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix bug in OLDGNU format creation.
	See tests/append02.at for a detailed description

	* src/common.h (MODE_FROM_HEADER): Take additional argument.
	(mode_from_header): Likewise.
	* src/create.c (mode_to_chars): Store all mode bits if
	using OLDGNU_FORMAT. This reverses f4e4adea80a.
	* src/list.c (decode_header): Use header mode field
	to discern between GNU and OLDGNU formats.
	(mode_from_header): Store unrecognized mode bits (from 10th up)
	in the location pointed to by the third parameter.
	* tests/append02.at: Update documentation and references.

2009-09-16  Sergey Poznyakoff  <gray@gnu.org.ua>

	Restore extra help output.
	* src/tar.c (tar_list_quoting_styles): Change first argument to
	struct obstack.
	(format_default_settings): New function.
	(show_default_settings)
	(show_default_settings_fs): Removed.
	(tar_help): Removed.
	(tar_help_filter): New function.
	(argp): Set help_filter.
	(parse_opt): Fix error message.

2009-09-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	Improve command line option handling.
	* gnulib.modules: Add argp-version-etc and progname,
	use getopt-gnu instead of getopt.
	* src/tar.c (HANG_OPTION, USAGE_OPTION)
	(VERSION_OPTION): Remove.
	(options): Remove corresponding options. Let argp
	handle them.
	(parse_opt): Likewise.
	(_argp_hang): Removed.
	(tar_authors): New variable.
	(decode_options): Call argp_version_setup.
	Do not use ARGP_NO_HELP flag in the call to argp_parse.

	Avoid overwriting exit_status with a value indicating less
	important condition.
	* src/tar.c (set_exit_status): New function.
	* src/common.h (set_exit_status): New prototype.
	* src/compare.c: Use set_exit_status instead of
	exit_status assignments.
	* src/create.c: Likewise.
	* src/misc.c: Likewise.

	* src/system.c (wait_for_grandchild): Use auto variable
	instead of the global exit_status.
	* src/incremen.c (scan_directory): Use file_removed_diag
	instead of stat_diag.

	Automatic detection of seekable archives.
	* src/buffer.c (guess_seekable_archive): New function.
	(_open_archive): Call guess_seekable_archive for archives
	open for reading.
	(new_volume): Likewise.
	* src/common.h (seek_option): New global.
	* src/tar.c (options): New option --no-seek.
	(parse_opt): --seek and --no-seek set seek_option,
	not seekable_archive.
	(decode_options): Initialize seek_option to -1.

	* NEWS: Update.
	* doc/tar.texi: Update.

2009-08-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix testcases.
	* tests/extrac08.at: Ensure a predictable umask value.
	* tests/xform-h.at (xform): do not depend on file name
	ordering.

2009-08-13  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix interaction between --listed-incremental and -C
	* src/incremen.c (read_directory_file): Execute eventual -C dir
	after opening the snapshot file.
	(collect_and_sort_names): Remove call to chdir_do
	* tests/incr05.at, tests/incr06.at: Use relative file names for
	snapshot files.

2009-08-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	Update for new exclude module from gnulib. Add testcases by
	Phil Proudman.
	* src/names.c (is_pattern): Remove.
	(regex_usage_warning): Use fnmatch_pattern_has_wildcards
	instead of
	is_pattern.
	* src/tar.c: New option --exclude-backups.
	(vcs_file_table, backup_file_table): New globals.
	(add_exclude_array): New function.
	* tests/exclude01.at, tests/exclude02.at,
	tests/exclude03.at, tests/exclude04.at,
	tests/exclude05.at: New testcases. Supplied by Phil Proudman.
	* tests/Makefile.am (TESTSUITE_AT): Add new tests.
	* tests/testsuite.at: Add new tests.
	* THANKS: Update.

2009-08-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Remove src/version.c (reappeared after migration to Git)

2009-08-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fixes.
	* src/misc.c (file_removed_diag): Set exit code to
	TAREXIT_DIFFERS.

2009-08-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fixes

	Fix handling of files removed during incremental dumps.
	Changes to src/create.c and src/incremen.c are partially
	based on patch from Alexander Peslyak <solar at openwall.com>.

	The new testcases require paxutils commit f653a2b or later.

	* src/common.h (struct name): New member `cmdline'.
	(dump_file): Change type of the 2nd argument to bool.
	(file_removed_diag, dir_removed_diag): New prototypes.
	(addname): New argument `cmdline'.
	(name_from_list): Change return value.
	* src/create.c (dump_dir0, dump_dir): top_level is bool.
	(create_archive): Update calls to name_from_list.
	Take advantage of the name->cmdline to set top_level argument
	during incremental backups.
	(dump_file0): top_level is bool.
	Do not bail out if a no-top-level file disappears during
	incremental
	backup, use file_removed_diag instead.
	(dump_filed): top_level is bool.
	* src/incremen.c (update_parent_directory): Silently ignore
	ENOENT.  It should have already been reported elsewhere.
	(scan_directory): Use dir_removed_diag to report missing
	directories.
	* src/misc.c (file_removed_diag, dir_removed_diag): New functions.
	* src/names.c (name_gather): Set ->cmdname.
	(addname): Likewise. All uses updated.
	(name_from_list): Return struct name const *. All uses updated.

	* tests/filerem01.at: New testcase.
	* tests/filerem02.at: New testcase.
	* tests/Makefile.am, tests/testsuite.at: Add filerem01.at,
	filerem02.at
	* tests/grow.at, test/truncate.at: Use new syntax for genfile
	--run.

	* NEWS: Update.
	* doc/tar.texi: Minor fix.

	Optimize searches for directory structures by keeping a pointer
	to struct directory in struct name.
	* src/common.h (struct name): New member `directory' replaces
	dir_contents. Rearrange members.
	(rebase_directory): Change signature.
	(scan_directory): Change signature.
	(name_fill_directory)
	(directory_contents, safe_directory_contents): New prototypes.
	(append_incremental_renames): Change signature.
	(replace_prefix): New proto.
	* src/compare.c (diff_dumpdir): Use directory_contents +
	scan_directory.
	* src/create.c
	* src/incremen.c (replace_prefix): Move to misc.c
	(rebase_directory): Rewrite.
	(scan_directory): Return pointer to struct directory.
	(directory_contents, safe_directory_contents): New functions.
	(get_directory_contents): Remove.
	(name_fill_directory): New function.
	(append_incremental_renames): Rewrite. This also fixes a memory
	leak.
	* src/names.c (name_gather, addname): Reflect changes in struct
	name.
	(add_hierarchy_to_namelist): Rewrite using name_fill_directory and
	directory_contents.
	(rebase_child_list): Update call to rebase_directory.
	(collect_and_sort_names): Optimize

	* src/misc.c (replace_prefix): New function.
	* src/names.c (add_hierarchy_to_namelist): Use new
	get_directory_contents.

	* tests/incr05.at: New test case.
	* tests/incr06.at: New test case.
	* tests/Makefile.am, test/testsuite.at: Add incr05.at and
	incr06.at.

	* doc/Makefile.am (check-options): Improve rule.
	* doc/tar.texi, NEWS: Update.

2009-08-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fixes.
	* src/common.h (rebase_directory): New prototype.
	* src/incremen.c (rebase_directory): Use replace_prefix.
	* src/names.c (collect_and_sort_names): Abort if
	hash_insert fails.

	Improve listed incremental dumps.
	The modified algorithm tries to avoid dumping the same
	directory twice and ensures the order of the directories
	in the resulting archive is the same, whatever their order
	on the command line.  It also fixes the operation of
	--listed-incremental -C.

	* gnulib.modules: Add canonicalize
	* src/common.h (incremental_level): New global.
	(check_exclusion_tags): first argument is const.
	(get_directory_contents): Add third argument.
	(zap_slashes, normalize_filename): New prototypes.
	(chdir_count): New prototype.
	(WARN_VERBOSE_WARNINGS): New define.
	(WARN_ALL): Exclude WARN_VERBOSE_WARNINGS.
	* src/compare.c (diff_dumpdir): Update the call to
	get_directory_contents.
	* src/create.c (check_exclusion_tags): First argument is const.
	Use ISSLASH and DIRECTORY_SEPARATOR instead of referring to '/'.

	* src/incremen.c (struct directory): New member `caname'.
	(hash_directory_name): Rename to
	hash_directory_canonical_name. Operate
	on the canonical name.
	(compare_directory_names): Rename to
	compare_directory_canonical_names.
	Operate on the canonical name.
	(make_directory): Take two arguments.
	(free_directory): Free caname.
	(attach_directory): Create caname.
	(find_directory): Use caname for lookups.
	(PD_VERBOSE): Remove.
	(PD_FORCE_INIT): New define.
	(procdir): First argument is const.
	Reinitialize directory if PD_FORCE_INIT bit is set.
	Do not use PD_VERBOSE or verbose_option for issuing warnings.
	Rely on WARNOPT instead.
	Always set *entry.
	(scan_directory): Take three arguments. The third one is a boolean
	which is true if the directory is explicitly mentioned on
	the command
	line.
	(get_directory_contents): Remove.  Use scan_directory instead.
	All callers updated.
	(read_directory_file): Truncate the file if --level=0 is given.
	* src/misc.c: Include canonicalize.h
	(zap_slashes, normalize_filename): New functions.
	(chdir_count): New function.
	* src/names.c (add_hierarchy_to_namelist): Take three arguments,
	as
	get_directory_contents and scan_directory.
	(collect_and_sort_names): Allow at most one -C, before file name
	arguments.
	Read directory file after eventual changing to another directory.
	Avoid adding the same directory under different pathnames to
	the list.
	* src/tar.c: New option --level.

	* tests/incr03.at, tests/incr04.at, tests/listed01.at,
	tests/listed02.at, tests/rename01.at, tests/rename02.at,
	tests/rename03.at: Update for new tar behavior.
	* tests/multiv01.at: Do not use --listed-incremental.

2009-08-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	Forgotten to push src/warning.c

	Implement the --warning option.
	* src/warning.c: New file.
	* src/Makefile.am: Add warning.c
	* src/common.h: Provide definitions for warning classes.
	(warning_option): New global.
	(WARNOPT): New define.
	(set_warning_option): New prototype.
	* src/tar.c: New option `--warning'.
	* src/compare.c: When applicable WARNOPT instead of WARN.
	* src/create.c: Likewise.
	* src/extract.c: Likewise.
	* src/incremen.c: Likewise.
	* src/list.c: Likewise.

	* NEWS, doc/tar.texi: Update.

2009-08-05  Carl Worth	<cworth@cworth.org>

	Fix descriptions of some options (tiny change)

2009-08-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix backup handling and restoring file modes of existing
	directories
	* NEWS, THANKS: Update
	* src/extract.c (extract_dir): reset status to 0 if the
	directory already exists.
	* src/misc.c (maybe_backup_file): Assign before_backup_name
	and clear after_backup_name before checking if we really need
	to backup the file.
	* tests/backup01.at: New testcase.
	* tests/extrac08.at: New testcase.
	* tests/Makefile.am, tests/testsuite.at: Add extrac08.at and
	backup01.at

2009-07-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix hard links recognition with -c --remove-files
	* src/create.c (dump_hard_link): Always look up in the link table
	if remove_files_option is set. Patch suggested by Theodore Ts'o
	<tytso@mit.edu>.
	(check_links): Remove extra newline from the warning message.
	* tests/link02.at, tests/link03.at: New testcases.
	* tests/Makefile.am (TESTSUITE_AT): Add link02.at and link03.at
	* tests/testsuite.at: Include link02.at and link03.at

	Fix handling of hard link targets by -c --transform
	* src/create.c (file_count_links): Transform link target
	before the look up.
	* tests/xform-h.at: New test case.
	* tests/Makefile.am (TESTSUITE_AT): Add xform-h.at.
	* tests/testsuite.at: Add xform-h.at

2009-06-23  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fix.
	* src/extract.c (file_newer_p): Do not report error on ENOENT

2009-06-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	Remove rebox.el (reappeared after migration to Git)

2009-06-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	Remove files that were removed in CVS, but reappeared after
	migration to Git

2009-06-18  David Bartley  <dtbartle@csclub.uwaterloo.ca>

	Fix Solaris bug where chmod fails if we don't have
	PRIV_SYS_LINKDIR
	* gnulib.modules: Add priv-set.
	* src/extract.c (set_mode, extract_archive): Restore
	PRIV_SYS_LINKDIR on chmod failure.
	* src/tar.c (main): Drop PRIV_SYS_LINKDIR on startup.

2009-06-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	Ensure default behavior for SIGPIPE
	* src/tar.c (main): Install default handler for SIGPIPE.
	Proposed by Bastian Blank.

2009-06-18  Eric Blake	<ebb9@byu.net>

	Follow autoconf recommendation for TESTSUITEFLAGS.
	* tests/Makefile.am (check-local, installcheck-local): Honor
	TESTSUITEFLAGS.

2009-06-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix handling of sub-subprocess returns.
	* src/system.c (wait_for_grandchild): New function.
	(sys_child_open_for_compress)
	(sys_child_open_for_uncompress): Use wait_for_grandchild
	to manage grandchild return.

2009-05-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	Report record size only if the archive refers to a device.
	* Makefile.am (INCLUDES): Add ../lib, for rmt-command.h
	* src/buffer.c (short_read): Report the actual record size
	only if the archive descriptor refers to a device.
	* tests/pipe.at, tests/shortrec.at,
	tests/sparsemvp.at: Reflect the above change.
	* NEWS, configure.ac: Version 1.22.90

2009-05-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	Do not issue errors on existing files when given the -k option
	* Makefile.am (dist-hook): Fix rule.
	* src/extract.c (maybe_recoverable): Return three-state value.
	(extract_dir): Skip extraction if maybe_recoverable indicates so.
	(extract_file): Likewise.

2009-05-12  Eric Blake	<ebb9@byu.net>

	Avoid undefined behavior
	* src/xheader.c (xheader_set_keyword_equal): Pass correct type to
	ctype macros.
	* src/transform.c (run_case_conv): Likewise.

2009-05-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	Remove src/Makefile.in

2009-03-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	Bugfixes.
	* bootstrap (symlink_to_dir): Fix symlink calculation.
	* doc/tar.texi: Minor fixes by Victor Villa and Stepan Kasal.

2009-03-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	Remove Makefile.in

	Migrate to Git

2009-03-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c: --no-recursive works with --incremental.

2009-03-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	Add xz support.

	* src/buffer.c, src/suffix.c: Add support for xz compression.
	* src/tar.c: New option --xz, for compression/decompression using xz.
	Re-assign -J as a short equivalent of --xz.

2009-01-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Fix typo.

2008-12-29  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap.conf: Include size_max.
	* gnulib.modules: Remove memset, rmdir. Replace strdup with
	strdup-posix. Patch by Eric Blake.
	* src/tar.c: Implement -I as a shorthand for --use-compress-program.
	* doc/tar.texi: Document -I.
	* tests/pipe.at, tests/shortrec.at: Account for eventual 'Record
	size' output.
	* tests/testsuite.at (AT_TAR_CHECK_HOOK): New define
	(AT_TAR_WITH_HOOK, TAR_IGNREC_HOOK): New macros.

2008-11-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/xheader.c: Remove duplicate inclusion of fnmatch.h. Reported
	by Jim Meyering.

2008-11-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	Do not try to drain the input pipe before closing the
	archive.

	* src/buffer.c (close_archive): Remove call to
	sys_drain_input_pipe. Pass hit_eof as the second
	argument to sys_wait_for_child.
	* src/common.h (sys_drain_input_pipe): Remove
	(sys_wait_for_child): Declare second argument.
	* src/system.c (sys_drain_input_pipe): Remove.
	(sys_wait_for_child): Take two arguments. The second one helps to
	decide whether to tolerate child termination on SIGPIPE.

2008-11-03  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/buffer.c (_write_volume_label): Fix typo, which prevented
	`-V label -M' from working.

2008-10-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS, configure.ac: Version 1.20.91
	* doc/tar.texi: Document transformation scope flags.
	* src/common.h (transform_symlinks_option): Remove in favor of
	transformation scope flags.
	(XFORM_REGFILE, XFORM_LINK, XFORM_SYMLINK, XFORM_ALL): New macros.
	(transform_name, transform_member_name, transform_name_fp): Take
	an additional argument, specifying scope flags.
	* src/create.c: Reflect changes to transform_name.
	* src/extract.c (extract_link, extract_symlink): Remove calls to
	transform_member_name. It is done in read_header.
	* src/list.c (decode_xform): Reflect change in data type of 2nd
	argument.
	(transform_member_name): 2nd arg is int.
	(decode_header): Transform file name and link target names.
	* src/tar.c: Remove --transform-symlinks.
	* src/transform.c (struct transform): New member `flags'.
	(transform_flags): New variable.
	(parse_transform_expr): Parse transformation scope flags. Allow to
	set global flags using `flags=' syntax.
	(_transform_name_to_obstack, transform_name_fp)
	(transform_name): Take an additional argument, specifying scope
	flags.

2008-10-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	* THANKS: Add Ed Leaver.
	* src/buffer.c (short_read): Remove !read_full_records condition,
	which was always false on a first record and thus disabled record
	size autodetection.  Thanks Ed Leaver for the patch.
	(_gnu_flush_read): Handle blocking_factor == 1.
	* tests/sparsemv.at: Reflect changes to buffer.c.
	* tests/sparsemvp.at: Likewise.
	* tests/volsize.at: Likewise.
	* NEWS: Update.

2008-10-16  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/common.h (transform_symlinks_option): New global.
	* src/create.c (dump_file0): Transform symlink targets only if
	explicitly required.  Thanks Cyril Strejc for reporting the
	problem.
	* src/tar.c (parse_opt): New options --transform-symlinks and
	--no-transform-symlinks. New alias --xform to the --transform
	option.
	* doc/tar.texi: Document --transform-symlinks
	* NEWS: Update.
	* THANKS: Update.

	* src/names.c (name_gather): Use xzalloc.
	* src/buffer.c (short_read): Move record size detection before
	the loop.

2008-10-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (options): Add --lzop option.

2008-10-05  Xavier Hienne <xavier.hienne@free.fr> (tiny change)

	* src/checkpoint.c (checkpoint_compile_action): Add missing
	`else'.

2008-09-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update.
	* doc/tar.texi: Update.
	* src/tar.c: New option --no-null.

2008-09-23  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/common.h (filename_terminator): Remove global.
	* src/tar.c (filename_terminator): New static.
	* src/names.c (name_next_elt): Do not depend on
	filename_terminator, this was a leftover from 1.13.

2008-09-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Remove incorrect example.

2008-09-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c (dumpdir_create0): Eliminate gcc warning.
	(attach_directory): Bugfix - add missing return statement.
	* THANKS: Add Enric Hernandez

2008-07-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c (struct directory): New member `next'.  Change
	type of `name'.
	(dirhead, dirtail): New statics.
	(make_directory): Reflect changes to struct directory.
	(free_directory, attach_directory): New functions.
	(dirlist_replace_prefix): New function.
	(note_directory): Use attach_directory, instead of make_directory,
	(find_directory, find_directory_meta): Use free_directory.
	(procdir): Replace directory prefixes in directory list to avoid
	marking subdirectories as renamed after renaming their parent
	directory.
	(append_incremental_renames): Iterate over directory list, not
	hash table, to preserve logical ordering of renames.
	* tests/rename04.at, tests/rename05.at: New test cases.
	* tests/Makefile.am, tests/testsuite.at: Add rename04.at and
	rename05.at.
	* tests/atlocal.in (decho): New function.
	* tests/multiv06.at: Use decho instead of echo2.
	* tests/incremental.at: Raise wait interval to 2 seconds.

2008-07-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (decode_options): Do not allow volume length less
	than record size.
	* src/buffer.c (_gnu_flush_write): Compensate for the effect
	of eventual flush_archive occurring in the middle of buffer
	move.
	Increment records_written only if _flush_write was able to write
	something.
	* tests/multiv06.at: New testcase.
	* tests/Makefile.am, test/testsuite.at: Add tests/multiv06.at

2008-06-26  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac, NEWS: Version 1.20.90
	* doc/tar.texi: Document -J, --no-auto-compress, etc.
	* src/buffer.c (ct_tar): New constant.
	(magic): Add lzop support.  Proposed by Kevin Day
	<thekevinday@gmail.com>.
	(check_compressed_archive): Do not use autodetect if the
	compression program was specified explicitly.
	Fall back to analyzing archive name, if the autodetection fails.
	* src/suffix.c: Add .lzo
	* src/tar.c: New options --lzop and --no-auto-compress.
	New short option -J (alias for --lzma).

	* src/buffer.c (try_new_volume): Print more information with error
	diagnostics.
	(_gnu_flush_write): Improve error checking.  Adjust
	real_s_sizeleft before calling new_volume to avoid creating
	malformed multivolume headers.
	* tests/delete05.at, tests/gzip.at, tests/ignfail.at,
	tests/longv7.at, tests/lustar01.at, tests/lustar02.at,
	tests/shortfile.at: Update to match new diagnostic wording
	(see 2008-05-06).

	* NEWS: Update.

2008-06-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi (exclude): Document support for new VCS.
	* THANKS: Update.
	* NEWS: Update.
	* tests/multiv05.at: Fix typos.
	* tests/volsize.at: Remove a TZ dependency.

2008-06-14  Dan Drake <dan@dandrake.org> (tiny change)

	* src/tar.c (exclude_vcs_files): Support for Bazaar, Mercurial and
	Darcs.

2008-05-06  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (main): Reword the "delayed error" message. New
	wording proposed by Karl Berry.

2008-02-20  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac: Raise version number to 1.20
	* src/compare.c (diff_dumpdir): const.
	* src/common.h (dumpdir_t,dumpdir_iter_t): New data types.
	(dumpdir_create0,dumpdir_create,dumpdir_free,dumpdir_locate)
	(dumpdir_first,dumpdir_next): New functions.
	* src/incremen.c (dumpdir_create0,dumpdir_create,dumpdir_free)
	(dumpdir_first,dumpdir_next): New functions.
	(dumpdir_locate): Rewrite using binary search.
	(struct directory): Change members char *contents, *icontents to
	struct dumpdir *dump, *idump. All references updated.
	(note_directory): Last arg is const.
	* src/names.c (add_hierarchy_to_namelist): buffer is const.
	* tests/incr03.at, tests/incr04.at, tests/rename02.at,
	tests/rename03.at: Insert calls to sleep between creation of files
	and adding them to the archive.

2008-03-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/create.c (dump_file0): Count links only for actually dumped
	files.

2008-03-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Document --no-check-device and --check-device.
	* doc/rendition.texi: Change the way FIXME-*refs are handled in
	!PROOF.
	* doc/intern.texi, doc/tar.texi: Update.
	* doc/untabify.el: New file.
	* doc/Makefile.am (EXTRA_DIST): Add untabify.el
	(untabify, final, check-format, check-refs, check-fixmes)
	(check-unrevised, all-check-docs, check-docs): New rules.

	* src/common.h (check_device_option): New global.
	* src/incremen.c (procdir): Use boolean and instead of bitwise
	one. Patch by Jean-Louis Martineau.
	Compare device numbers only if check_device_option is set.
	* src/tar.c: New command line options --no-check-device and
	--check-device. Proposed by Jean-Louis Martineau.
	(parse_opt): Hanlde new options.
	(decode_options): Initialize check_device_option to true.

	* THANKS: Update

2008-03-06  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Use rsync to get translations.
	* doc/tar.texi: Minor change.
	* lib/.cvsignore: Update
	* po/.cvsignore: Update
	* src/system.c: Remove include setenv.h.
	* tests/atlocal.in (STAR_DATA_URL): Update.
	* tests/star/README: Update URL.

2008-02-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Fix a typo. Reported by Denis Excoffier.

2008-02-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update.
	* configure.ac: Version 1.19.90
	* po/POTFILES.in: Add missing files.
	* src/compare.c (verify_volume): Honor --ignore-zeros.
	Proposed by Jan-Benedict Glaw.
	* tests/shortfile.at (AT_KEYWORDS): Add shortfile0.

2008-02-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update.
	* src/create.c (dump_file0): Apply transform_name to symlink
	targets.

2008-02-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/transform.c: Support multiple --transform options. Support
	semicolon-separated lists of replace expressions.
	* NEWS, tar.texi: Document changes to the --transform option.

2008-01-30  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/tar.texi: Update Back-Cover text to reflect new GNU wording.

2007-12-17  Paul Eggert  <eggert@cs.ucla.edu>

	Exit with nonzero status if a close fails on an archive.
	Problem (and initial trivial fix)
	* src/buffer.c (close_archive, new_volume): close_error, not
	close_warn.

2007-12-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/buffer.c (check_compressed_archive): Do not bail out if the
	file is too short, set boolean flag, passed as an argument
	instead.  This fixes a bug introduced on 2007-08-24. See also
	tests/shortupd.at.

	* tests/Makefile.am, tests/testsuite.at: Add shortupd.at.
	* tests/shortupd.at: New test.

2007-11-12  Jim Meyering  <meyering@redhat.com>

	Don't read from name[-1].
	* src/incremen.c (make_directory): Handle namelen == 0, since
	find_directory_meta calls make_directory ("").

2007-11-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap (checkout): Use URL of the gnulib CVS mirror.
	* gnulib.modules: Add fseeko and snprintf.

2007-10-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/checkpoint.c: New actions: bell and ttyout
	* src/system.c (sys_exec_info_script)
	(sys_exec_checkpoint_script): pass the current blocking factor in
	TAR_BLOCKING_FACTOR environment variable.
	* doc/tar.texi: Update
	* NEWS: Update

2007-10-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/Makefile.am: Use texi2html and the CVS version of gendocs.sh
	to create HTML versions of the manual.
	* doc/gendocs_template: Likewise.
	* doc/tar.texi: Document --hard-dereference and
	--checkpoint-action options. Improve documentation of
	--check-links.

2007-10-29  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update
	* configure.ac: Version 1.19.1
	* po/POTFILES.in: Add src/checkpoint.c
	* src/Makefile.am (tar_SOURCES): add checkpoint.c
	* src/checkpoint.c: New file - checkpoint handling.
	* src/buffer.c (checkpoint, do_checkpoint): Remove.
	(_flush_write, simple_flush_read, _gnu_flush_read): Use
	checkpoint_run.
	* src/common.h (enum checkpoint_style): Remove.
	(checkpoint_style): Remove.
	(DEFAULT_CHECKPOINT): New define.
	(hard_dereference_option): New variable.
	(sys_exec_checkpoint_script): New declaration.
	* src/create.c (file_count_links): do nothing if
	hard_dereference_option is set.
	* src/system.c (sys_exec_checkpoint_script): New function.
	(sys_exec_info_script): Restore SIGPIPE handler.
	* src/tar.c: (parse_opt): New options --hard-dereference,
	--checkpoint-action.
	(decode_options): Call checkpoint_finish_compile.

	* src/system.c (sys_exec_info_script): Initialize buf. Problem
	reported by Bengt-Arne Fjellner.

2007-10-18  Jim Meyering  <jim@meyering.net>

	Avoid compiler warnings.
	* src/list.c (read_header_primitive): Define two locals, to
	avoid incorrect "may be used uninitialized" warnings.
	* src/incremen.c (procdir): Remove decl of unused local, "len".

2007-10-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi (gzip): Remove compression patent
	warning. According to Brett Smith, the patent is
	expired.

2007-10-17  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/suffix.c: New file. Compress format detection by archive
	suffix (when creating). Suggested by Jean-Pierre Demailly.
	* src/Makefile.am: Add suffix.c
	* src/buffer.c (magic): Add an entry for new lzma format. Proposed
	by Lasse Collin.
	* src/common.h (set_comression_program_by_suffix): New prototype.
	* src/tar.c: New options --auto-compress (-a) and --lzma
	* THANKS: Add Lasse Collin and Jean-Pierre Demailly.
	* NEWS: Update
	* doc/tar.texi: Update

2007-10-12  Paul Eggert  <eggert@cs.ucla.edu>

	* src/utf8.c (string_ascii_p): Recode to avoid bogus GCC 4.2.1
	warning about "comparison is always true due to limited range of
	data type" when char is unsigned.

2007-10-11  Paul Eggert  <eggert@cs.ucla.edu>

	Adjust to recent gnulib changes.
	* configure.ac: Dont' check for strerror, since gnulib now does this.
	* .cvsignore: Add m4, tar-[0-9]*.
	* lib/.cvsignore: Adjust to various gnulib file name changes.
	Add .deps, rmt-command.h.

2007-10-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac, NEWS: Raise version number to 1.19
	* tests/star/README: Update

2007-10-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/create.c (dump_regular_file): Fix file padding in case of
	truncation to zero size.
	* NEWS: Update

2007-10-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/T-null.at: Use AT_DATA for sample output.

2007-10-03  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c (try_purge_directory): Ensure that arguments to T
	and R are safe.

2007-09-29  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c (obstack_code_rename): Apply safer_name_suffix to
	name arguments before storing them in T and R records. Reported by
	Nicholas Cole.

2007-09-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac: Raise version number to 1.18.90
	* NEWS: Likewise

	* doc/snapshot.texi: Document version 2.
	* doc/dumpdir.texi: Update.

	Implement --exclude-tag* and --exclude-cache* options for listed
	incremental archives.
	New option --exclude-vcs to exclude VCS-specific files and
	directories.

	* NEWS: Update
	* doc/tar.texi: Document --exclude-vcs option
	* src/common.h (exclusion_tag_warning, check_exclusion_tags): New
	prototypes.
	* src/create.c (exclusion_tag_warning, check_exclusion_tags):
	Remove static qualifier.
	(check_exclusion_tags): account for dirname without terminating
	slash.
	(dump_dir0): exclusion_tag_all is handled elsewhere.
	* src/incremen.c (struct directory): New member tagfile
	(make_directory): Initialize tagfile to NULL
	(procdir): New argument: entry
	Hanlde exclusion tags.
	(makedumpdir): Take into account directory->tagfile.
	(scan_directory): Hanlde exclusion tags.
	* src/tar.c: New option --exclude-vcs
	(exclude_vcs_files): New function

2007-09-14  Paul Eggert  <eggert@cs.ucla.edu>

	* AUTHORS: Remove unnecessary information.  Just list the
	principal authors.
	* THANKS: Remove info duplicated from AUTHORS.

2007-08-25  Jim Meyering  <jim@meyering.net>

	Don't include <getline.h>.  No longer needed.
	* src/incremen.c: Don't include <getline.h>.  No longer needed.
	* src/buffer.c: Likewise.
	* src/system.c: Likewise.
	* src/tar.c: Likewise.

	Avoid shadowing and unused-variable warnings.
	* src/create.c (check_exclusion_tags): Remove declaration of unused
	local, "ret".
	* src/compare.c (diff_dumpdir): Rename stat->stat_data to avoid
	shadowing the syscall.
	* src/buffer.c (do_checkpoint): Don't shadow the write syscall.
	(try_new_volume): Avoid shadowing "access".
	* src/tar.c (decode_options): Rename index->idx to avoid shadowing.
	(find_argp_option): Rename option->o to avoid shadowing.
	* src/incremen.c (scan_directory): Rename local, dir_name->dir,
	to avoid shadowing the function.
	(get_directory_contents): Likewise.
	* src/system.c (global_pid): Rename from "pid", to avoid being
	shadowed by locals.
	* src/extract.c (apply_nonancestor_delayed_set_stat):
	Rename st->sb to avoid shadowing another local.

2007-08-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac, NEWS: Raise version number to 1.18.1

	* src/buffer.c (check_compressed_archive): Detect files smaller
	than 512 bytes.
	* tests/shortfile.at: New test case for the above change.
	* tests/testsuite.at, tests/Makefile.am: Add shortfile.at

2007-08-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Gnulib initialization destroyed paxutils m4 files.
	Initialize paxutils structure after that of gnulib.

2007-08-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/names.c (contains_dot_dot): Fix double-dot recognition in
	case of duplicate /. Patch by Dmitry V. Levin.

	* bootstrap (symlink_to_gnulib): Make sure the target directory
	exists and create it if it does not.

	* doc/tar.texi: Fix a typo.

2007-06-28  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Update for the change of the TP URL

2007-06-27  Sergey Poznyakoff  <gray@gnu.org.ua>

        Relicense under GPLv3

2007-06-21  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/testsuite.at (AT_TAR_MKHIER): Skip test if genfile is
	unable to create the file
	* tests/lustar01.at: Likewise

2007-06-21  Eric Blake  <ebb9@byu.net>

        Resolve testsuite failures 40-42 on cygwin.
        * tests/testsuite.at (AT_TAR_MKHIER): Skip tests when long
        file names cannot be created.

2007-06-16  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/Makefile.am (tar_TEXINFOS): Add tar-snapshot-edit.texi
	* doc/tar-snapshot-edit.texi: New file
	* doc/tar.texi (Fixing Snapshot Files): New appendix

	* scripts/tar-snapshot-edit: New file
	* tests/extrac07.at: Add back write permissions on dir

2007-06-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/exclude.at: Sort the output.

2007-06-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac, NEWS: Raise version number to 1.17

	* doc/tar.texi, doc/intern.texi: Replace: s/filename/file name/;
	s/(ASCII|ID|BSD)/@acronym{&}/;s/"[^"]+"/``&''/
	Use `path' only when it refers to search paths, use
	`file name' otherwise.
	Fix various errors (based on patch by Benno Schulenberg)

	* doc/tar.texi (Operation Summary): Restore alphabetical order of
	the options.

2007-06-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix bug, introduced on 2007-03-30.

	* src/common.h (xform_type): New data type
	(transform_member_name): Last argument is of xform_type type
	All callers updated

	* src/extract.c: Update calls to transform_member_name
	* src/list.c (decode_xform): Exempt symbolic links from component
	stripping and name suffix normalization.

	* tests/extrac07.at: Update

2007-05-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/xheader.c (decx): Unknown pax keywords produce a warning,
	not error.

2007-05-29  Paul Eggert  <eggert@cs.ucla.edu>

	* src/misc.c (set_file_atime): Use gl_futimens, not futimens,
	due to gnulib change.

2007-05-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/common.h (buffer_write_global_xheader): New function
	(struct xheader): Move definition to tar.h
	(extended_header): Remove global
	(xheader_init): New function
	(xheader_decode_global,xheader_store,xheader_read)
	(xheader_write_global,xheader_write,xheader_string_begin)
	(xheader_string_add,xheader_string_end): Take xhdr as first
	argument.
	* src/tar.h (struct xheader): New definition
	(struct tar_stat_info): New member xhdr (extended header).

	* src/xheader.c (xheader_init): New function
	(xheader_decode_global,xheader_store,xheader_read)
	(xheader_write_global,xheader_write,xheader_string_begin)
	(xheader_string_add,xheader_string_end): Take xhdr as first
	argument.

	* src/buffer.c (buffer_write_global_xheader): New function
	Update to use new xheader calls.

	* src/compare.c, src/create.c, src/delete.c, src/list.c,
	src/sparse.c, src/tar.c, src/update.c: Global extended_header
	removed, use new xheader calls instead.

	* tests/T-null.at: Minor fix
	* tests/atlocal.in (tarball_prereq): Discard eventual md5sum
	output.

2007-05-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/create.c (dump_file0): Original ctime cannot be used as a
	directory change indicator if --remove-files is given.

2007-04-12  Paul Eggert  <eggert@cs.ucla.edu>

	Adjust to latest Gnulib.
	* lib/.cvsignore: Add dirfd.c, dirfd.h, float+.h, mbscasecmp.c,
	stdio.h, stdio_.h, stdlib.h, stdlib_.h, time.h, time_.h, unistd.h.
	Remove exit.h, getcwd.h, mempcpy.h, memrchr.h, mkdtemp.h, stpcpy.h,
	strcase.h, strchrnul.h, strdup.h, strndup.h, strnlen.h, time_r.h,
	vsnprintf.h.
	* m4/.cvsignore: Remove localedir.h.  Sort.

2007-04-03  Paul Eggert  <eggert@cs.ucla.edu>

	* src/common.h (closeopen): Remove decl.
	* src/misc.c: Don't include <sys/time.h>, <sys/resource.h>; no longer
	needed.
	(get_max_open_files, closeopen): Remove.  All callers removed.
	(chdir_dir): Use a different technique, which doesn't rely on closing
	all open files.
	* src/tar.c (main): Don't call closeopen.

2007-04-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update
	* doc/tar.texi: Update
	* src/system.c (sys_exec_info_script): Store the
	inter-communication fd in the environment variable TAR_FD

2007-04-03  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (main): Move closeopen after decode_options to
	allow shell process substitution to work.
	* tests/extrac07.at: Expect a warning on stderr.

2007-03-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/common.h (transform_name_fp): Change signature
	(transform_member_name): New function
	* src/extract.c (extract_link, extract_symlink): Use
	transform_member_name instead of safer_name_suffix so that
	--transform and --strip-components affect links as well.
	* src/list.c (transform_member_name): New function
	(decode_header): Use transform_member_name
	* src/names.c (all_names_found): Remove check for matching_flags.
	* NEWS: Update

	* TODO: Update
	* bootstrap (slurp): Remove any occurrences of $bt from the
	generated gnulib.mk
	* src/incremen.c: Do not include mkdtemp.h

2007-01-26  Paul Eggert  <eggert@cs.ucla.edu>

	Adjust to recent gnulib changes.
	* lib/.cvsignore: Add fchownat.c, rmt-command.h, strerror.c, string.h,
	string_.h, sys, sys_time_.h, unistd_.h, wchar_.h, wctype_.h.
	Remove localedir.h, size_max.h, xsize.h.
	* src/xheader.c: Don't include stpcpy.h; no longer needed, now that
	gnulib string.h defines stpcpy on all platforms.

2007-01-23  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Document --exclude-caches* and --exclude-tag*
	options.
	* src/common.h (exclude_caches_option): Remove
	(enum exclusion_tag_type): New data type
	(add_exclude_tag): Rename to add_exclusion_tag
	(cachedir_file_p): New prototype
	* src/create.c (struct exclude_tag): rename to exclusion_tag
	(check_exclusion_tags): New function
	(cachedir_file_p): New function (from check_cache_directory)
	(dump_dir0,dump_file0): Use check_exclusion_tags
	* src/tar.c: New options --exclude-caches-all,
	--exclude-caches-under, --exclude-tag-all, --exclude-tag-under
	* tests/exclude.at: New file
	* tests/Makefile.am (TESTSUITE_AT): Add exclude.at
	* tests/testsuite.at: Add exclude.at

2007-01-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	* gnulib.modules: Require strerror
	* doc/gendocs_template: Fix typos
	* scripts/xsparse.c (expand_sparse): use ftruncate to handle the
	trailing hole
	* src/sparse.c (sparse_skip_file,pax_dump_header_1)
	(pax_decode_header): Keep track of the number of bytes
	written.
	* configure.ac: Version 1.16.2
	* NEWS: Update

2007-01-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/compare.c (diff_dumpdir): Compare directory contents using
	dumpdir_cmp.  Do not free dumpdir_buffer, it will leave the
	incremental directory table in the inconsistent state and trigger
	full dump.
	(read_and_process): Process dumpdirs no matter what the archive
	format.
	* src/incremen.c (list_dumpdir): Minor fixes.

	* src/compare.c (read_and_process): Fix type of "size"

2006-12-13  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/T-null.at: Skip the test if genfile is not able to create
	the filename with an embedded newline.

2006-12-12  Paul Eggert  <eggert@cs.ucla.edu>

	Port to Forte Developer 7 C 5.4 and C99.
	* src/common.h (add_exclude_tag): Add decl; C99 requires this
	and Forte warns about it.
	* src/incremen.c: Include <mkdtemp.h> for mkdtemp prototype,
	for same reason.
	* src/misc.c (get_max_open_files): Rewrite to avoid code that
	Forte C complains about as being unreachable.
	* src/xheader.c (mtime_code): Rewrite to avoid Forte error
	reported by Trond Hasle Amundsen.

	* src/incremen.c (compare_dirnames): Rewrite to avoid casts.
	* src/utf8.c (string_ascii_p): Likewise.
	* src/xheader.c (mtime_coder, volume_size_coder, volume_offset_coder):
	Likewise.

2006-12-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Add paxutils files to dot_ignore.

	* configure.ac: Raise version number to 1.16.1
	* bootstrap (slurp): Create .(cvs|git)ignore if not present
	* po/.cvsignore, m4/.cvsignore: Remove automatically generated
	files.

2006-12-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update
	* Makefile.am (distclean-local): Fixed
	* doc/tar.texi: Update documentation of --exclude-tag
	* src/create.c (dump_dir0): Move checks for exclude tags to
	dump_file0.
	(dump_dir): Move calls to ensure_slash to dump_file0
	* src/extract.c (extract_file): Call skip_member if open fails.
	Patch proposed by Jan-Benedict Glaw <jbglaw@lug-owl.de>
	* tests/truncate.at: Use genfile instead of dd, because on some
	systems /dev/zero is not available.

2006-12-04  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Fix some race conditions with tar -x --same-owner.
	* src/extract.c (ARCHIVED_PERMSTATS): Add a comment saying that
	S_IRWXG | S_IRWXO might be masked out.
	(set_mode): Set the mode if some bits were masked out originally.
	(set_stat): Don't chmod before chown, as that might temporarily
	grant permissions that we don't want to grant.  The chmod was
	there only to work around broken hosts, so add a comment advising
	users not to use those broken hosts instead.
	(repair_delayed_set_stat, extract_dir):
	Remember to mask out current umask before inverting permissions.
	(extract_dir): If the owner might change, or if the mode has
	special bits, create the directory 700 at first, but restore it later.
	(open_output_file): New arg mode; all uses changed.
	(extract_file, extract_node, extract_fifo): If the owner might
	change, omit group and other bits at first, but restore them after
	changing the owner.

2006-12-04  Jim Meyering  <jim@meyering.net>

	* doc/tar.texi (Long Options): Remove doubled word.

2006-11-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/xheader.c (xheader_read): Remove unused variable

	* po/POTFILES.in: Remove src/mangle.c

	* bootstrap: Implement --update-po and .bootstrap

	* src/create.c (dump_dir0): Implement --exclude-tag option
	* src/tar.c: Likewise
	* doc/tar.texi (exclude): Document --exclude-tag

2006-11-29  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Remove support for mangled names.
	* doc/tar.texi (verbose tutorial): Likewise.
	* src/Makefile.am (tar_SOURCES): Remove mangle.c.
	* src/common.h (extract_mangle): Remove decl.
	* src/extract.c (extract_mangle_wrapper): Remove.
	(prepare_to_extract): Remove support for mangled names.
	* src/list.c (read_and, print_header): Likewise.
	* src/mangle.c: Remove.
	* src/tar.h (GNUTYPE_NAMES): Remove.

	Port to latest gnulib.  There were a lot of changes, so the
	simplest way to get this up and running was to switch to coreutils
	bootstrap procedure.  I noticed one feature missing after this
	merge: the ability to update a single .po file.  I can add that
	later if need be.
	* README-cvs, bootstrap.conf: New files.
	* lib/.cvsignore: Remove Makefile.am, printf-parse.c, vasnprintf.c.
	Add fstatat.c, gnulib.mk, openat-proc.c, same-inode.h, stat_.h,
	tempname.c, tempname.h, uinttostr.c.
	* lib/printf-parse.c, lib/vasnprintf.c: New files, from coreutils,
	to override gnulib, so that we don't need xsize.h.
	* bootstrap: Replace with coreutils bootstrap, except add support
	for paxutils.
	* configure.ac (gl_USE_SYSTEM_EXTENSIONS): Remove, as gl_EARLY now
	does this.
	(gl_EARLY, gl_INIT): Add.
	(tar_GNULIB): Remove.
	* gnulib.modules: Add configmake.
	* lib/Makefile.tmpl: Remove, replacing with....
	* lib/Makefile.am: New file.
	* src/Makefile.am (tar.o): Remove dependency: Automake does this
	for us.
	* src/tar.c: Include <configmake.h> and <rmt-command.h>, not
	<localedir.h>.

2006-11-13  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/xheader.c (mtime_coder): Treat non-null data as a pointer to
	struct timespec, overriding st->mtime
	* src/create.c (start_header): Pass mtime as a call-specific data
	to xheader_store.

	* tests/truncate.at: Do not use 'k' modifier in dd options.
	* tests/append02.at: Do not depend on command timing.

2006-11-01  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (enum read_file_list_state.file_list_skip): New value
	(read_name_from_file): Skip zero-length entries

	* tests/T-empty.at: New test case
	* tests/T-null.at: New test case
	* tests/extrac07.at: New test case
	* tests/Makefile.am: Add new test cases.
	* tests/testsuite.at: Add new test cases.
	* tests/extrac02.at: Add more keywords
	* tests/extrac04.at: Likewise
	* tests/extrac06.at: Likewise
	* tests/shortrec.at: Do not assume tar's default archive is stdout

2006-10-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/extract.c, src/xheader.c: Call last_component instead of
	base_name. The latter returns a malloced string since 2006-03-11.

2006-10-21  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS, configure.ac: Version 1.16
	* Makefile.am (distclean-local): New rule

2006-10-17  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c: Fix help output formatting.  Thanks Benno
	Schulenberg.

2006-10-16  Sergey Poznyakoff  <gray@gnu.org.ua>

	* Makefile.am (dist-hook): Create a cpio archive.
	* NEWS: Update

2006-10-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi (Synopsis): Document tar exit codes.
	* src/create.c (dump_regular_file,dump_file0): Set exit_status to
	TAREXIT_DIFFERS if the file being dumped was truncated or
	otherwise changed.
	* src/tar.c: Do not attempt to close stderr after call to
	close_stdout.
	* tests/grow.at: New test case
	* tests/Makefile.am: New test grow.at
	* tests/testsuite.at: Likewise
	* tests/truncate.at (AT_KEYWORDS): Keyword `filechange'
	Test tar exit status.

	* src/buffer.c (_open_archive): Make sure stdlis is set to stderr
	when we are writing archive to stdout (unless --index-file is
	used). Bug introduced on 2006-07-06.
	* tests/Makefile.am: New test verbose.at
	* tests/testsuite.at: Likewise
	* tests/indexfile.at (AT_KEYWORDS): Add stdout keyword
	* tests/verbose.at: New test case

2006-10-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	* THANKS: Add Joerg Weilbier
	* src/buffer.c (new_volume): Initialize current_block
	* src/xheader.c (xheader_string_end): Fix diagnostic message.
	* tests/multiv05.at: New testcase.
	* tests/Makefile.am, tests/testsuite.at: Add multiv05.at

2006-09-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Use ${package} instead of hardcoding package name
	* doc/tar.texi: Minor fix
	* src/tar.c (doc0, doc1, initialize_argp_doc): Removed.  Rely on
	the new argp method instead.

2006-09-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	* README: Fix a typo

2006-09-08  Paul Eggert  <eggert@cs.ucla.edu>

	Adjust to latest gnulib.
	* lib/.cvsignore: Add at-func.c, configmake.h, fchmodat.c,
	fcntl.h, fcntl_.h, inttypes_.h, lstat.c, lstat.h.
	* tests/testsuite.at (AT_TAR_MKHIER): Use install-sh -d
	rather than the no-longer-included mkinstalldirs.

2006-09-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c (try_purge_directory): Initialize struct st.  Fix
	condition for selecting candidates for removal.
	* README-alpha: List texinfo among build prerequisites for the CVS
	version.

	* bootstrap (intl_files_to_remove): Do not remove m4/inttypes-h.m4
	and m4/inttypes-pri.m4

2006-08-11  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap: Set XGETTEXT_OPTIONS to flag our printf-format functions,
	so that translators are warned about strings that are formats but
	don't look like formats.  This might help prevent core dumps.
	* configure.ac (AM_GNU_GETTEXT): Upgrade to need-formatstring-macros.
	Suggested by Eric Blake to avoid problems like
	<http://lists.gnu.org/archive/html/bug-coreutils/2006-07/msg00087.html>.
	(AM_GNU_GETTEXT_VERSION): Upgrade from 0.12.1 to 0.15.  The gettext
	manual says we should use the version number normally expected of
	maintainers, neither more nor less.

	* bootstrap (get_translations):
	Don't exclude ky.po; it is working again.

2006-08-09  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap (get_translations):
	Don't exclude ja.po; it is working again.
	Don't remove all old .po files if we're merely updating one.
	* po/.cvsignore: Add Makevars.

2006-08-07  Paul Eggert  <eggert@cs.ucla.edu>

	* src/tar.c: Work around limitation imposed by gettext 0.15
	by concatenating strings with "\v" after translation.
	(doc): Remove, splitting into:
	(doc0, doc1): New constants.
	(argp): Don't use doc; just initialize to NULL.
	(initialize_argp_doc): New function.
	(decode_options): Use it.

	* bootstrap: Redo po file retrieval to match Bison's method,
	since the translation project changed its index format.
	Don't use --assume-autoconf; it's now replaced
	by looking in configure.ac.
	(m4/codeset.m4, m4/intdiv.m4, m4/inttypes-pri.m4, m4/isc-posix.m4):
	(m4/lcmessage.m4, m4/onceonly_2_57.m4, m4/gettext.m4, m4/glibc21.m4):
	(m4/inttypes_h.m4, m4/lib-ld.m4, m4/lib-prefix.m4, m4/po.m4):
	(m4/stdint_h.m4, m4/uintmax_t.m4, m4/ulonglong.m4):
	Don't rename to ..._gl.m4, as this is no longer needed.
	(m4/geteext.m4): Patch to remove the need for intl/*.
	Use autopoint manually, then remove the intl files,
	then undo changes to gnulib files that autoreconf made,
	and then run aclocal/autoconf/autoheader/automake.
	This makes our bootstrap procedure closer to Bison's.
	(po/Makevars): Generate automatically.
	* configure.ac (AC_PREREQ): Update from 2.59 to 2.60.
	(gl_AC_TYPE_INTMAX_T, jm_AC_TYPE_UINTMAX_T): Remove.
	* gnulib.modules: Add inttypes, stdint.
	* lib/.cvsignore: Add close-stream.c, close-stream.h,
	stdint.h, stdint_.h.
	* po/Makefile: Remove; now automatically generated.

	* src/incremen.c (read_incr_db_01): Check input strings more
	carefully.  Do not pass arbitrary char values to isspace, as
	this has undefined behavior.  Likewise for assigning arbitrary
	uintmax_t values to other types.
	(read_negative_num, read_unsigned_num, read_timespec):
	New functions, to check input values a bit more carefuly.
	(read_num): Use read_unsigned_num.  New arg MAX_VAL;
	all callers changed.
	(read_incr_db_2): Use these new functions.
	Use a consistent diagnostic for unexpected EOF.
	(read_directory_file): Do not assign arbitrary uintmax_t value
	to int.
	(read_timespec, write_directory_file_entry, write_directory_file):
	Handle negative time_t values correctly.  We don't bother to do
	this with pre-2 formats, since presumably the time stamps were
	output incorrectly.

	* src/tar.c (doc): Don't use \v in an argument to gettext;
	gettext 0.15 rejects this.

2006-07-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (decode_options): Do not require -L with -M -Hpax.
	It could be needed in future, but currently it is not.
	* src/create.c (to_chars_subst): Update comment regarding OLDGNU
	vs. GNU format differences.
	(mode_to_chars): Treat OLDGNU_FORMAT same as GNU_FORMAT. Fixes bug
	reported by TAMUKI Shoichi <tamuki@linet.gr.jp>, which caused
	equivalent `tar cf ...' and `tar rf ...' commands to produce
	different archives.

	* tests/append02.at: New test case
	* tests/Makefile.am, tests/testsuite.at: Add append02.at

2006-07-20  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap: Adjust to today's change to gnulib-tool by invoking
	it with --assume-autoconf='latest-stable'.

2006-07-16  Paul Eggert  <eggert@cs.ucla.edu>

	Adjust to recent gnulib changes.
	* lib/.cvsignore: Remove atexit.c, exit.c, getndelim2.c, getndelim2.h,
	pathmax.h, paxconvert.c, paxerror.h, xstrdup.c.
	Add inttypes.h, mktime.c, wcwidth.h, xstrndup.c, xstrndup.h.
	* src/create.c (start_header): Adjust to API change to mode_adjust.

2006-07-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	* THANKS: Add Ralf Wildenhues
	* NEWS: Update

2006-07-09  Ralf Wildenhues   <Ralf.Wildenhues@gmx.de>

	* doc/dumpdir.texi, doc/snapshot.texi, doc/sparse.texi,
        doc/tar.texi: Fix some typos.

2006-07-06  Sergey Poznyakoff  <gray@gnu.org.ua>

	tar --index-file=FILE --file=- sent the archive to FILE, and
	the listing to stderr. Bug reported by Marcin Gryszkalis
	<mg@fork.pl>

	* src/buffer.c (_open_archive): Remove stdlis initialization
	* src/tar.c (decode_options): Initialize stdlis
	* tests/indexfile.at: New test case
	* tests/testsuite.at: Include indexfile.at
	* tests/Makefile.am (TESTSUITE_AT): Add indexfile.at

2006-07-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/Makefile.am (manual): Fix TEXINPUTS
	* doc/rendition.texi (FIXME): Do not use deprecated @quote-args.
	Do not use @allow-recursion. In its current form the macro is not
	recursive.

2006-07-03  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap (update_po): Fix single translation update

2006-07-03  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac (AC_CHECK_FUNCS): Check for getdtablesize
	* src/common.h (closeopen): New function
	* src/misc.c (chdir_arg): Use x2nrealloc to reallocate wd.
	(get_max_open_files,closeopen): New functions
	(chdir_do): Do not use save_cwd if it was already used more than
	max_open_files-4 times to avoid running off the file
	descriptors.
	* src/tar.c (main): Call closeopen
	* doc/tar.texi: Update --directory description
	* NEWS: Update

2006-06-26  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Update. Add cross-references.
	* doc/sparse.texi: Add cross-references.

2006-06-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	* scripts/xsparse.c: A sample utility to expand sparse files
	extracted by third-party tars. It is not meant to be installed nor
	to be included in the distribution. It is here, so that it can be
	obtained either from CVS or from the tar web site.
	* doc/Makefile.am (tar_TEXINFOS): Sorted
	* doc/tar.texi (Other Tars): New node describing how to extract
	GNU-specific member formats using third-party tars.
	* src/common.h (sparse_file_p): Remove
	* src/sparse.c: Likewise
	* src/create.c: Use ST_IS_SPARSE instead of sparse_file_p (update
	paxutils first)
	* src/tar.c: --sparse-version turns on --sparse

2006-06-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/buffer.c (print_total_stats): Add default case.
	* src/common.h (name_init): New prototype.
	(xheader_string_end): Return bool.
	* src/extract.c (extract_volhdr): Add missing return
	* src/incremen.c: Remove not used variables
	* src/sparse.c (pax_dump_header_0): Return false if
	xheader_string_end fails (for 0.1 formats).
	(pax_dump_header): Return meaningful value
	* src/transform.c (segm_count): Change type to size_t
	* src/xheader.c (xhdr_tab.decoder): pass keyword as a second
	argument. All callers changed.
	(decode_record): Check for numeric overflow
	(xheader_string_end): Return boolean value. Check for possible
	numeric overflow

2006-06-23  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/sparse.texi: New file
	* doc/Makefile.am (tar_TEXINFOS): Add sparse.texi
	* doc/intern.texi (Sparse Formats): New node
	* doc/tar.texi: Update master menu

	* src/common.h (tar_sparse_major,tar_sparse_minor): New globals.
	* src/sparse.c: Implement sparse format versioning. Implement new
	version (1.0) of PAX sparse format.
	(pax_sparse_member_p): Fix condition
	(pax_dump_header): A dispatcher function
	(pax_dump_header_0,pax_dump_header_1): New functions.
	(pax_optab): Update
	(oldgnu_dump_header): Minor fix: make sure
	sparse_header.isextended is set before calling
	set_next_block_after
	* src/tar.c: New option --sparse-version
	* src/tar.h (struct tar_stat_info.sparse_major,sparse_minor): New
	members.
	* src/xheader.c: Implement new keywords: GNU.sparse.name,
	GNU.sparse.major, GNU.sparse.minor, GNU.sparse.realsize

	* tests/spmpv00.at, tests/spmvp01.at, tests/spmvp10.at: New
	testcases.

	* tests/Makefile.am: Add spmvp00.at, spmpv01.at, spmpv10.at
	* tests/shortrec.at: Explicitely give `-f -' to the tar invocation
	* tests/sparsemvp.at: Rewritten as an include file.
	(TAR_MVP_TEST): New macro
	* tests/testsuite.at: Include sparsemvp.at, spmvp00.at,
	spmvp01.at, spmvp10.at

2006-06-21  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi (Overriding File Metadata): New node
	Document --mtime option.
	* src/common.h (set_mtime_option,mtime_option): New globals
	* src/create.c (start_header): Override mtime if requested
	* src/tar.c: Implement new option, --mtime, allowing to set
	modification times for all archive members during creation.
	(struct tar_args): textual_date_option replaced with a linked list
	textual_date. All references updated.
	(get_date_or_file,report_textual_dates): New functions.
	* configure.ac: Raise version number to 1.15.92
	* NEWS: Update

2006-06-20  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/common.h (struct name.explicit): Remove
	Use variable names in all declarations
	(name_scan): Remove second argument
	* src/delete.c: Remove second argument from calls to name_scan
	* src/update.c: Likewise
	* src/incremen.c (procdir): Use is_individual_file to check for
	files explicitely specified in the command line. Fixes bug
	reported by Dat Head on 19 Jun 2006 (descending into mountpoints
	with --one-file-system in use)
	* src/misc.c (maybe_backup_file): Second argument is bool
	* src/names.c (name_next_elt): Call register_individual_file
	(namelist_match): Remove third argument
	(name_match): Change return type to bool
	(name_scan): Remove second argument
	* src/sparse.c (pax_dump_header): Store original sparse file name
	in GNU.sparse.name variable. The name field in the ustar header
	now contains generated name (%d/GNUSparseFile.%p/%f), so that
	non-pax-aware tars won't extract the file under the original
	filename.
	* src/xheader.c (GNU.sparse.name): New variable for storing sparse
	file name.

2006-06-13  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/Makefile.am (check-options): Expand macros before grepping
	in $(info_TEXINFOS)
	* doc/rendition.texi (FIXME) [!PROOF_FOOTNOTED]: Enclose in a
	cartouche
	* doc/tar.texi: Define op as codeindex. Use special macros to
	populate it
	Consequently prefer @dfn{long options} over @dfn{mnemonic
	options}.
	Document --unquote, --no-unquote
	(Short Option Summary): Build a table of cross-references to the
	corresponding long options.
	(Using Multiple Tapes,Multi-Volume Archives): Rewritten

	* doc/value.texi (xopindex,opsummary): New macros

	* doc/Makefile.am (check-options): New goal
	* doc/tar.texi: Update
	* src/tar.c: Implement --overwrite-dir option (long ago
	documented).

2006-06-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Document better the --totals option
	* NEWS: Update
	* src/buffer.c (total_blocks_deleted): New variable
	(set_start_time): Set volume_start_time and last_stat_time as well
	(set_volume_start_time): New function
	(compute_duration): Do not call set_start_time, update
	last_stat_time instead. Use it in calculation instead of
	start_time, which is now set only once, upon startup.
	(print_total_written): Removed.
	(print_total_stats): New function for printing byte/speed statistics.
	(_open_archive): Detect attempts to update compressed archives.
	(_gnu_flush_write): Always update prev_written.
	(open_archive): Call set_volume_start_time.
	* src/common.h (volume_start_time,last_stat_time): New globals
	(print_total_written): Replaced with:
	(print_total_stats): New function
	* src/delete.c (records_skipped): Remove static qualifier, the
	variable is used by print_total_stats in buffer.c
	* src/extract.c (check_time): Use volume_start_time when checking
	for timestamp plausability.
	* src/tar.c: (options, parse_opt): Allow for optional argument to
	the --totals option, which specifies a signal upon delivery of which
	the statistics must be output.
	(main): Call print_total_stats if total_option is set.

2006-06-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/xheader.c (xheader_set_single_keyword): Fix typo.
	(decode_time): Avoid using gotos.

	* doc/mastermenu.el: New file
	* doc/Makefile.am (master-menu): New goal
	* doc/tar.texi: Update master menu

2006-06-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Remove leftover include

2006-06-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/Makefile.am (tar_TEXINFOS): Add intern.texi
	(EXTRA_DIST): Remove convtexi.pl, add texify.sed
	* doc/intern.texi: New file
	* doc/convtexi.pl: Remove
	* doc/texify.sed: Auxiliary script to convert ../src/tar.h to
	header.texi
	* doc/rendition.texi: Fix typo
	* doc/tar.texi: Update
	* src/tar.h: Fix indentation, introduce end-of-format marker for
	texify.sed

	* THANKS: Add Jason Armistead
	* doc/tar.texi: Update
	* NEWS: Update
	* src/buffer.c: Implement more flexible checkpoint style
	* src/common.h (checkpoint_option): Change type to unsigned
	(checkpoint_style): New variable.
	* src/tar.c: --checkpoint takes an optional argument specifying
	number of records between two successive checkpoints (proposed
	by Jason Armistead on 2004-06-22).  Optional dot starting the
	argument means "print dots instead of textual checkpoints".
	(tar_help): New function
	* src/transform.c: Minor fixes.

2006-06-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* gnulib.modules: Add mkdtemp
	* doc/dumpdir.texi: New file
	* doc/Makefile.am (tar_TEXINFOS): Add dumpdir.texi
	* doc/tar.texi: Document dumpdir format
	* src/incremen.c (dumpdir_locate,obstack_code_rename):
	(purge_directory): Re-implement renaming. Introduce
	'X' control code.
	(make_tmp_dir_name): Remove

	* src/transform.c (set_transform_expr,_transform_name_to_obstack):
	Implement NUMBER flag.
	(add_char_segment): Fix length assignement

	* doc/tar.texi: Update

2006-06-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/transform.c (transform_name_fp): Run fun even if
	_transform_name_to_obstack returns false.
	(_transform_name_to_obstack,set_transform_expr): Implement GNU
	extension case conversion operations.

	* doc/tar.texi (transform): Document the option.

2006-06-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update
	* src/common.h (set_transform_expr): New function
	* tests/Makefile.am: Add incr04.at
	* tests/testsuite.at: Likewise
	* tests/incr04.at: New test case
	* tests/long01.at: Fix typo in the comment
	* tests/multiv04.at: Use genfile --files-from

	(Above changes need new genfile.c from paxutils)

	* TODO: Update
	* NEWS: Update
	* doc/tar.texi: Update
	* src/transform.c: New file
	* src/Makefile.am (tar_SOURCES): New module transform.c
	* src/common.h (transform_name, transform_name_fp): New functions
	(show_stored_names_option): Renamed to
	show_transformed_names_option. All uses changed
	* src/create.c (dump_file0): Transform file name
	* src/extract.c (extract_archive): safer_name_suffix and
	stripped_prefix_len are now called by decode_header
	* src/list.c (print_header): Update displayable name selection.
	* src/tar.c: New option --transform
	New option --show-transformed-names generalizes
	--show-stored-names. The latter is retained as an alias.

2006-05-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c (make_directory): Fix initialization of struct
	directory.

2006-05-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Document use of globbing patterns.
	* src/tar.c (parse_opt): Add comment before --preserve case.

2006-05-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update
	* doc/tar.texi: Update
	* configure.ac (AM_INIT_AUTOMAKE): Use tar-ustar option. Raise
	version requirement to 1.9
	* src/common.h (struct name): Refactured
	(warn_regex_usage): New variable.
	(dump_file): First argument is const char*.
	(name_init,name_add): Removed
	(name_add_name,name_add_dir): New functions
	(name_next): Return const char*.
	* src/create.c: (dump_file,dump_file0): First argument is const
	char*. All callers updated.
	* src/names.c: Rewritten handling of member names in the command
	line. Tar no longer attempts to guess globbing patterns, instead
	it relies on --wildcard option.
	(init_names): Removed.
	(struct name_elt): New structure.
	(name_array): Change type to struct name_elt. All references updated
	(name_add_name,name_add_dir): New functions
	(name_next_elt): New function
	(name_next): Rewritten using name_next_elt.
	(namelist_match): Rewritten pattern matching using
	exclude_fnmatch.
	(names_notfound): Warn if globbing patterns were used without
	--wildcards option
	* src/tar.c (options): Move globbing-related options into a
	separate group. Set -l as an alias to --check-links, as required
	by UNIX98
	(struct tar_args): New fields
	wildcards,matching_flags,include_anchored
	(MAKE_EXCL_OPTIONS,MAKE_INCL_OPTIONS): New macros
	(parse_opt): Use x2nrealloc to grow archive_name_array.
	Use MAKE_EXCL_OPTIONS,MAKE_INCL_OPTIONS to create appropriate
	fnmatch options, and name_add_name,name_add_dir to handle member
	name and -C arguments.
	(decode_options): Likewise
	(main): Remove call to init_names.

	* tests/append.at, tests/append01.at, tests/extrac01.at,
	tests/options.at, tests/options02.at, tests/same-order01.at,
	tests/same-order02.at: Make AT_SETUP more readable.

2006-05-23  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/buffer.c (change_tape_menu): Fix typo (uninitialized
	variable) introduced yesterday.

2006-05-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Use @var{file_name} instead of @var{file name}
	* src/buffer.c (change_tape_menu): Break the loop after obtaining
	new archive name. Check for empty input line.

2006-05-15  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/atlocal.in (XFAILFILE): New variable
	* tests/version.at: Create $XFAILFILE on failure
	* tests/testsuite.at (AT_TAR_CHECK): Declare expected failure if
	$XFAILFILE exists.

2006-05-13  Sergey Poznyakoff  <gray@gnu.org.ua>

	* THANKS: Update
	* src/buffer.c (read_header0): Use read_header_primitive to avoid
	clubbering current_tar_info. All callers updated.
	* src/common.h (read_header_primitive): New function
	* src/extract.c (extract_volhdr): New function
	(prepare_to_extract): Use extract_volhdr as extractor for volume
	names.
	* src/list.c (read_header_primitive): New function
	(read_header): Front end for read_header_primitive
	* tests/chtype.at: New file
	* tests/volsize.at: New file
	* tests/Makefile.am (TESTSUITE_AT): Add chtype.at, volsize.at
	(check-full): New target.
	* tests/atlocal.in (TEST_DATA_URL,STAR_DATA_URL)
	(STAR_TESTSCRIPTS): Provide default values.
	(tarball_prereq): New function
	* tests/testsuite.at (AT_TARBALL_PREREQ): New defun
	(AT_STAR_PREREQ): Rewrite using tarball_prereq
	Include chtype.at and volsize.at
	* tests/volume.at: Add keywords.

	* tests/star/gtarfail.at, tests/star/gtarfail2.at,
	tests/star/multi-fail.at, tests/star/pax-big-10g.at,
	tests/star/ustar-big-2g.at, tests/star/ustar-big-8g.at
	(AT_STAR_PREREQ): Provide md5 sum.

	* lib/.cvsignore: Update

2006-05-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/testsuite.at (AT_SORT_PREREQ, AT_UNPRIVILEGED_PREREQ): New
	defines

	* tests/extrac04.at, tests/incr03.at, tests/listed02.at,
	tests/pipe.at, tests/rename01.at, tests/rename02.at,
	tests/rename03.at, tests/same-order01.at: Call
	AT_SORT_PREREQ. Remove fd 2 redirection after calls to sort
	* ignfail.at: Call AT_UNPRIVILEGED_PREREQ

2006-05-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	Listed incremental backups: keep more information about
	directories. Handle renamed directories more effectively
	(initial implementation, more updates to follow).
	Source tree before this point is tagged
	alpha_1_15_90_incremental_1.

        * NEWS: Update
        * configure.ac: Raise version number to 1.15.91
	* src/common.h (rename_directory,append_incremental_renames): New
	functions.
	* src/extract.c (rename_directory): New function
        * src/incremen.c (struct directory.contents, flags): New members
	(nfs,found,new): Remove. Replaced by appropriate bitmask values in
	`flags' field. All uses updated.
	(directory_meta_table): New table.
	(hash_directory): Rename to hash_directory_name
	(compare_directories): Rename to compare_directory_names
	(hash_directory_meta,compare_directory_meta,find_directory_meta):
	New functions
	(compare_dirents): Removed
        (note_directory): Get 7th argument: directory contents.
        All callers updated
        (dumpdir_locate,makedumpdir): New functions
        (scan_directory): Rewritten. Use makedumpdir to create a sorted
        dumpdir array. This makes the obstack argument unnecessary. Besides,
        ALL_CHILDREN flag is set only for new directories.
	(procdir): Change return type to struct directory. Return
	immediately if the directory was already initialized. Discover
	directory renames using directory_meta_table.
	(append_incremental_renames): New function.
        (read_directory_file, write_directory_file): Use new snapshot file
        format.
	* src/names.c (collect_and_sort_names): Update dir_contents of the
	first non-fake name entry when in listed incremental mode.

        * tests/incr03.at: New testcase
	* tests/rename01.at: New testcase
	* tests/rename02.at: New testcase
	* tests/rename03.at: New testcase
        * tests/Makefile.am: Add
	incr03.at,rename01.at,rename02.at,rename03.at
        * tests/testsuite.at: Likewise.
	* tests/listed02.at: Update for the new behavior
        * tests/multiv04.at (AT_KEYWORDS): Add missing incremental kw.

2006-05-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/buffer.c (try_new_volume): Attempt to continue if the name
	is apparently truncated in a GNU format volume.

	* tests/comprec.at, tests/delete01.at, tests/delete02.at,
	tests/delete04.at, tests/delete05.at, tests/extrac05.at,
	tests/listed01.at, tests/multiv01.at, tests/multiv02.at,
	tests/pipe.at, tests/same-order01.at, tests/same-order02.at,
	tests/sparse01.at, tests/sparse03.at: Always use genfile --file,
	this enables extra error checking.

	* tests/multiv03.at: Attempt to extract a member with truncated
	file name from the archive.

	* src/buffer.c (_open_archive): Remove unnecessary argument to
	check_compressed_archive.

2006-04-25  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/sparse01.at, tests/sparse02.at, tests/sparse03.at,
	tests/sparsemv.at, tests/sparsemvp.at: Skip the test if the file
	system does not support sparse files.
	* doc/tar.texi (@copying): Remove the reference to not existing
	invariant section.

2006-04-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/extract.c (extract_dir): Fix toggling existing directory
	permissions (Debian bug #361077). Use parts of patch provided by
	Ian Jackson <iwj@ubuntu.com>.
	* src/compare.c: Minor changes
	* src/incremen.c (directory.new): New member
	(note_directory,find_directory: Use make_directory to create
	struct directory entries
	(procdir): Avoid duplicating  directories in the incremental
	backup map.
	* tests/Makefile.am (TESTSUITE_AT): Add extrac06.at
	* tests/testsuite.at: Include extrac06.at

2006-03-18  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de> (trivial change)

	* tests/atlocal.in (PATH): Add build-aux from the source tree,
	not the build tree.

2006-03-13  Sergey Poznyakoff  <gray@gnu.org.ua>

	* THANKS: Add Benno Schulenberg

2006-03-13  Jim Meyering <jim@meyering.net>

	* tests/listed02.at:  Sort the two lines of stderr from the
	first `tar -v --listed-incremental'.  They would come out
	reversed and provoke a test failure on a tmpfs
	file system.

2006-03-13  Benno Schulenberg <benno@nietvergeten.nl>

	* doc/tar.texi: Minor fixes.
	* src/tar.c (options): Consistently begin help messages with a
	lowercase letter.

2006-03-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/Makefile.am (AM_CPPFLAGS): Define LOCALEDIR

2006-03-07  Paul Eggert  <eggert@cs.ucla.edu>

	* src/buffer.c (record_buffer_aligned): New var.
	(init_buffer): Use it to ensure that the buffer is aligned.
	This doesn't result in any measurable performance improvement
	on my host (Debian GNU/Linux 3.1 stable, with default block size),
	but I assume it does help on some hosts.

	* lib/.cvsignore: Sort.

2006-03-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/shortrec.at: Use -f - to read from stdin.

2006-02-21  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Fix typo: --to-command instead of --to-program

2006-02-20  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/multiv04.at (split directory members in a MV archive):
	Don't use %X in an awk printf format; this doesn't work with
	Solaris 10 /usr/bin/awk.  Use %x instead.

2006-02-20  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/create.c (split_long_name): Fix maximum length estimation.
	Patch by Jim Lowe.
	* tests/Makefile.am (lustar01.at,lustar02.at,lustar03.at): New
	tests.
	* tests/atlocal.in: Add build-aux to the PATH
	* tests/long01.at: Remove mkhier, use AT_TAR_MKHIER instead
	* tests/longv7.at: Reword test title
	* tests/lustar01.at: New test
	* tests/lustar02.at: New test
	* tests/lustar03.at: New test
	* tests/testsuite.at (AT_TAR_MKHIER): New macro
	(lustar01.at,lustar02.at,lustar03.at): New tests.

2006-02-20  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap: Don't claim lib/Makefile.am is generated automatically
	from itself.

	Avoid installation glitches on Solaris 8 with Sun C 5.4.
	* lib/.cvsignore: Add system-ioctl.h.
	* lib/Makefile.tmpl (noinst_HEADERS): Add system-ioctl.h.
	* src/buffer.c: Include system-ioctl.h.
	* src/compare.c: Likewise.
	* src/delete.c: Likewise.
	* src/system.c: Include <getline.h>, <setenv.h>.
	* src/tar.c: Include <getline.h>.

2006-02-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/buffer.c (add_chunk_header): Free st.orig_file_name after
	calling	finish_header().
	(new_volume): Prompt the user for archive name if unable to open
	next archive.

	* src/create.c (dump_file0): Restore file_count_links,
	accidentally removed on 2005-11-29.
	* configure.ac: Raise version number to 1.15.90
	* NEWS: Likewise.

2006-02-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (tar_set_quoting_style): Provide second argument to
	the format spec: program_invocation_short_name. Reported by Jim
	Meyering.

2006-02-07  Paul Eggert  <eggert@cs.ucla.edu>

	* gnulib.modules: Add closeout, exitfial.
	* lib/.cvsignore: Add __fpending.c, __fpending.h, closeout.c,
	closeout.h.
	* src/buffer.c: Incluse closeout.h.
	(_open_archive): Use freopen rather than fopen, so
	that stdlis is always either stdout or stderr.  Use
	close_stdout_set_file_name to report its name.
	* src/tar.c: Include closeout.h and exitfail.h.
	(parse_opt, usage): Call close_stdout as appropriate, to check for
	write errors.
	(decode_options): Exit with status TAREXIT_FAILURE, not 1.
	(main): Set exit_failure, to exit with proper status on memory
	allocation failure and the like.
	Use close_stdout rather than rolling our own test.

	* NEWS: --version now outputs copyright etc., to conform to the
	GNU coding standards.  Remove --license.
	* gnulib.modules: Add version-etc-fsf.
	* doc/tar.texi: Document the change.
	* lib/.cvsignore: Add version-etc-fsf.c, version-etc.c, version-etc.h.
	* scripts/Makefile.am (SED_CMD): Update PAKCAGE_NAME, not PACKAGE.
	* scripts/backup.in: Remove --license.  Change --version to conform
	to GCS.
	* scripts/restore.in: Likewise.
	* scripts/backup.sh.in (license): Output briefer license in the
	style of coreutils, for consistency with other changes.
	* src/tar.c: Include <version-etc.h>.
	(LICENSE_OPTION): Remove.
	(options): Remove --license.
	(license): Remove.
	(parse_opt): Use version_etc instead of rolling it ourselves.
	Remove --license.
	* tests/version.at (tar --version): Check only the first line of
	output.

	* ChangeLog, NEWS, src/common.h, src/extract.c, src/incremen.c:
	* src/list.c, src/names.c, src/tar.h, src/xheader.c:
	Update copyright year to 2006.

2006-02-07  Jim Meyering  <jim@meyering.net>

	* src/xheader.c (sparse_map_decoder): Fix misleading diagnostic.

2006-01-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/common.h (get_gnu_dumpdir): Remove prototype
	(is_dumpdir): New function
	* src/extract.c (prepare_to_extract): Use is_dumpdir member to
	check for dumpdirs.
	* src/incremen.c (get_gnu_dumpdir): Static
	(is_dumpdir): New function
	(purge_directory): Use is_dumpdir
	* src/list.c (list_archive): Use is_dumpdir
	Do not wrap skip_member in mv_begin/mv_end, the function itself
	takes care of it.
	(decode_header): Set stat_info->is_dumpdir
	(skip_member): Do nothing if skipped is true
	* src/tar.h (struct tar_stat_info): New members is_dumpdir and skipped.

2006-01-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (decode_options): Refuse using --delete with
	compression options.

2006-01-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Updated.
	* configure.ac (DEFAULT_QUOTING_STYLE): New configuration variable
	* doc/tar.texi: Initial documentation for --quoting-style,
	--quote-chars and --no-quote-chars option.
	* src/tar.c: Implement new options --quoting-style, --quote-chars
	and --no-quote-chars.

2006-01-09  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap: Default to pserver, and switch to cvs.sv.gnu.org,
	to accommodate recent changes to the GNU CVS server.
	* lib/.cvsignore: Add argp-pin.c, mkdirat.c, openat-priv.h.

2005-12-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/names.c (name_scan): Take an additional argument requesting
	exact matching.
	* src/common.h (name_scan): Change prototype.
	* src/delete.c, src/incremen.c, src/update.c: Update invocations
	of name_scan.

2005-12-13  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/common.h (struct name): New member `explicit'. Remove unused
	member `isdir'.
	* src/incremen.c (procdir): If name_scan() returns something,
	check if it was explicitely given in the command line
	* src/names.c (addname,add_hierarchy_to_namelist): Initialize
	explicit member appropriately.

	* src/incremen.c (procdir): If --one-file-system is given and a
	directory is found to be on another device, *and* this directory
	is explicitely given in the command line, then do not omit it.

2005-12-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update
	* doc/tar.texi: Document --delay-directory-restore option.
	(Configuring Help Summary): Document usage of ARGP_HELP_FMT
	variable to customize help output.
	* src/common.h (delay_directory_restore_option): New global.
	* src/extract.c (directories_first): Replaced by
	delay_directory_restore_option. All uses changed.
	* src/tar.c (options,parse_opt): New options
	--delay-directory-restore and --no-delay-directory-restore

2005-12-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/buffer.c (open_archive): Add default case to shut up gcc.
	* src/common.h (set_file_atime): Add prototype.
	* src/create.c (to_chars_subst): Remove unused variable
	Make sure useful result code is returned.
	* src/incremen.c (read_directory_file): Fix format string
	Thanks Eric Blake for reporting.

2005-12-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi (Current status): Renamed to 'Changes' and moved to
	appendices.
	(Large or Negative Values): Rewritten
	* src/common.h (gid_to_chars, major_to_chars, minor_to_chars)
	(mode_to_chars, off_to_chars, size_to_chars, time_to_chars)
	(uid_to_chars, uintmax_to_chars): Return bool
	* src/create.c (gid_to_chars, major_to_chars, minor_to_chars)
	(mode_to_chars, off_to_chars, size_to_chars, time_to_chars)
	(uid_to_chars, uintmax_to_chars): Return bool
	(to_chars): Return bool
	(start_header): Check return values of convertion routines. Fail
	if unable to store data in the header.

2005-12-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Following the discussion with Karl Berry,
	discontinue using @value{} substitutions for Texinfo commands.
	Properly index all long options. Print a
	separate long option index.
	* doc/value.texi: Remove @set's

	* doc/tar.texi: Update --info-script documentation
	Resolve some more FIXMEs.
	* scripts/dump-remind.in: Use TAR_VOLUME instead of reading volno
	file.
	* src/buffer.c (new_volume): Update invocation
	(change_tape_menu): New function. Disable '!' command if given
	--restrict option.
	* src/common.h (sys_exec_info_script): Update declaration
	(restrict_option): New global
	* src/system.c (sys_exec_info_script): The script can supply new
	archive name to use by writing it to file descriptor 3.
	* src/tar.c (options): Add --restrict option. Use macros for
	option grouping.
	(license): Print full list of copyright years
	* NEWS: Update

2005-12-06  Eric Blake  <ebb9@byu.net> (trivial changes)

	* configure.ac (DENSITY_LETTER): Fix m4 overquoting.
	* .cvsignore: Ignore .bootstrap.

2005-12-06  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Document --to-command and --info-script
	options. Add missing xrefs.
	* src/buffer.c (new_volume): Use sys_exec_info_script() instead of
	system().
	* src/common.h (archive_format_string,subcommand_string)
	(sys_exec_info_script): New prototypes.
	* src/system.c (sys_exec_info_script): New function.
	* src/tar.c (archive_format_string): Remove static qualifier.
	(subcommand_string): New function.

2005-12-01  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/extract.c: Fix restoring of directory timestamps from
	incremental archives.
	(directories_first): New variable.
	(prepare_to_extract): Set directories_first
	(extract_archive): Call apply_nonancestor_delayed_set_stat() only
	if not extracting from an incremental archive
	(extract_dir): Obtain root_device here, to make sure it works
	correctly with -C.

	* src/incremen.c (purge_directory): Skip the member and return if
	the archive is not in incremental format.
	* tests/incr02.at: New testcase
	* tests/Makefile.am: Add incr02.at
	* tests/testsuite.at: Likewise

	* THANKS: Add Guerkan Karaman.
	* NEWS: Update

2005-11-30  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/tar.texi (Option Summary): Rewrite the
	--atime-preserve=system description in response to Ian Turner's
	proposed patch.

2005-11-30  Ian Turner  <ian@zmanda.com>

	* doc/tar.texi (Extracting Specific Files): Remove obsolescent
	FIXME.

2005-11-29  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: New option --atime-preserve=system, which uses O_NOATIME.
	* THANKS: Add Ian Turner.

	* configure.ac: Prefer AC_CHECK_HEADERS_ONCE to AC_CHECK_HEADERS.
	Check for stropts.h and sys/filio.h too, for _FIOSATIME.
	* doc/tar.texi: Change "modification time" to "data modification
	time", "change time" to "status change time", and "filesystem" to
	"file system", so that we use terminology consistent with POSIX.
	Use American spacing rather than French for sentence ends.
	"non-dependable" -> "undependable".
	(Option Summary, Attributes): Explain better the pitfalls of the
	--atime-preserve option, and suggest read-only mounts,loopback
	mounts, and noatime mounts for older systems.
	* doc/value.texi (op-atime-preserve-system): Renamed from
	op-atime-preserver-system to fix a misspelling.
	* src/common.h (enum atime_preserve): Use lower case for enum values.
	* src/compare.c: Don't include utimens.h; no longer needed.
	(diff_file): Use set_file_atime rather than utimens; avoid closing
	diff_handle until after this, so that we can set the file time stamp
	via the file descriptor rather than via its name.
	* src/create.c: Don't include utimens.h; no longer needed.
	(dump_regular_finish): Remove.  All callers now do its work inline.
	(dump_dir): New arg FD.  All callers changed.
	Use fdsavedir rather than savedir.
	(unknown_file_error): Arg is a const pointer now.
	(dump_file0): 2nd arg is a const pointer now.
	Treat directories more like files, with respect to --atime-preserve.
	For example, also warn if a directory changes while we are dumping it.
	Prefer file descriptors to file names when retrieving/setting file
	attributes; this saves path-resolution time and allows us to avoid
	changing mtime/ctime on Solaris when restoring atime as root.
	Use O_DIRECTORY when opening directories, to avoid some race conditions.
	Do not reset atime if mtime has changed.  Report an error if
	we cannot reset atime.

	* lib/.cvsignore: Add malloc.h, regcomp.c, regex.c, regex.h,
	regex_internal.c, regex_internal.h, regexc.c; used by rpmatch.

2005-11-29  Ian Turner  <ian@zmanda.com>

	First cut at adding support for --atime-preserve=system.
	* doc/tar.texi (Option Summary): First cut at documenting it.
	All other uses of --atime-preserve changed to --atime-preserve=replace.
	* doc/value.texi (op-atime-preserve-replace, op-atime-preserver-system):
	New.
	(op-atime-preserve): Mention METHOD.
	* src/common.h (atime_preserve): New enum.
	(atime_preserve_option): Now of the enum type rather than bool.
	All uses changed.
	* src/compare.c (diff_file): Read with O_NOATIME if asked for.
	* src/create.c (dump_file0): Read regular and CTG files with O_NOATIME
	if asked for.
	* src/tar.c (usage): Mention new usage.
	(parse_opt): Parse new usage.

2005-11-29  Paul Eggert  <eggert@cs.ucla.edu>

	* THANKS: Convert back to UTF-8, sort (using LC_ALL=C on Debian
	stable), and consistently use tabs rather than spaces.

2005-11-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/xheader.c: Remove parts of code prematurely introduced
	yesterday. Thanks Eric Blake.

2005-11-26  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/xheader.c (xheader_format_name): Fix memory leak.

2005-11-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	* gnulib.modules: Add rpmatch
	* lib/stdopen.h, lib/stdopen.c: New file. Imported from coreutils.
	* lib/Makefile.tmpl: Add stdopen.h, stdopen.c
	* po/POTFILES.in: Add rpmatch.c
	* src/tar.c (confirm): Rewritten using rpmatch.
	(decode_options): Minor optimizations
	(main): Call stdopen() to ensure the first three descriptors are
	open.

	* tests/multiv01.at, tests/multiv02.at, tests/multiv03.at,
	tests/multiv04.at, tests/sparsemv.at, tests/sparsemvp.at,
	tests/star/multi-fail.at: Close stdin so that if something fails
	causing tar to ask for the next volume, it won't hang the
	testsuite.

	* src/buffer.c (flush_write,flush_read): Change data type.
	(flush_archive): Compute actual buffer fill level before calling
	low level function.
	(close_archive): Call flush_archive again if the first call
	resulted in partially filled buffer.
	(try_new_volume): Rewritten handling of initial headers.
	(add_chunk_header): New function. Write an additional header
	before the continuation chunk. The purpose of the header is to
	allow third-party tars to extract the member.
	(simple_flush_write): Take an argument.
	(_gnu_flush_write): Correctly handle partially filled buffers.
	* src/common.h (flush_read,flush_write): Functions, again.
	(write_extended): Changed declaration
	(xheader_format_name): New declaration
	* src/create.c (write_extended): Change type and meaning of
	the first argument. All callers updated
	* src/xheader.c (xheader_format_name): Remove static
	qualifier. Change last argument.
	Correct buffer size calculation (allocated too much space).
	(xheader_write): Increase global_header_count here ...
	(xheader_write_global): ... instead of here

	* tests/testsuite.at (AT_TAR_CHECK): Define TEST_TAR_FORMAT
	* tests/multiv01.at: Update
	* tests/multiv02.at: Update
	* tests/multiv03.at: Update
	* tests/sparsemvp.at: Update
	* tests/star/multi-fail.at: Update

	* scripts/tarcat: Handle archives in pax format. Improve handling
	of traditional archives.
	* doc/tar.texi (Tarcat): New node

2005-11-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix splitting of sparse files between the volumes.

	* src/buffer.c (try_new_volume): Bugfix. Always check
	continued_file_name. If it is absent, the volume is out
	of sync.
	(add_multi_volume_header): Create GNU.volume.filename keyword in
	the extended header.
	* src/sparse.c (sparse_dump_region): Call mv_size_left.
	(sparse_dump_file): Enclose the loop in mv_begin/mv_end.
	* src/system.c: Do not pad compressed output if it goes to
	stdout.
	* src/xheader.c (xhdr_tab): New keyword GNU.volume.filename.

	* tests/sparsemv.at: New testcase
	* tests/sparsemvp.at: New testcase
	* tests/Makefile.am: Add sparsemv.at and sparsemvp.at.
	* tests/testsuite.at: Likewise.

2005-11-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/buffer.c: Rewritten in a more modular fashion to provide
	GNU extensions (multi-volume archives and archive labels) in
	pax format.
	NOTICE, that some of the aspects (e.g. splitting the archive
	on the extended header boundary) are still not solved, others
	(splitting a sparse file between the volume) require additional
	testing. Wait for the next commit.

	(volume_label,continued_file_name,continued_file_size)
	(continued_file_offset): New globals.
	(save_name,save_totsize,save_sizeleft): Make static
	(mv_begin,mv_end,mv_total_size,mv_size_left): New functions
	(open_archive,flush_write,flush_read): Rewritten

	* src/common.h (save_name,save_sizeleft,save_totsize): Remove
	globals.
	(volume_label,continued_file_name,continued_file_size): New
	variables.
	(flush_read,flush_write): Pointers to functions
	(mv_begin,mv_end,mv_total_size,mv_size_left): New functions
	(write_extended): New function.

	* src/compare.c, src/create.c, src/extract.c, src/incremen.c,
	src/list.c: Use mv_.* functions uniformly instead of fiddling
	with the global variables.
	* src/sparse.c: Use mv_.* functions where necessary.
	* src/tar.c (decode_options): Allow to use --multi-volume and
	--label with pax archives.
	* src/xheader.c (xhdr_tab): Support for new GNU keywords.

	* tests/delete01.at, tests/delete02.at, tests/delete03.at,
	tests/delete04.at, tests/delete05.at, tests/extrac01.at,
	tests/extrac02.at, tests/extrac03.at, tests/extrac04.at,
	tests/extrac05.at, tests/incr01.at, tests/incremental.at,
	tests/listed01.at, tests/listed02.at, tests/long01.at,
	tests/longv7.at, tests/multiv01.at, tests/multiv02.at,
	tests/multiv03.at, tests/multiv04.at, tests/options.at,
	tests/options02.at, tests/same-order01.at, tests/same-order02.at,
	tests/sparse01.at, tests/sparse02.at, tests/sparse03.at,
	tests/star/multi-fail.at (AT_KEYWORDS): Improve to allow execution
	of related tests in groups.

	* doc/tar.texi: Update

2005-11-07  Paul Eggert  <eggert@cs.ucla.edu>

	* src/xheader.c (struct xhdr_tab.coder): Last arg is void const *,
	not void *, to avoid create.c warning from GCC "passing argument 3
	of 'xheader_store' discards qualifiers from pointer target type".
	(dummy_coder, atime_coder, gid_coder, gname_coder, linkpath_coder):
	(ctime_coder, mtime_coder, path_coder, size_coder, uid_coder):
	(uname_coder, sparse_size_coder, sparse_numblocks_coder):
	(sparse_offset_coder, sparse_numbytes_coder, dumpdir_coder):
	(xheader_store): Likewise.
	* src/common.h (xheader_store): Likewise.

2005-11-07  Sergey Poznyakoff  <gray@gnu.org.ua>
       and  Paul Eggert  <eggert@cs.ucla.edu>

	* src/tar.c (NS_PRECISION_FORMAT_MASK): New macro.
	(tar_timespec_cmp): New function. Wrapper over
	timespec_cmp using the timespec precision provided by the
	current archive format.
	* src/common.h (tar_timespec_cmp): New declaration.
	* src/compare.c (diff_file): Use tar_timespec_cmp.
	* src/extract.c (file_newer_p): Likewise.
	* src/update.c (update_archive): Likewise.
	* tests/truncate.at: Reverted changes
	* tests/update.at: Reverted changes

2005-11-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	Support for incremental formats in pax archives.
	Fixed POSIX compatibility of `sparse' extended header keywords.

	* src/common.h (dumpdir_size,get_gnu_dumpdir)
	(xheader_string_begin,xheader_string_add)
	(xheader_string_end): New functions.
	* src/create.c (dump_dir0): Handle incremental backups in pax
	archives.
	* src/incremen.c (dumpdir_size, get_gnu_dumpdir): New functions.
	(purge_directory): Use stat_info.dumpdir instead of getting its
	value explicitely.
	* src/list.c (list_archive): Handle incremental backups in pax
	format.
	(decode_header): Initialize stat_info.dumpdir
	* src/sparse.c (sparse_diff_file): Bugfix: set seekable.
	(pax_dump_header): Store sparse map in GNU.sparse.map. If this
	variable has been explicitely deleted, use GNU.sparse.offset/
	GNU.sparse.numbytes variables.
	* src/tar.c (decode_options): Incremental options are allowed with
	--format=pax
	(tar_stat_destroy): Free dumpdir
	* src/tar.h (struct tar_stat_info.dumpdir): New member.
	* src/xheader.c (xheader_keyword_deleted_p): Remove static
	qualifier.
	(struct xhdr_tab.decoder): Change prototype. POSIX allows string
	values to contain embedded nulls, so take an extra argument
	specifying the length of the string.
	(decx,decg,dummy_decoder,atime_decoder,gid_decoder)
	(gname_decoder,linkpath_decoder,ctime_decoder,mtime_decoder)
	(path_decoder,size_decoder,uid_decoder,uname_decoder)
	(sparse_size_decoder,sparse_numblocks_decoder)
	(sparse_offset_decoder,sparse_numbytes_decoder): Likewise.
	(decode_record): Pass value length to the handler
	(run_override_list): Pass value length to the decoder
	(xheader_print_n): New function
	(xheader_print): Rewritten using xheader_print_n
	(xheader_finish): Do not rely om strlen to compute the length of
	the collected string: it can contain embedded nulls
	(xheader_string_begin,xheader_string_add,xheader_string_end): New
	functions.
	(sparse_map_decoder,dumpdir_coder,dumpdir_decoder): New
	functions. Handle GNU.sparse.map and GNU.dumpdir variables.
	(xhdr_tab): Add new variables.

	* tests/incr01.at: Test gnu, oldgnu, and posix formats
	* tests/incremental.at: Likewise

2005-11-06  Paul Eggert  <eggert@cs.ucla.edu>

	* NEWS: Minor language and white space fixes.

	* tests/truncate.at: Create files whose time stamps must fall on
	1-second boundaries.  This prevents tests from failing on hosts
	like Solaris 8 that have nanosecond-resolution file time stamps.
	* tests/update.at: Likewise.

	* src/xheader.c (strtoimax, strtoumax): Remove decls; now done
	in system.h.

2005-11-06  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Properly document incremental dumps
	* doc/value.texi: Likewise.
	* doc/snapshot.texi: Likewise.

2005-11-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	Improve listed incremental format:

	* src/common.h (update_parent_directory): New prototype.
	* src/create.c (dump_file): Call update_parent_directory.
	* src/incremen.c (struct directory.mtime): New member.
	(note_directory): Take additional arguments. All callers updated.
	(scan_directory): Updated to use more metadata. In particular,
	this allows to correctly detect renamed files.
	(read_directory_file,write_directory_file)
	(write_directory_file_entry): Support new directory file format.
	* tests/listed01.at: Sleep 1 sec before creating second file.
	* tests/listed02.at: Never skip the test. It should work on any
	filesystem.

	* doc/snapshot.texi: New file
	* doc/tar.texi: Update.
	* doc/Makefile.am: Update.

2005-11-04  Paul Eggert  <eggert@cs.ucla.edu>

	* src/extract.c (set_stat): Rewrite to avoid bug in Forte
	Developer 7 C 5.4 Patch 111708-09 (2004-02-19).

2005-11-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Fix quoting in help output.
	(update_po): Use backward-compatible wget option --cache instead
	of deprecated -C to accomodate for wget 1.10.
	Changes proposed by Eric Blake
	* THANKS: Add Eric Blake

2005-11-02  Paul Eggert  <eggert@cs.ucla.edu>

	* doc/tar.texi: Consistently put two spaces after sentences,
	and put commas after "i.e." and "e.g.".  This is the usual GNU
	style in manuals.

	* lib/.cvsignore: Add creat-safer.c, fcntl--.h, fcntl-safer.h,
	open-safer.c, openat-die.c, verify.h, to accommodate recent gnulib
	changes.

2005-10-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/compare.c (diff_dumpdir): Pass a valid device number to
	get_directory_contents.

	* THANKS: Add John Thomas McDole

	* bootstrap: If file `.bootstrap' exists in the cwd and is
	readable, prepend its contents to the command line

2005-10-21  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/link01.at: Skip test if ln fails (suppose the OS does
	not support hard links).

2005-10-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/tar.c (decode_options): Report error if -A or -r is used
	together with compression option.

2005-09-29  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/tar.texi: Use @option and @kbd consistently.
	Document new options.

2005-09-28  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Updated
	* src/common.h (show_stored_names_option): New variable
	* src/list.c (print_header): If show_stored_names_option is given,
	list member names as stored in the archive. Patch proposed by Erik
	Cumps <erik.cumps@icos.be>
	* src/tar.c: Implement --show-stored-names option

	* src/common.h (test_label_option): New variable;
	* src/list.c (print_header): Special handling if test_label_option
	is set.
	* src/names.c (all_names_found): If test_label_option is set
	return true.
	* src/tar.c: New option --test-label tests the archive volume
	label. The option proposed by Wouter Verhelst <wouter@nixsys.be>

2005-09-21  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/Makefile.am (clean-local): Don't attempt to run
	$(TESTSUITE) if it doesn't exist.  Problem reported by
	Eric Blake.

2005-09-16  Paul Eggert  <eggert@cs.ucla.edu>

	Don't filter time stamps through the resolution supported
	by struct stat; keep them to full nanosecond resolution.
	This affects behavior only on older hosts or file systems
	that have lower-resolution time stamps.
	* src/common.h (OLDER_STAT_TIME): Parenthesize arg.
	(OLDER_TAR_STAT_TIME): New macro.
	(code_timespec): New function.
	(BILLION, LOG10_BILLION, TIMESPEC_STRSIZE_BOUND): New constants.
	* src/compare.c (diff_file): Use full time stamp resolution.
	* src/create.c (start_header, dump_file0): Likewise.
	(start_header, dump_file0): Adjust to new structure layout.
	(dump_regular_finish): Simplify by using timespec_cmp.
	* src/extract.c (struct delayed_set_stat): Don't store stat info
	that we don't need, to save space.  All uses changed.
	(struct delayed_set_stat, struct delayed_link, file_newer_p):
	(create_placeholder_file, extract_link, apply_delayed_links):
	Use full time stamp resolution.
	(check_time): Use code_timespec rather than rolling our own code.
	(set_stat, delay_set_stat): Arg now points to tar_stat_info to
	avoid losing time information.  All callers changed.
	* src/list.c (read_and, decode_header, print_heaeder):
	Use full time stamp resolution.
	* src/misc.c (code_timespec): New function.
	* src/tar.h (struct tar_stat_info): Record atime, mtime, ctime
	separately, for benefit of hosts with lower resolution.
	* src/update.c (update_archive): Use full time stamp resolution.
	* src/xheader.c (code_time): Use new code_timespec function
	to simplify code.
	(atime_coder, atime_decoder, ctime_coder, ctime_decoder):
	(mtime_coder, mtime_decoder): Use full time stamp resolution.

	Report time stamps to full resolution in environment.
	Report memory allocation failures rather than ignoring them.
	* src/system.c (time_to_env): New function.
	(oct_to_env, str_to_env, chr_to_env): Report memory allocation failures.
	(stat_to_env): Report full resolution in time stamps.

2005-09-16  Paul Eggert  <eggert@cs.ucla.edu>

	Merge changes from gnulib for file system sub-second time stamps.
	* configure.ac: Remove checks for struct stat.st_spare1, struct
	stat.st_atim.tv_nsec, struct stat.st_atimespec.tv_nsec, struct
	stat.st_atimensec, as gnulib now does this for us.
	Similarly for LIB_CLOCK_GETTIME.
	* gnulib.modules: Add stat-time.
	* lib/.cvsignore: Add stat-time.h.
	* src/common.h: Include stat-time.h.
	(timespec_lt): Remove.  All callers changed to use timespec_cmp.
	(get_stat_atime, get_stat_ctime, get_stat_mtime):
	(set_stat_atime, set_stat_ctime, set_stat_mtime):
	Remove; now defined by stat-time.h.

2005-09-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c (list_dumpdir): New function. Used to dump
	contents of GNUTYPE_DUMPDIR blocks.
	* src/common.h (list_dumpdir): Likewise.
	* src/list.c (list_archive): Use list_dumpdir() to display
	GNUTYPE_DUMPDIR blocks. Do that only if two or more -v options are
	given.

2005-09-12  Paul Eggert  <eggert@cs.ucla.edu>

	* lib/.cvsignore: Adjust to current gnulib and modules used.
	Add getdelim.c, getdelim.h, mbchar.c, mbchar.h, mbuiter.h, memchr.c,
	pipe-safer.c, size_max.h, strdup.c, strdup.h, strnlen.h, strnlen1.c,
	strnlen1.h, unistd--.h.
	Remove getndelim2.c, getndelim2.h, pathmax.h, sysexits.h, xstrdup.c.

	Treat fishy-looking hard links like fishy-looking symlinks.
	* src/extract.c (struct delayed_set_stat): Rename after_symlinks
	member to after_links.  All uses changed.
	(struct delayed_link): Renamed from struct delayed_symlink.
	All uses changed.  New member is_symlink.
	(delayed_link_head): Renamed from delayed_symlink_head.  All uses
	changed.
	(create_placeholder_file): New function, taken from extract_symlink.
	(extract_link): Create placeholders for fishy-looking hard links.
	(extract_symlink): Move code into create_placeholder_file.
	(apply_delayed_links): Renamed from apply_delayed_symlinks.
	All uses changed.  Create both hard links and symlinks.

2005-09-03  Paul Eggert  <eggert@cs.ucla.edu>

	* README-alpha: Modernize description of software required for
	developers.

2005-09-03  Sergey Poznyakoff  <gray@gnu.org.ua>

	* gnulib.modules: Add strdup
	* src/incremen.c (purge_directory): Do not dereference symbolic
	links. Bug reported by Ralph Corderoy <ralph@inputplus.co.uk> and
	David Brown <davidb@davidb.org>
	* tests/incr01.at: New test.
	* tests/Makefile.am: Add incr01.at
	* tests/testsuite.at: Likewise
	* THANKS: Updated

2005-08-17  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/incremen.c (read_directory_file): Use strtoumax to read
	snapshot file contents.
	(write_directory_file_entry): Use umaxtostr().

2005-07-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/create.c (file_dumpable_p,dump_file0): Fix handling of
	sparse files to /dev/null with --totals option.
	* tests/update.at: Remove dependency on file order.

2005-07-08  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* doc/tar.texi: Fix typo.

2005-07-07  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* tests/pipe.at: Pipe the output from `tar xfv' through sort.

2005-06-25  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/sparse.c (tar_sparse_init): Fill structure with zeros. Call
	sparse_select_optab(). All callers updated.
	(sparse_member_p, sparse_fixup_header): Use tar_sparse_init().

2005-06-23  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/sparse.c (pax_sparse_member_p): Checking member size
	vs. file size is not reliable enough. Use sparse_map_avail.

	* tests/star/gtarfail.at: Adapt to the new output format
	* tests/star/gtarfail2.at: Likewise
	* tests/star/multi-fail.at: Likewise
	* tests/star/pax-big-10g.at: Likewise
	* tests/star/ustar-big-2g.at: Likewise
	* tests/star/ustar-big-8g.at: Likewise

	* tests/sparse03.at: New test.
	* tests/Makefile.am: Add sparse03.at
	* tests/testsuite.at: Likewise

	* src/xheader.c (size_decoder): Do not set archive_file_size.

	Fix bugs introduced yesterday:

	* src/sparse.c (tar_sparse_init):  Initialize
	dimped_size to 0.
	(sparse_scan_file): Initialize archive_file_size to 0. The
	variable keeps size of the file *as stored in the archive*, not
	the size reported by stat.

2005-06-22  Paul Eggert  <eggert@cs.ucla.edu>

	A sweep of the sparse code prompted by a bug report by Jim Meyering.
	* src/sparse.c: Include <inttostr.h>.
	(struct tar_sparse_file): offset and dumped_size are off_t, not
	size_t.  optab is now const *.
	(dump_zeros): Return bool success flag, not off_t.
	All callers changed.
	Use a constant-zero buffer rather than clearing a buffer each time.
	Don't mess up if write fails.
	(dump_zeros, check_sparse_region):
	Don't assume off_t is no wider than size_t.
	(tar_sparse_init): Don't bother clearing a field that is already clear.
	(zero_block_p): First arg is const *, not *.
	(clear_block, SPARSES_INIT_COUNT): Remove.
	(sparse_add_map): First arg is now struct start_stat_info *, not
	struct tar_sparse_file *.  All callers changed.
	Use x2nrealloc to check for size_t overflow.
	(parse_scan_file): Cache commonly-used parts of file.
	Use an auto buffer, not a static one.
	Don't bother clearing the buffer; not needed.
	Don't bother clearing items that are already clear.
	(oldgnu_optab, star_optab, pax_optab): Now const.
	(sparse_dump_region): Don't bother clearing the buffer before
	reading into it; just clear the parts that aren't read into.
	(sparse_dump_file): Clear the whole local variable 'file'.
	(diff_buffer): Remove; now a local var.
	(check_sparse_region): Don't bother clearing buffer before
	reading into it.  Don't assume off_t is promoted to long.
	(oldgnu_get_sparse_info, star_get_sparse_info):
	Use an auto status, not static.
	* src/tar.h (struct tar_stat_info): had_trailing_slash is
	now bool, not int.
	* src/xheader.c (sparse_offset_coder, sparse_numbytes_coder):
	Rewrite to avoid cast.
	(sparse_offset_decoder, sparse_numbytes_decoder):
	Diagnose excess entries rather than crashing.

2005-06-22  Jim Meyering  <jim@meyering.net>

	* src/common.h (timespec_lt): Add a return type: bool.

2005-06-21  Paul Eggert  <eggert@cs.ucla.edu>

	Further improvements inspired by Jim Meyering's fixes.

	* NEWS: Better support for full-resolution time stamps.
	The -v option now prints time stamps only to 1-minute resolution.
	* gnulib.modules: Add utimens.
	* lib/.cvsignore: Add imaxtostr.c, inttostr.c, inttostr.h,
	offtostr.c, umaxtostr.c, utimens.c, utimens.h.  Remove paxconvert.c.
	* lib/Makefile.tmpl (libtar_a_SOURCES): Remove paxconvert.c.
	* lib/paxconvert.c: Remove; superseded by umaxtostr.c.
	* po/POTFILES.in: Remove lib/paxconvert.c.  Add lib/xalloc-die.c,
	lib/obstack.c.
	* src/buffer.c (set_start_time, compute_duration, start_time):
	Use gettime rather than rolling our own code.
	* src/common.h (OLDGNU_NAME_FIELD_SIZE, MAXOCTAL11, MAXOCTAL7): Remove.
	(newer_ctime_option): Remove.
	(timespec_lt): New function.
	(OLDER_STAT_TIME): Use it.
	(string_to_chars): First arg is char const *, not char *.
	(tartime): Time arg is now struct timespec.  New bool arg.
	All callers changed.
	(code_ns_fraction): New decl.
	(sys_stat_nanoseconds): Remove decl.
	(get_stat_atime, get_stat_ctime, get_stat_mtime): New functions.
	(set_stat_atime, set_stat_ctime, set_stat_mtime): New functions.
	* src/compare.c: Include utimens.h rather than rolling our own.
	(diff_dir, diff_file, diff_link, diff_symlink, diff_special):
	Prototype.
	(diff_dumpdir, diff_multivol): Prototype.
	(diff_file): Support higher-resolution time stamps.
	* src/create.c: Include utimens.h rather than rolling our own.
	(MAX_OCTAL_VAL): New macro.
	(tar_copy_str, string_to_chars): Don't bother to zero-fill;
	the destination is already zeroed.
	(string_to_chars): First arg is char const *.
	(start_private_header): Use MINOR_TO_CHARS, not MAJOR_TO_CHARS,
	for minor device number.
	(write_header_name, dump_hard_link, dump_file0):
	Simplify test for old GNU format.
	(start_header): Put in placeholders for uid, etc., even when
	using extended headers, for benefit of older "tar" implementations.
	Don't assume uintmax_t is wider than 32 bits.
	Output extended header for mtime if needed.
	(dump_regular_finish, dump_file0):
	Support extended time stamp resolution.
	* src/extract.c: Include utimens.h rather than rolling our own.
	(check_time): Support extended time stamp resolution.
	* src/list.c: Include <inttostr.h>.
	(tartime): Use umaxtostr rather than stringify_uintmax_t_backwards.
	* src/xheader.c: Include <inttostr.h>.
	Do not include <xstrtol.h>.
	(strtoimax) [!HAVE_DECL_STRTOIMAX && !defined strtoimax]: New decl.
	(strtoumax) [!HAVE_DECL_STRTOUMAX && !defined strtoumax]: New decl.
	(BILLION, LOG10_BILLION): New constants.
	(to_decimal): Remove; superseded by inttostr.  All callers changed
	to use umaxtostr.
	(xheader_format_name): Don't assume pids and uintmax_t values
	fit in 63 bytes (!) when printed.
	(decode_record): Don't bother to check for ERANGE; an out of range
	value must be treater than len_max anyway.
	If the length is out of range, output it in the diagnostic.
	(format_uintmax): Remove; all callers changed to use umaxtostr.
	(xheader_print): Don't assume sizes can be printed in 99 bytes (!).
	(out_of_range_header): New function.
	(decode_time): Use it.
	(code_time): Accept struct timespec, not time_t and unsigned long.
	All callers changed.  Size sbuf properly, and remove unnecessary check.
	Don't assume time stamps can fit in 199 bytes.
	Handle negative time stamps.  Handle fractional time stamps
	more consistently.  Don't output unnecessary trailing zeros.
	(decode_time): Yield struct timespec, not time_t and unsigned long.
	All callers changed.
	Handle negative time stamps.  Truncate towards minus infinity
	consistently.  Improve overflow checks, and output a better
	diagnostic on overflow.
	(code_num): Don't assume uintmax_t can be printed in 99 bytes (!).
	(decode_num): New function, for better diagnostics.
	(atime_coder, atime_decoder, gid_decoder, ctime_coder):
	(ctime_decoder, mtime_coder, mtime_decoder, size_decoder):
	(uid_decoder, sparse_size_decoder, sparse_numblocks_decoder):
	(sparse_offset_decoder, sparse_numbytes_decoder):
	Use decode_num, etc., instead of xstrtoumax, etc.

2005-06-21  Jim Meyering  <jim@meyering.net>

	Carefully crafted invalid headers can cause buffer overrun.
	Invalid header fields go undiagnosed.
	Some valid time strings are ignored.

	* src/xheader.c (sparse_numblocks_decoder): Remove unchecked use
	of `calloc'.  Use xcalloc instead.
	(decode_time, gid_decoder, size_decoder, uid_decoder):
	(sparse_size_decoder, sparse_offset_decoder, sparse_numblocks_decoder):
	Ensure that the result of calling xstrtoumax is no larger than
	the maximum value for the target type.  Upon any failure, exit with
	a diagnostic.
	(sparse_numblocks_decoder): Avoid buffer overrun/heap corruption:
	use x2nrealloc, rather than `n *= 2' and xrealloc(p, n,....
	(decode_time): Rewrite to accept time strings like
	1119018481.000000000.  Before, such strings were always ignored.

2005-06-13  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/create.c (dump_file0): Check for is_avoided_name()
	first. Fixes bug reported by Martin Lohmeier
	<martin@mein-horde.de>
	* tests/update.at: New file
	* tests/Makefile.am (TESTSUITE_AT): Add update.at
	* tests/testsuite.at: Likewise

2005-06-13  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac (AC_STRUCT_ST_BLKSIZE)
	(AC_STRUCT_ST_BLOCKS): Removed. Handled by system.m4.

2005-06-02  Paul Eggert  <eggert@cs.ucla.edu>

	* src/names.c (excluded_name): excluded_filename ->
	excluded_file_name, because the name was changed in gnulib.

2005-05-30  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.c (read_name_from_file,update_argv): Automatically
	detect nul-terminated list files.
	* NEWS: Updated

2005-05-27  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* scripts/backup.sh.in: Bugfixes.

2005-05-26  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* scripts/backup.in: Minor fixes
	* scripts/backup.sh.in (mt_begin,mt_rewind)
	(mt_offline,mt_status):	Use $MT to invoke mt
	(init_common): Set --rsh-command option for mt if TAPE_FILE is a
	remote archive.
	* doc/tar.texi: Document new backup scripts behavior

2005-05-22  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* lib/.cvsignore: Updated
	* lib/Makefile.tmpl: Add new paxutils files
	* po/POTFILES.in: Likewise
	* src/buffer.c: Update invocations of safer_name_suffix()
	* src/create.c: Likewise
	* src/extract.c: Likewise
	* src/xheader.c: Likewise
	* src/common.h: Include paxlib.h instead of paxerror.h
	(safer_name_suffix,removed_prefixes_p): Removed. The functions are
	imported from paxutils
	* src/names.c (hash_string_hasher,hash_string_compare)
	(hash_string_insert,hash_string_lookup,removed_prefixes_p)
	(safer_name_suffix): Moved to paxutils

2005-05-19  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap (copy_files): Accept optional third argument: a prefix
	to be appended to destination file names.
	Import paxutils/paxlib files.
	* configure.ac: Remove checking for LIB_SETSOCKOPT, it is handled
	by paxutils.
	* lib/Makefile.tmpl (libtar_a_SOURCES): Add paxerror.c paxexit.c
	paxconvert.c
	* po/POTFILES.in: Likewise.
	* src/common.h: Remove defines and declarations imported from
	paxutils
	* src/misc.c: Likewise
	* src/list.c (stringify_uintmax_t_backwards): Moved to paxutils

2005-05-17  Paul Eggert  <eggert@cs.ucla.edu>

	* src/misc.c (remove_any_file): Fix typo in previous change.

2005-05-14  Paul Eggert  <eggert@cs.ucla.edu>

	Port to Solaris 10's treatment of unlinking directories.
	* gnulib-modules: Add unlinkdir.
	* lib/.cvsignore: Add unlinkdir.h, unlinkdir.c.
	* src/common.h (we_are_root): Remove extern decl; it's now static.
	* src/extract.c (we_are_root): Now static.
	* src/misc.c: Include <unlinkdir.h>.
	(remove_any_file): Use cannot_unlink_dir () rather than	we_are_root.

	* ChangeLog, ChangeLog.1, Makefile.am, NEWS, PORTS, README,
	README-alpha, TODO, bootstrap, configure.ac, doc/Makefile.am,
	doc/convtexi.pl, doc/fdl.texi, doc/gendocs_template,
	lib/Makefile.tmpl, lib/prepargs.c, lib/waitpid.c, po/POTFILES.in,
	scripts/Makefile.am, scripts/backup-specs, scripts/backup.in,
	scripts/backup.sh.in, scripts/restore.in, src/Makefile.am,
	src/arith.h, src/buffer.c, src/common.h, src/compare.c,
	src/create.c, src/delete.c, src/extract.c, src/incremen.c,
	src/list.c, src/mangle.c, src/misc.c, src/names.c, src/sparse.c,
	src/system.c, src/tar.c, src/tar.h, src/update.c, src/utf8.c,
	src/xheader.c, tests/Makefile.am, tests/append.at,
	tests/append01.at, tests/comprec.at, tests/delete01.at,
	tests/delete02.at, tests/delete03.at, tests/delete04.at,
	tests/delete05.at, tests/extrac01.at, tests/extrac02.at,
	tests/extrac03.at, tests/extrac04.at, tests/extrac05.at,
	tests/gzip.at, tests/ignfail.at, tests/incremental.at,
	tests/link01.at, tests/listed01.at, tests/listed02.at,
	tests/long01.at, tests/longv7.at, tests/multiv01.at,
	tests/multiv02.at, tests/multiv03.at, tests/multiv04.at,
	tests/old.at, tests/options.at, tests/options02.at, tests/pipe.at,
	tests/recurse.at, tests/same-order01.at, tests/same-order02.at,
	tests/shortrec.at, tests/sparse01.at, tests/sparse02.at,
	tests/testsuite.at, tests/truncate.at, tests/version.at,
	tests/volume.at, tests/star/gtarfail.at, tests/star/gtarfail2.at,
	tests/star/multi-fail.at, tests/star/pax-big-10g.at,
	tests/star/quicktest.sh, tests/star/ustar-big-2g.at,
	tests/star/ustar-big-8g.at:
	Update FSF postal mail address.

2005-05-12  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* NEWS: Updated
	* THANKS: Updated
	* bootstrap: Install files from paxutils/doc
	* doc/Makefile.am (tar_TEXINFOS): Add genfile.texi
	* doc/tar.texi (Genfile): New appendix
	* src/compare.c (diff_file): diff_handle was not initialized
	* src/create.c (dump_regular_file): Correctly pad archive members
	that shrunk during archiving. Repored by Frank Heckenbach.
	* src/extract.c (file_newer_p): Return false if file does not
	exist
	(prepare_to_extract): Correct warning wording.
	* tests/truncate.at: New test case
	* tests/Makefile.am: Add truncate.at
	* tests/testsuite.at: Likewise.

	* doc/.cvsignore: Updated
	* lib/.cvsignore: Updated
	* tests/.cvsignore: Updated

2005-05-02  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/multivol04.at: Tell awk to read from /dev/null.

	Adjust to recent gnulib changes.
	* lib/.cvsignore: Add dup-safer.c, fd-safer.c, unistd-safer.h.
	* src/common.h (initial_umask): New var.
	* src/create.c (start_ueader): Use it, and adjust to new modechange
	API.
	(hash_link): unsigned -> size_t parameters and result.
	* src/incremen.c (hash_directory): Likewise.
	* src/names.c (hash_string_hasher): Likewise.
	* src/tar.c (parse_opt): Set it, and adjust to new modechange API.

2005-04-19  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* tests/Makefile.am: Add shortrec.at.

2005-04-18  Paul Eggert  <eggert@cs.ucla.edu>

	* src/buffer.c (reading_from_pipe): Remove.  All uses removed.
	(short_read): Don't warn about short reads; they're normal.
	* tests/shortrec.at: New file.
	* tests/testsuite.at: Include it.

	* bootstrap (gnulib_modules): Don't create a file modlist.tmp, as
	it is sometimes left behind as a garbage file (maybe due to the
	multiple traps?).

2005-04-14  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c: Handle Solaris 'X' type flag
	* src/tar.h (SOLARIS_XHDTYPE): New define

2005-04-06  Sergey Poznyakoff  <gray@mirddin.farlep.net>

	* src/tar.c: Minor fixes to text messages. Proposed by Benno
	Schulenberg.
	* src/extract.c: Likewise
	(extract_file): Assign orig_file_name
	to save_name uniformly over the program. This fixes matching
	directory names at the start of an archive volume.
	* src/buffer.c (flush_write): Warn when the name of the archive
	straddling volume boundary is longer than 100 characters. Earlier
	behavior was to issue a fatal error.
	(struct zip_magic): Reverted part of changes from 2005-04-04.
	They make the maintenance too costly. Removing `unsigned'
	qualifier from `magic' member should be enough.
	* src/compare.c (diff_init): Read directory file if in listed
	incremental. This prevents spurious 'Contents differ' diagnostics.
	(diff_archive): Minor fixes to text messages
	(diff_file,diff_dumpdir,diff_multivol): Assign orig_file_name
	to save_name uniformly over the program. This fixes matching
	directory names at the start of an archive volume.
	* src/create.c: Assign orig_file_name
	to save_name uniformly over the program. This fixes matching
	directory names at the start of an archive volume.
	* src/list.c: Likewise

	* tests/multiv03.at: Modified to match the new behavior
	* tests/multiv04.at: New file. Test splittind directory members between
	the archive volumes.
	* tests/Makefile.am: Add multiv04.at
	* tests/testsuite.at: Likewise.

2005-04-04  Paul Eggert  <eggert@cs.ucla.edu>

	* configure.ac (AC_CONFIG_AUX_DIR): Rename from config to build-aux,
	for reasons discussed in the thread beginning at
	<http://lists.gnu.org/archive/html/bug-gnulib/2005-03/msg00119.html>.
	* .cvsignore: Remove config; add build-aux.

	* src/buffer.c (struct zip_magic): Use char arrays, not pointers.
	The unsigned char * pointer ran afoul of pedantic C compilers, and
	we didn't need pointers anyway.  Put the size field before the
	data to avoid unnecessary padding.  All uses changed.
	(magic) Make it const, since it doesn't change.  All uses changed.

2005-04-02  Paul Eggert  <eggert@cs.ucla.edu>

	* src/xheader.c (decode_record): Don't dump core when given
	a corrupted extended header.  Problem reported by Jim Meyering.
	Also, check for other ways that the header might be invalid,
	e.g., missing newline at end.  Do not allow keys with nulls.
	Allow blanks before and after length, as POSIX requires.
	Do not allow leading "-" in length.  Check for length overflow.
	(xheader_decode, xheader_decode_global): Let decode_record
	check for exhaustion of record.
	(xheader_read): Null-terminate the extended record;
	decode_record relies on this.

2005-03-21  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap (TP_URL): Change from
	<http://www2.iro.umontreal.ca/~gnutra/po/maint/tar/> to
	<http://www.iro.umontreal.ca/translation/maint/tar/> to avoid
	some redirection glitches.
	Use "trap - 0" rather than "trap 0" to fix a POSIX-conformance bug.
	* doc/.cvsignore: Change "tar.info" to "tar.info*".  Sort.
	* lib/.cvsignore: Add intprops.h (new gnulib file).

2005-03-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c (print_header): Print UID/GID in case of
	empty user/group name. This could occur when dumping
	files belonging to non-existing users and when listing
	broken archives.
	Reported by Igor Lautar.

	* src/create.c: Correctly parse empty uname/gname
	* src/sparse.c (sparse_scan_file): Bugfix. offset had
	incorrect type.

	* scripts/backup.in: Use `head -n 1'. Provide missing
	argument to ${MT_STATUS}. Proposed by Jan Merka.
	* scripts/backup.sh.in: Likewise. Fixed typo in
	MT_OFFLINE assignment.
	* scripts/restore.in (restore_fs): Use root_fs

2005-02-15  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/create.c: Replace strdup with xstrdup
	* src/names.c: Likewise
	* src/tar.c: Likewise

	* tests/append01.at: Added reference to bug-tar archive
	* tests/listed02.at: Use -print with find.

2005-02-11  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* THANKS: Added Tim Adye. Fixed UTF.
	* src/list.c (read_header): Removed assignment to
	oldgnu_header.isextended. It was breaking append mode.

	* tests/append01.at: New test.
	* tests/Makefile.am: Added append01.at
	* tests/testsuite.at: Likewise

2005-02-06  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* gnulib.modules: New file. List of required gnulib
	modules.
	* bootstrap: Merge list of required modules from
	paxutils with that from tar proper.
	* src/tar.c: Various fixes in help and diagnostic messages.

2005-02-05  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/common.h (EXTRACT_OVER_PIPE): New macro
	* src/compare.c: Code clean up.
	* src/extract.c (extract_archive): Do not check for
	EXTRACT_OVER_PIPE, decode_options() does this.
	* src/misc.c (exec_error,fork_error,dup2_error)
	(pipe_error): Removed unneeded functions.
	* src/system.c (sys_exec_command): Use xclose, xpipe,
	xfork, xdup2 and exec_fatal.
	* src/tar.c (options): Improved sorting. Document --backup=off.
	(decode_options): Clear backup_option if necessary.

2005-02-05  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Initial implementation of --to-command option proposed
	by Hansjoerg Lipp.

	* bootstrap: Get setenv module from gnulib
	* src/buffer.c: Do not use 8-bit chars in comments
	* src/common.h (to_command_option)
	(ignore_command_error_option): New globals
	(sys_exec_command,sys_wait_command): New commands
	* src/extract.c (extract_file): Handle to_command_option
	Fix error recovery: decrease `size' by `written', not
	by `count', otherwise tar misses the next header
	Do not diagnose write error if to_command_option
	is set, since the command may have exited prematurely.
	It would be better to check for sigpipe, though.
	(prepare_to_extract): Handle to_command_option
	* src/misc.c (exec_error, fork_error, dup_error)
	(pipe_error): New functions
	* src/system.c (sys_exec_command)
	(sys_wait_command): New functions
	* src/tar.c: Handle new options --to-command,
	--ignore-command-error
	* THANKS: Added Hansjoerg Lipp

2005-02-03  Paul Eggert  <eggert@cs.ucla.edu>

	* src/list.c (from_header): New arg OCTAL_ONLY, normally false.
	All uses changed.  Fix typo that sometimes suppressed all "Archive
	contains obsolescent base-64 headers" warnings, not just the first
	one.
	(tar_checksum): Accept only octal checksums, since they aren't
	supposed to overflow into weird formats.

	Adjust to gnulib changes.
	* lib/.cvsignore: Add chdir-long.c, chdir-long.h, memrchr.c,
	memrchr.h, openat.c, openat.h.  Remove pathmax.h (added by
	mistake, perhaps?), sysexit.h (my typo), xstrdup.c (gnulib removed
	this file).  Sort entries.

2005-02-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/extract.c: Further rewrite.
	* src/buffer.c: Removed unused variables.
	* src/list.c: Likewise
	* src/tar.c (update_argv): Changed type to void

	* src/common.h (OLDGNU_NAME_FIELD_SIZE): New constant
	* src/create.c (start_private_header,write_header_name)
	(dump_hard_link): Restore compatibility with 1.13.25
	* src/extract.c (extract_archive): Rewritten
	* src/list.c: Add translators' comments
	* src/tar.c (options) Minor spelling fix
	* tests/star/quicktest.sh: Determine path to the tar executable.

2005-02-03  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* po/POTFILES.in: Added tests/genfile.c
	* src/buffer.c (short_read): Use ngettext()
	(new_volume): use quote().
	* src/create.c: Use quote()
	* src/extract.c: Likewise
	* src/xheader.c: Likewise
	* src/misc.c: Add comments to translators

	* tests/same-order01.at: sort ls output
	* tests/sparse01.at (RE_CHECK): Added missing space

	* tests/sparse02.at: Test extracting sparse files over a pipe.
	* tests/Makefile.am: Added sparse02.at
	* tests/testsuite.at: Likewise
	* tests/listed02.at: Skip the test on filesystems that do not
	update ctime of a file when renaming it. To be reverted when
	the new incremental mode is ready.
	* tests/sparse01.at: Extract and compare sparse file

2005-02-02  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/sparse.c: Extract sparse files even if the output
	fd is not seekable.

2005-02-01  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Add a comment to lib/Makefile.am saying that this
	is an autogenerated file.
	Exit with code 1 if any of autotools fails.
	* lib/Makefile.tmpl: Insert Emacs magic to the first line.
	* tests/Makefile.am: Add append.at

	* m4/.cvsignore: Ignore all *.m4 files

2005-01-18  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Rewritten handling of -T (--files-from) option. Now it
	inserts the file names immediately into argv array which allows
	for:
	1) any valid tar options (including another -T) to be used in the file
	2) any number of -T options to be given in command line

	* configure.ac: Raised version number to 1.15.2
	* src/common.h: Include obstack.h
	(files_from_option): Removed
	(unquote_option): New variable
	(stat_fatal): New function
	(name_close): Removed function.
	* src/incremen.c: Remove inclusion of obstack.h
	* src/xheader.c: Likewise.
	* src/misc.c (stat_fatal): New function
	* src/names.c (name_file): Removed variable.
	(read_name_from_file): Removed function. All callers changed.
	(name_close): Removed function. All callers changed.
	* src/tar.c: New options --unquote (--no-unquote) and
	--add-file
	(add_file_id,read_name_from_file,update_argv): New functions
	(parse_opt): Rewritten handling of -T option. Handle hidden
	--HANG option for debugging purposes.
	(decode_options): Init unquote_option to true. Init argv_stk.
	Remove unneeded references to files_from_option

	* doc/tar.texi: Document new options.
	Moved rendition macros and option value definitions into
	separate files
	* doc/rendition.texi: New file
	* doc/value.texi: New file
	* doc/Makefile.am: Updated

2005-01-13  Paul Eggert  <eggert@cs.ucla.edu>

	* tests/testsuite.at (RE_CHECK): Use "join - file", not
	"join file -", to work around a bug in Solaris 8 join.
	Problem reported by Tomohiro Suzuki.

2005-01-13  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c (read_header): Fixed calculation of the
	size for GNU long name/link. Tar was reading one block
	more if name_size was divisible by 512. Thanks Josef
	Bauer.
	* tests/long01.at: New file. Test listing of GNU long names
	divisible by 512.
	* tests/pipe.at: Sort tar output.
	* tests/Makefile.am: Added long01.at
	* tests/testsuite.at: Likewise.
	* THANKS: Added Josef Bauer
	* lib/.cvsignore: Updated
	* m4/.cvsignore: Updated
	* NEWS: Updated

2005-01-11  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* directory: Updated for 1.15.1
	* doc/Makefile.am: Use gendocs.sh to generate web documentation
	* doc/gendocs_template: Template file for gendocs.sh
	* doc/tar.texi: Updated docs for --[no-]same-permissions
	* src/tar.c: Reworded docstrings for --[no-]same-permissions

2005-01-06  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Create m4/paxutils.m4
	* configure.ac: Call tar_PAXUTILS
	* tests/options02.at: Test that tar correctly handles non-option
	arguments interspersed with options.
	* tests/Makefile.am: Add options02.at
	* tests/testsuite.at: Likewise
	* tests/listed02.at: Do not create useless directory

2005-01-05  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.c (parse_opt): Bugfix: Use ARGP_KEY_ARG. Thanks
	Mike Frysinger <vapier@gentoo.org> for reporting.

2005-01-04  Paul Eggert  <eggert@cs.ucla.edu>

	* lib/Makefile.tmpl (localedir.h): Omit needless quotes and a
	needless sed command.  Problem reported by Paul Jarc.

2004-12-23  Paul Eggert  <eggert@cs.ucla.edu>

	Accommodate latest gnulib.
	* doc/.cvsignore: Add getdate.texi.
	* bootstrap: Do not treat alloca-opt specially; this is no
	longer needed (and breaks builds) with latest gnulib.

2004-12-22  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.c (main): Reverted recent changes (#ifdef).

2004-12-21  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Raise version number to 1.15.1
	Check for locale.h
	* NEWS: Entry for 1.15.1
	* src/buffer.c: Bugfix. Changes introduced 2004-11-26
	broke extraction from stdin.
	* src/list.c (from_header, tar_checksum): Changed declaration.
	All callers updated.
	* src/common.h: Likewise
	* src/tar.c (main): Protect invocation of setlocale by
	ifdef.

	* tests/comprec.at: New test
	* tests/pipe.at: New test
	* tests/Makefile.am (comprec.at,pipe.at): New tests
	* tests/testsuite.at: Likewise
	* tests/gzip.at: Use AT_GZIP_PREREQ
	* tests/star/pax-big-10g.at: Likewise
	* tests/star/ustar-big-2g.at: Likewise
	* tests/star/ustar-big-8g.at: Likewise

	* tests/extrac04.at: Discard stderr from sort, on some
	systems it spits out lots of irrelevant info.
	* tests/listed02.at: Likewise

	* doc/index.html.in: Rewritten in xhtml to follow recent
	GNU site standards.
	* THANKS: Updated

2004-12-20  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Released version 1.15. Sources up to this point are
	tagged release_1_15.

	* configure.ac: Raised version number to 1.15
	* NEWS: Likewise
	* directory: Updated
	* bootstrap (update_po): Give -r to wget. Always remove index.html
	Ignore alloca-opt module (it duplicates alloca)

	* tests/Makefile.am: Distribute star/quicktest.sh
	* tests/star/README: Document quicktest.sh
	* tests/star/qucktest.sh: Removed.
	* tests/star/quicktest.sh: New file.

2004-12-18  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* NEWS: Updated
	* doc/tar.texi: Document auto-detection of compressed archive
	formats.
	* src/tar.c (decode_options): Ignore --seek if used with --delete.
	Delete.c is based on the assumption that the archive is being
	actually read, not lseeked.

	* tests/delete05.at: New file
	* tests/extrac02.at: Fixed typo in AT_SETUP
	* tests/Makefile.am: Added delete05.at
	* tests/testsuite.at: Likewise.

2004-12-17  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/delete.c (delete_archive_members): Bugfix: when
	attempting to delete an nonexistent member, the last
	blocking_factor blocks were zeroed.

2004-12-14  Paul Eggert  <eggert@cs.ucla.edu>

	* TODO: Mention sub-second resolution, lutimes, lchmod.

2004-11-27  Paul Eggert  <eggert@cs.ucla.edu>

	Adjust to recent gnulib changes.
	* doc/getdate.texi: Remove, since bootstrap gets it from gnulib now.
	* .cvsignore: Add rmt, rmt/*, rmt/*/*.
	* lib/.cvsignore: Add allocsa.c, allocsa.h, allocsa.valgrind,
	charset.alias, config.charset, getcwd.c, getcwd.h, localcharset.c,
	localcharset.h, ref-add.sed, ref-add.sin, ref-del.sed,
	ref-del.sin, setenv.c, setenv.h, unsetenv.c.  Remove pathmax.h,
	xstrdup.c.
	* m4/.cvsignore: Add allocsa.m4, eealloc.m4, getcwd-path-max.m4,
	localcharset.m4, realloc.m4, setenv.m4.  Remove malloc.m4,
	pathmax.m4, realloc.m4.

2004-11-26  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Raised version number to 1.14.91
	* scripts/tarcat: New file
	* scripts/Makefile.am: Added tarcat
	* src/buffer.c (hit_eof): Changed type to boolean
	(read_full_records,reading_from_pipe): New variables
	(check_compressed_archive,open_compressed_archive): New functions
	(open_archive): Autodetect compressed archives and act accordingly.
	Set reading_from_pipe. This fixes controversial set of changes
	introduced 2004-05-11,2004-03-22.
	* src/list.c (tar_checksum): New function
	(read_header): Use tar_checksum().
	* src/common.h (tar_checksum): New function

	* tests/star/README: Updated
	* NEWS: Updated
	* PORTS: Updated

2004-11-16  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.c (decode_options): Fixed -o semantics. Thanks
	Jean Delvare <khali@linux-fr.org>

2004-10-25  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Add localcharset
	* lib/Makefile.tmpl: Initialize SUFFIXES and CLEANFILES since the
	makefile snippet from localcharset uses '+=' on them.
	* src/Makefile.am (LDADD): Add LIBICONV
	* src/list.c (decode_header): Set uname/gname to NULL if their
	header counterparts are empty
	* src/tar.c (options): Use OPTION_NO_TRANS
	* src/utf8.c: Use locale_charset() from gnulib

	* tests/star/README: Updated

	* NEWS: Updated
	* TODO: Minor fix

2004-10-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* THANKS: Added Bryan Ford
	* doc/Makefile.am (.text): Fixed rule
	* po/POTFILES.in: Added argp-help.c

2004-10-04  Bryan Ford  <baford@mit.edu>

	* src/tar.c: New option --exclude-caches, to exclude
	cache directories automatically on archive creation.
	Cache directories are directories containing a
	standardized tag file, as specified at:
		http://www.brynosaurus.com/cachedir/spec.html
	* src/common.h: New variable exclude_caches_option.
	* src/create.c: New function check_cache_directory(),
	called from dump_dir0() if exclude_caches_option is set,
	to check for a cache directory tag and exclude the directory
	if such a tag is found.
	* doc/tar.texi: Updated accordingly.

2004-09-16  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* doc/tar.texi: Minor fix
	* src/tar.c (options): Minor fix

2004-09-12  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* TODO: Updated
	* lib/Makefile.tmpl: Added 'rtapelib.o: localedir.h' dependency
	* src/common.h: Comment WANT_DIRECTORY_REMOVE_OPTION.
	* src/extract.c: Normalized use of remove_any_file().
	* src/misc.c: Likewise.
	* src/tar.c (parse_opt): Emit warning if -l option is used.
	(show_default_settings): REMOTE_SHELL may be undefined

2004-09-07  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Test suite rewritten in autotest.

	* configure.ac: Updated for autotest
	* src/tar.c (argp_program_version): Modified.
	* tests/Makefile.am: Rewritten for autotest.

	* tests/.cvsignore: Updated
	* tests/append.at: New file
	* tests/atlocal.in: New file
	* tests/delete01.at: New file
	* tests/delete02.at: New file
	* tests/delete03.at: New file
	* tests/delete04.at: New file
	* tests/extrac01.at: New file
	* tests/extrac02.at: New file
	* tests/extrac03.at: New file
	* tests/extrac04.at: New file
	* tests/extrac05.at: New file
	* tests/gzip.at: New file
	* tests/ignfail.at: New file
	* tests/incremental.at: New file
	* tests/link01.at: New file
	* tests/listed01.at: New file
	* tests/listed02.at: New file
	* tests/longv7.at: New file
	* tests/multiv01.at: New file
	* tests/multiv02.at: New file
	* tests/multiv03.at: New file
	* tests/old.at: New file
	* tests/options.at: New file
	* tests/recurse.at: New file
	* tests/same-order01.at: New file
	* tests/same-order02.at: New file
	* tests/sparse01.at: New file
	* tests/testsuite.at: New file
	* tests/version.at: New file
	* tests/volume.at: New file
	* tests/star/gtarfail.at: New file
	* tests/star/gtarfail2.at: New file
	* tests/star/multi-fail.at: New file
	* tests/star/pax-big-10g.at: New file
	* tests/star/ustar-big-2g.at: New file
	* tests/star/ustar-big-8g.at: New file

	* tests/preset.in: Removed
	* tests/before: Removed
	* tests/after: Removed
	* tests/version.sh: Removed.
	* tests/append.sh: Removed.
	* tests/delete01.sh: Removed.
	* tests/delete02.sh: Removed.
	* tests/delete03.sh: Removed.
	* tests/delete04.sh: Removed.
	* tests/extrac01.sh: Removed.
	* tests/extrac02.sh: Removed.
	* tests/extrac03.sh: Removed.
	* tests/extrac04.sh: Removed.
	* tests/extrac05.sh: Removed.
	* tests/gzip.sh: Removed.
	* tests/incremen.sh: Removed.
	* tests/ignfail.sh: Removed.
	* tests/link01.sh: Removed.
	* tests/listed01.sh: Removed.
	* tests/listed02.sh: Removed.
	* tests/longv7.sh: Removed.
	* tests/multiv01.sh: Removed.
	* tests/multiv02.sh: Removed.
	* tests/multiv03.sh: Removed.
	* tests/old.sh: Removed.
	* tests/options.sh: Removed.
	* tests/same-order01.sh: Removed.
	* tests/same-order02.sh: Removed.
	* tests/volume.sh: Removed.
	* tests/recurse.sh: Removed.
	* tests/sparse01.sh: Removed.
	* tests/star/gtarfail.sh: Removed.
	* tests/star/gtarfail2.sh: Removed.
	* tests/star/multi-fail.sh: Removed.
	* tests/star/ustar-big-2g.sh: Removed.
	* tests/star/ustar-big-8g.sh: Removed.
	* tests/star/pax-big-10g.sh: Removed.

2004-09-07  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Install genfile.c from paxutils
	* tests/genfile.c: Removed. Integrated into
	paxutils.
	* tests/mksparse.c: Removed. Integrated into
	(paxutils) genfile.c
	* tests/Makefile.am: Removed mksparse
	* tests/sparse01.sh: Use genfile instead of mksparse

2004-09-06  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Started merging with cpio into paxutils. Sources before
	this point are tagged alpha-1_14_90

	* Makefile.am: Updated for use with paxutils
	* README-alpha: Likewise
	* bootstrap: Likewise
	* configure.ac: Likewise
	* lib/Makefile.tmpl: Likewise
	* po/POTFILES.in: Likewise
	* src/Makefile.am: Likewise
	* src/buffer.c: Likewise
	* src/common.h: Likewise
	* src/compare.c: Likewise
	* src/create.c: Likewise
	* src/delete.c: Likewise
	* src/extract.c: Likewise
	* src/incremen.c: Likewise
	* src/list.c: Likewise
	* src/mangle.c: Likewise
	* src/misc.c: Likewise
	* src/names.c: Likewise
	* src/sparse.c: Likewise
	* src/system.c: Likewise
	* src/tar.c: Likewise
	* src/update.c: Likewise
	* src/utf8.c: Likewise
	* src/xheader.c: Likewise

	* src/system.h: Removed
	* src/rmt.c: Removed
	* src/rmt.h: Removed
	* src/rtapelib.c: Removed

2004-09-03  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* tests/listed02.sh: Do not depend on any particular ordering
	of output.

2004-09-02  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* doc/tar.texi: Document the use of -C option in
	file lists. Document --seek option.
	* configure.ac: New option --with-rmt. New configuration variable
	DEFAULT_RMT_DIR. Removed DEFAULT_RMT_COMMAND.
	* src/Makefile.am: Install rmt into rmtdir
	* src/tar.c (usage): Minor fix.
	* NEWS: Updated.
	* README: Updated.

2004-09-01  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Raised version number to 1.14.90
	* src/common.h (is_individual_file): New prototype
	* src/create.c (dump_file0): Fix bug introduced
	2004-02-21.
	* src/names.c (register_individual_file)
	(is_individual_file): New functions.
	* tests/listed01.sh: Use genfile instead of dd.
	* tests/listed02.sh: New file.
	* tests/Makefile.am: Added listed02.sh

	* NEWS: Updated

2004-08-31  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/sparse.c (sparse_add_map): Fixed improper initializations
	of sparse_map_size. We assume that whatever number it contains
	describes adequately the current size of sparse_map. The only
	number we need to reset is sparse_map_avail.
	* src/compare.c (verify_volume): Call set_next_block_after
	if read_header returns HEADER_FAILURE
	Destroy and reinitialize content of current_stat_info and
	extended_header after each iteration (bug reported by
	John L. Males <jlmales@yahoo.com>).
	Issue a warning if the created archive contains some members
	whose file names were stripped off their leading prefixes.
	This is a temporary fix of the issue reported by Bdale Garbee
	<bdale@gag.com> (Refs: Debian bug 230064, Message-Id
	<87n07kyzhi.fsf@rover.gag.com>, Sun, 15 Feb 2004 11:22:17 -0700)

	* src/names.c (removed_prefixes_p): New function.

	* src/buffer.c: When computing write rate do not take
	into account the time needed to verify the archive(s).
	The bug reported by John L. Males <jlmales@yahoo.com>
	(set_start_time,compute_duration): New functions.
	(print_total_written): Use the result of compute_duration().
	(close_archive): Call compute_duration.
	* src/common.h (set_start_time, removed_prefixes_p): New prototypes.
	* src/list.c (decode_header): Fixed initialization
	of stat_info->is_sparse
	* src/tar.c (main): Call set_start_time().

	* src/misc.c (unquote_string): Unquote '\a' and '\v'.
	Reported by Helmut Waitzmann <helmut.waitzmann@web.de>.

	* NEWS: Updated
	* THANKS: Updated

2004-08-30  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.c: Fix copy-n-paste errors in the license

2004-08-19  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* scripts/backup.in: Renamed LIBPATH to LIBDIR.
	Use ROOT_FS with -C option. Do not send mail
	if ADMINISTRATOR is set to NONE.
	* scripts/backup.sh.in (test_root): Append / to
	ROOT_FS if it does not already end in it.
	* scripts/restore.in: Renamed LIBPATH to LIBDIR.
	New option -a (--all). Do not start restore unless
	-a or patterns are given.
	(restore_fs,restore_files): Fixed use of --listed option.
	* doc/tar.texi: Updated
	* NEWS: Updated

2004-08-17  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.c (find_argp_option): Fixed typo

2004-08-12  Paul Eggert  <eggert@cs.ucla.edu>

	Merge argp, getopt, xalloc changes from gnulib.
	* bootstrap (gnulib_modules): Add xalloc-die.
	Remove code to test for patches; we don't have patches now.
	Set LC_ALL=C so that file names sort consistently.
	Prefer the gnulib copies of gettext.m4, glibc21.m4,
	lib-ld.m4, lib-prefix.m4, po.m4 too.

	* patches/getopt.diff: Remove; gnulib now works unpatched.
	* configure.ac (_getopt_long_only_r): Remove check.
	gl_ARGP now does this for us.
	* lib/.cvsignore: Add fnmatch.h, getopt_.h, sysexit.h,
	xalloc-die.c.
	* src/extract.c: Adjust to changes to gnulib xalloc module.
	(extr_init): Remove assignment to xalloc_fail_func; no longer needed.
	(xalloc_die): New function.

2004-08-10  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* NEWS: Updated

	* src/buffer.c (flush_write): Limit filenames
	of the members that straddle multivolume archive
	boundary to 100 characters.
	(flush_read): Use strncmp when comparing multivolume member
	names.
	* tests/multiv03.sh: New file
	* tests/Makefile.am: Added multiv03.sh

2004-08-09  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c (read_and): Call decode_header before
	calling skip_member()
	(skip_member): Use is_sparse field to determine if the
	member is a sparse file.

	* tests/Makefile.am: Added extrac05.sh
	* tests/extrac05.sh: New file
	* tests/append.sh: Rearranged leading comments. Added explicit
	references to report messages wherever available.
	* tests/delete01.sh: Likewise
	* tests/delete02.sh: Likewise
	* tests/delete03.sh: Likewise
	* tests/delete04.sh: Likewise
	* tests/extrac01.sh: Likewise
	* tests/extrac02.sh: Likewise
	* tests/extrac03.sh: Likewise
	* tests/extrac04.sh: Likewise
	* tests/gzip.sh: Likewise
	* tests/ignfail.sh: Likewise
	* tests/incremen.sh: Likewise
	* tests/link01.sh: Likewise
	* tests/listed01.sh: Likewise
	* tests/longv7.sh: Likewise
	* tests/multiv01.sh: Likewise
	* tests/multiv02.sh: Likewise
	* tests/old.sh: Likewise
	* tests/options.sh: Likewise
	* tests/recurse.sh: Likewise
	* tests/same-order01.sh: Likewise
	* tests/same-order02.sh: Likewise
	* tests/sparse01.sh: Likewise
	* tests/version.sh: Likewise
	* tests/volume.sh: Likewise

2004-08-08  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Extended --update-po option to take an
	optional argument specifying the po file to update.
	* src/create.c: Improved compatibility with 1.13.25
	* tests/link01.sh: New file.
	* tests/Makefile.am: Added link01.sh

2004-08-06  Paul Eggert  <eggert@cs.ucla.edu>

	Merge from gnulib.

	* patches/argp.diff: Remove; no longer needed.

	* lib/.cvsignore: Add stat-macros.h.
	Remove addext.c, malloc.c, realloc.c.

	* src/extract.c: Include <getcwd.h>.
	(extract_archive): Rewrite with new macro IS_ABSOLUTE_FILE_NAME.
	* src/extract.c (make_directories):
	FILESYSTEM_PREFIX_LEN -> FILE_SYSTEM_PREFIX_LEN.
	* src/misc.c (must_be_dot_or_slash): Likewise.
	* src/names.c (excluded_name, safer_name_suffix, stripped_prefix_len):
	Likewise.
	* src/tar.c (parse_opt): Likewise.
	* src/incremen.c (purge_directory): Fix format buffer typos in warning
	strings.
	* src/tar.c (options): Add missing initializers to pacify gcc.
	(decode_options): Remove unused var.

2004-08-02  Paul Eggert  <eggert@cs.ucla.edu>

	* bootstrap (gnulib_modules): Add getpagesize.
	* configure.ac (valloc): Remove check; valloc no longer used.
	* lib/.cvsignore: Add getpagesize.h.
	* m4/.cvsignore: Add getpagesize.m4.
	* src/buffer.c (record_buffer): New var.
	(open_archive): Don't use valloc; on older or buggy hosts, you can't
	free the result.  Use page_aligned_alloc instead.
	* src/compare.c (diff_init): Likewise.
	* src/buffer.c (open_archive): Record the pointer to be freed
	into record_buffer.
	(close_archive): Free record_buffer.
	* src/common.h (page_aligned_alloc): New decl.
	* src/misc.c (quote_n, quote): Remove these redundant functions.
	(ptr_align): New function, from coreutils/src/system.h.
	(page_aligned_alloc): New function.
	* src/system.h (valloc): Remove.

2004-07-09  Paul Eggert  <eggert@cs.ucla.edu>

	* src/extract.c (extract_archive): Do not report an error
	when hard-linking X to X when X exists.  Problem reported by
	Toby Peterson.
	* lib/.cvsignore: Add fchown-stub.c.

2004-06-29  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* NEWS: Updated
	* src/common.h (root_device): New global.
	(gnu_restore): Renamed to purge_directory().
	* src/extract.c (extr_init): Save the device number
	of the root device.
	(extract_archive): Renamed gnu_restore() to purge_directory().
	* src/incremen.c (gnu_restore): Renamed to purge_directory().
	Do not attempt to purge the directory if it is on a different
	device and one_file_system_option is set.

2004-06-25  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* doc/tar.texi: The actual default for exclude patterns
	is --no-anchored. Fixed.
	* src/tar.c (options): Likewise.
	Thanks "Felix Natter" <felix.natter@ldc.de> for noticing.

2004-06-22  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* doc/tar.texi: Fixed several inconsistencies.
	* src/tar.c: Fixed docstring for --checkpoint option.

2004-05-19  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/buffer.c (seek_archive): New function
	* src/common.h (seek_archive): New function
	(seekable_archive): New global.
	* src/list.c (skip_file): Use seek_archive() if
	possible.
	* src/tar.c (struct fmttab): Accept 'pax' as alias
	for 'posix'
	(options): New option -n (--seek).
	* src/update.c: Determine type of the archive before
	appending to it.

	* TODO: Updated.

2004-05-19  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: New option --update-po
	* src/tar.c: New option -H (short alias to --format)
	* doc/tar.texi: Document -H option
 	* src/names.c (safer_name_suffix): Fixed bug introduced
	2004-05-11.

2004-05-16  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Apply patches from patch subdirectory
	* patches: New dir
	* patches/argp.diff: New file
	* patches/getopt.diff: New file
	* configure.ac: Check for _getopt_long_only_r and
	force using included version of getopt if the function
	is not available.
	* src/tar.c: Use argp for command line parsing.
	* src/system.h: Minor formatting fix
	* m4/.cvsignore: Updated
	* lib/.cvsignore: Updated
	* doc/tar.texi: Minor fix.
	* src/extract.c: Fix improper use of 'path' term
	* src/incremen.c: Likewise
	* src/list.c: Likewise
	* src/misc.c: Likewise
	* src/names.c: Likewise
	* src/rmt.h: Likewise
	* src/rtapelib.c: Likewise
	* src/update.c: Likewise
	* src/xheader.c: Likewise
	* tests/star/README: Minor fix

2004-05-13  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Raised version number to 1.14.1
	* src/tar.c: Renamed --strip-path to --strip-components
	Changed improper use of _() to ngettext().
	* src/extract.c: Renamed strip_path_option to strip_components_option
	* src/common.h: Likewise.
	* NEWS: Updated.
	* doc/tar.texi: Updated

2004-05-11  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/system.c (sys_child_open_for_uncompress): Do not
	set read_full_records_option: the compressed archive is
	likely not to contain integer number of records. Should
	the user wish to use reblocking, he may always give tar
	-B option. This is a minor improvement over the change
	dated 2004-03-22.
	* src/buffer.c (open_archive): Removed assignment to
	read_full_records_option.

	* src/names.c (safer_name_suffix): (safer_name_suffix): Use "%s"
	as the format argument, rather than a possibly-translated variable
	string. Patch provided by Jim Meyering  <jim@meyering.net>
	* src/tar.c (decode_options): Fixed typo in the comment.
	* tests/star/README: Minor correction

2004-05-11  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* directory: New file. GNU directory entry for tar.
	* doc/Makefile.am: Rewritten. Added rules for generating
	documentation for the project's website.
	* doc/.cvsignore: Updated
	* doc/index.html.in: New file.

2004-05-11  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Raised version number to 1.14
	* NEWS: Updated.
	* tests/after: Added copyleft statement
	* tests/before: Added copyleft statement
	* tests/preset.in: Added copyleft statement

	Tar 1.14 is released. Sources up to this point are tagged
	release_1_14

2004-05-10  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Fixed prerequisite headers for sys/buf.h
	(needed on FreeBSD)
	* src/system.h: Likewise.
	* tests/after (compare): Fixed argument quoting under eval
	* tests/before: Quote TAR_ARCHIVE_FORMATS

2004-05-10  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* NEWS: Updated
	* README: Updated
	* PORTS: Updated
	* configure.ac: Call gl_AC_TYPE_INTMAX_T. Document
	DEFAULT_.* variables. Use DEFAULT_RMT_COMMAND to set
	the pathname of the rmt utility.
	New option --enable-backup-scripts.
	* doc/tar.texi: Updated
	* scripts/Makefile.am: Install the scripts only if requested
	by the configure.
	* scripts/backup.in: Fixed --version output.
	Fixed initialization of the listing files and printing
	the time of the last previous level dump.
	* scripts/restore.in: Fixed --version output.
	* src/Makefile.am (localedir.h rule): Generate correct
	DEFAULT_RMT_COMMAND variable.
	* src/common.h (rmt_command_option): New variable.
	* src/list.c (read_and): Print block number before
	issuing 'Skipping to next header' diagnostics, if
	requested by block_number_option.
	* src/rtapelib.c: Use rmt_command_option instead of
	hardcoded "/etc/rmt".
	* src/tar.c: New option --rmt-command.
	(decode_options): Handle --rmt-command. Initialize
	rmt_command_option to DEFAULT_RMT_COMMAND.

2004-05-09  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* doc/tar.texi: Further update.

2004-05-08  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Minor fix
	* scripts/Makefile.am: Updated
	* scripts/backup-specs: Updated
	* scripts/backup.in: Minor fixes
	* scripts/backup.sh: Removed
	* scripts/backup.sh.in: New file. Source for backup.sh
	* scripts/restore.in: New file
	* scripts/.cvsignore: Updated
	* scripts/WARNING: Removed
	* doc/tar.texi: Updated
	* NEWS: Updated

2004-05-07  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/names.c (name_gather): Bugfix: Honor single -C with
	--same-order.
	* tests/same-order01.sh: New file
	* tests/same-order02.sh: New file
	* tests/Makefile.am: Updated

	* tests/append.sh: Added copyleft header
	* tests/delete01.sh: Likewise
	* tests/delete02.sh: Likewise
	* tests/delete04.sh: Likewise
	* tests/extrac01.sh: Likewise
	* tests/extrac02.sh: Likewise
	* tests/extrac03.sh: Likewise
	* tests/extrac04.sh: Likewise
	* tests/gzip.sh: Likewise
	* tests/ignfail.sh: Likewise
	* tests/incremen.sh: Likewise
	* tests/multiv01.sh: Likewise
	* tests/old.sh: Likewise
	* tests/options.sh: Likewise
	* tests/recurse.sh: Likewise
	* tests/version.sh: Likewise
	* tests/volume.sh: Likewise
	* tests/star/gtarfail.sh: Likewise
	* tests/star/gtarfail2.sh: Likewise
	* tests/star/multi-fail.sh: Likewise
	* tests/star/pax-big-10g.sh: Likewise
	* tests/star/qucktest.sh: Likewise
	* tests/star/ustar-big-2g.sh: Likewise
	* tests/star/ustar-big-8g.sh: Likewise

	* doc/.cvsignore: Updated

2004-05-06  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Check whether date accepts +format argument
	(for backup scripts).
	* scripts/level-0: Removed
	* scripts/level-1: Removed
	* scripts/weekly.new: Removed
	* scripts/dump-remind: Removed
	* scripts/backup.in: New file
	* scripts/backup.sh: New file
	* scripts/dump-remind.in: New file
	* scripts/backup-specs: Updated
	* scripts/Makefile.am: Updated for new directory contents.
	* scripts/.cvsignore: Updated

2004-05-05  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* TODO: Updated
	* doc/tar.texi:	Updated
	* src/tar.c: --utc implies -vv

2004-04-28  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/utf8.c: Make sure ICONV_CONST is defined. AM_ICONV
	does not define it if it fails to find iconv.h.

2004-04-26  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Use gnulib-tool to generate lib/Makefile.am
	and parts of configure.ac
	* configure.ac: Invoke tar_GNULIB to configure gnulib stuff.
	* lib/Makefile.am: Removed
	* lib/Makefile.tmpl: New file.
	* lib/.cvsignore: Updated
	* m4/.cvsignore: Updated
	* src/xheader.c: Include stpcpy.h

	* src/create.c: Produce an error, not warning, if the
	filename is too long.
	* tests/longv7.sh: Synchronized with the recent changes.

2004-04-20  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Fixed test for iconv_t
	* src/rmt.h: Bugfix by Jürgen Weigert
	* THANKS: Add Jürgen Weigert
	* tests/star/README: Fixed typo

2004-04-04  Paul Eggert  <eggert@twinsun.com>

	Merge getdate documentation changes from coreutils.

	* doc/getdate.texi: Update from coreutils CVS.
	* doc/tar.texi: Fix getdate menu to match getdate.texi's.

	Merge recent gnulib changes, and remove some lint.

	Improve support for nanosecond-resolution time stamps.
	* bootstrap: Add gettime, timespec modules.
	* configure.ac (gl_GETTIME, gl_TIMESPEC): Add.
	* lib/.cvsignore (getopt_int.h, gettime.c, gettimeofday.c,
	timespec.h): Add.
	* lib/Makefile.am (libtar_a_SOURCES): Add gettime.c, timespec.h.
	* m4/.cvsignore: Add clock_time.m4, gettime.m4, gettimeofday.m4,
	st_mtim.m4, timespec.m4.  Remove malloc.m4, realloc.m4.
	* src/common.h (newer_mtime_option): Now a struct timespec, not
	time_t.  All uses changed.
	(NEWER_OPTION_INITIALIZED, OLDER_STAT_MTIME): New macros.
	* src/create.c (dump_file0): Use OLDER_STAT_TIME to compare times.
	* src/incremen.c (scan_path): Likewise.
	* src/list.c (read_and): Likewise.
	* src/list.c (read_and): Use NEWER_OPTION_INITIALIZED to decide
	whether newer_mtime_option is initialized.
	* src/tar.c (decode_options): Likewise.
	* src/tar.c (decode_options): Adjust to new signature for get_date.

	* src/buffer.c (short_read, flush_read): Use size_t, not ssize_t, for
	result of safe_read, full_write, and similar functions.
	Detect safe_read error by comparing to SAFE_READ_ERROR;
	detect full_write error by comparing to 0.
	All uses changed.
	* src/common.h (write_error_details, sys_write_archive_buffer):
	Likewise.
	* src/misc.c (write_error_details): Likewise.
	* src/rmt.c (main): Likewise.
	* src/rmt.h (rmt_read__, rmt_write__): Likewise.
	* src/rtapelib.c (rmt_read__, rmt_write__, rmt_ioctl__): Likewise.
	* src/sparse.c (sparse_scan_file, sparse_dump_region,
	check_sparse_region, check_data_region): Likewise.
	* src/system.c (sys_write_archive_buffer, sys_drain_input_pipe,
	sys_child_open_for_compress, sys_child_open_for_uncompress): Likewise.
	* src/update.c (append_file): Likewise.

	* src/buffer.c (clear_read_error_count): Use explicit (void)
	to indicate a function with no arguments.
	* src/create.c (check_links): Likewise.
	* src/system.c (sys_get_archive_stat, sys_save_archive_dev_ino,
	sys_detect_dev_null_output, sys_drain_input_pipe, sys_spawn_shell,
	sys_reset_uid_gid, sys_get_archive_stat, sys_save_archive_dev_ino,
	sys_detect_dev_null_output, sys_drain_input_pipe, sys_spawn_shell):
	Likewise.
	* src/utf8.c (get_input_charset): Likewise.
	* src/xheader.c (xheader_ghdr_name, xheader_write_global,
	xheader_decode_global, extended_header_init): Likewise.
	* tests/mksparse.c (usage): Likewise.

	* src/buffer.c (new_volume): Rename local variables to avoid
	shadowing warnings.
	* src/common.h (file_dumpable_p, sys_stat_nanoseconds,
	sparse_file_p, sparse_member_p, sparse_fixup_header,
	sparse_dump_file, sparce_extract_file, sparse_skip_file,
	sparse_diff_file): Likewise.
	* src/compare.c (diff_archive): Likewise.
	* src/create.c (file_dumpable_p, dump_regular_file, dump_dir0,
	dump_dir, dump_hard_link, file_count_links, dump_file0, dump_file):
	Likewise.
	* src/extract.c (repair_delayed_set_stat): Likewise.
	* src/misc.c (maybe_backup_file, add_hierarchy_to_namelist):
	Likewise.
	* src/sparse.c (struct tar_sparse_optab, tar_sparse_dump_region,
	tar_sparse_extract_region, sparse_dump_region, sparse_extract_region,
	sparse_dump_file, sparse_file_p, sparse_member_p,
	sparse_fixup_header, sparse_extract_file, sparse_skip_file,
	check_data_region, sparse_diff_file): Likewise.
	* src/system.c (sys_stat_nanoseconds): Likewise.
	* src/xheader.c (xheader_format_name): Likewise.

	* src/common.h (enum old_files): Remove comma before }; not portable.

	* src/common.h (read_fatal_details): Add __attribute__ ((noreturn)).
	* src/rmt.c (usage): Likewise.
	* src/xheader.c (xheader_set_single_keyword): Likewise.
	* tests/genfile.c (usage): Likewise.
	* tests/mksparse.c (die, usage): Likewise.  Also add printf attribute
	to die.

	* src/common.h (gname_to_gid, uname_to_uid): Add const to avoid
	some gcc warnings.
	* src/names.c (uname_to_uid, gname_to_gid): Likewise.
	* src/utf8.c (struct langtab.lang, struct langtab.terr, struct
	langtab.charset, charset_lookup): Likewise.

	* src/common.h (name_init): Remove unused args.  All callers changed.
	* src/names.c (name_init): Likewise.

	* src/common.h (usage, xheader_write, xheader_write_global,
	sys_reset_uid_gid): New decls.

	* src/compare.c (report_difference, process_noop): Add
	__attribute__ ((unused)) for unused attributes.
	* src/sparse.c (oldgnu_sparse_member_p, star_sparse_member_p):
	Likewise.
	* src/xheader.c (dummy_coder, dummy_decoder, atime_coder,
	gid_coder, gname_coder, linkpath_coder, ctime_coder, mtime_coder,
	path_coder, size_coder, uid_coder, uname_coder,
	sparse_numblocks_coder): Likewise.

	* src/create.c (dump_regular_finish, dump_dir0, dump_dir,
	dump_file0): Now static.
	* src/utf8.c (charset_lookup): Likewise.
	* src/xheader.c (xheader_protected_pattern_p,
	xheader_protected_keyword_p, xheader_set_single_keyword,
	xheader_keyword_deleted_p, xheader_keyword_override_p,
	xheader_list_append, xheader_list_destroy, xheader_set_keyword_equal):
	Likewise.
	* tests/genfile.c (usage): Likewise.
	* tests/mksparse.c (die, mkhole, mksparse, usage, xlat_suffix):
	Likewise.

	* src/create.c (hash_link): Rewrite to avoid cast.

	* src/extract.c (file_newer_p): Use parameter, not global var.
	* src/misc.c (write_error_details): Likewise.

	* src/extract.c (prepare_to_extract): Remove directory arg; not
	used.  All callers changed.

	* src/misc.c (close_fatal): Remove; not used.
	* src/system.c (sys_utimes): Likewise.

	* src/rmt.c (get_string): Avoid buffer overrun (off by 1 error).

	* src/rmt.c (main): Update copyright date to 2004.
	* src/tar.c (decode_options): Likewise.

	* src/rtapelib.c (get_status_string): Don't lose errno when
	skipping the error messages.
	(get_status): Report an error if atol returns a negative number.

	* src/utf8.c (struct langtab, langtab, charset_lookup,
	get_input_charset) [!defined HAVE_LIBCONV]: Omit unused
	definitions.
	(iconv_open, iconv, iconv_close) [!defined HAVE_LIBCONV]:
	Use macros, not definitions, to avoid type clashes with system
	headers.
	(charset_lookup): Local var is now auto, not static.
	(utf8_convert): Use ICONV_CONST instead of const, to avoid
	type clashes.

	* src/utf8.c (langtab): Initialize all elements of struct, to
	avoid gcc warning.
	* src/xheader.c (xhdr_tab): Likewise.

	* src/xheader.c: Include fnmatch.h, since we use fnmatch.

	* tests/mksparse.c (mkhole): Fix typo: bool was assigned to off_t.

2004-04-04  Sergey Poznyakoff  <gray@Noldor.runasimi.org>

	* NEWS: Updated
	* configure.ac: Raised version number to 1.13.94
	* src/system.h: Protect inclusion of <sys/time.h>
	by ifdef.
	Declare time() if HAVE_DECL_TIME is 0
	* tests/.cvsignore: Added mksparse

	* tests/sparse01.sh: New file
	* tests/multiv02.sh: New file
	* tests/Makefile.am: Add sparse01.sh and multiv02.sh
	* tests/longv7.sh: Added missing call to 'after'

	* src/common.h: Added missing prototypes
	* src/compare.c (diff_archive): Use is_sparse member
	instead of GNUTYPE_SPARSE.
	* src/create.c: Removed unused variables
	* src/extract.c (extract_archive): Use sparse_member_p instead
	of GNUTYPE_SPARSE.
	Removed unused variables
	* src/list.c (decode_header): Use sparse_fixup_header to correct
	the st_size value.
	(print_header): Do not rely on GNUTYPE_SPARSE type.
	Use st->stat.st_size to print real file size.
	(skip_member): Assign stat_info.file_name to save_name. This fixes
	bug reported by Mads Martin Joergensen <mmj@suse.de>
	Use sparse_skip_file() to skip sparse members.
	* src/rtapelib.c: include "common.h"
	* src/sparse.c (struct tar_sparse_optab.sparse_member_p)
	(struct tar_sparse_optab.fixup_header): New member
	(tar_sparse_member_p): New function.
	(tar_sparse_init): Return true if decode_header is not provided
	(tar_sparse_fixup_header)
	(sparse_member_p,sparse_fixup_header)
	(sparse_skip_file)
	(oldgnu_sparse_member_p,oldgnu_fixup_header,star_sparse_member_p)
	(star_fixup_header, pax_sparse_member_p): New function
	(pax_decode_header): Remove
	* src/system.h: Include <sys/time.h> and <utime.h> when available
	* src/tar.c (usage): Prototype moved to common.h
	* src/tar.h (struct tar_stat_info.is_sparse): New member
	* src/utf8.c (utf8_convert): Changed prototype
	(get_input_charset): Removed unused variable
	* src/xheader.c: include <fnmatch.h>
	(size_decoder): Assign to both st->archive_file_size and
	st->stat.st_size.
	(st->stat.st_size): Assign to st->stat.st_size
	(sparse_numbytes_decoder): Removed unused variable
	* src/.cvsignore: Added .gdbinit
	* THANKS: Added Mads Martin Joergensen

2004-03-26  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/create.c (write_long_name): Do not allow more than
	NAME_FIELD_SIZE-1 characters in a file name for V7 format
	archives.
	* tests/longv7.sh: New file.
	* tests/Makefile.am: Add longv7.sh

2004-03-22  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/buffer.c (open_archive): Clear read_full_records_option
	if reading from a pipe.
	(short_read): Display warning about the deduced record size
	if version > 1
	* tests/star/pax-big-10g.sh: Updated to match the above changes.
	* tests/star/ustar-big-2g.sh: Likewise.
	* tests/star/ustar-big-8g.sh: Likewise.

	* configure.ac: Added gl_FUNC_STRTOULL
	* src/create.c (start_header): Check for GNU_FORMAT
	if incremental_option is set.
	* src/xheader.c (to_decimal): New function.
	(xheader_format_name): Use to_decimal() instead of snprintf.
	* tests/listed01.sh: Use genfile instead of dd
	* tests/multiv01.sh: Likewise.

2004-03-12  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c (read_and): Stop processing the archive after
	encountering a single zero record. Many old archives contain
	arbitrary garbage after it.
	The warning is issued anyway.

2004-03-02  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/rtapelib.c (rmt_lseek__,rmt_ioctl__): Bugfix. The
	conversion buffer was not null terminated. Fix provided
	by Leland Lucius <llucius@tiny.net>
	* THANKS: Added Leland Lucius
	* src/utf8.c (utf8_convert): Indentation fix.

2004-02-29  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/buffer.c (flush_read): Bugfix: the
	condition at line 714 included

	      || (status > 0 && !read_full_records_option)

	which is grossly wrong, since even if new_volume() below succeeds,
	the subsequent call to rmtread will overwrite the chunk of data
	already read in the buffer and thus spoil everything.
	* src/system.c (sys_child_open_for_uncompress): Minor stylistic
	fix.
	* tests/star/multi-fail.sh: New test.
	* tests/Makefile.am: Added multi-fail.sh
	* tests/star/README: Updated

2004-02-29  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* NEWS: Updated
	* configure.ac: Removed spurious AC_CHECK_LIB(iconv)
	* src/common.h (utc_option): new global
	(enum old_files.KEEP_NEWER_FILES): New element
	* src/extract.c: Handle --keep-newer-files option
	* src/list.c (tartime): Print UTC if --utc was given.
	* src/tar.c: New options: --utc and keep-newer-files

	* tests/Makefile.am: Added new tests
	* tests/after: Rewritten
	* tests/before: Rewritten
	* tests/preset.in: Rewritten
	* tests/delete03.sh: Accommodate for the new testsuite logic
	* tests/gzip.sh: Likewise
	* tests/incremen.sh: Likewise
	* tests/listed01.sh: Likewise
	* tests/multiv01.sh: Likewise
	* tests/old.sh: Likewise
	* tests/options.sh: Likewise
	* tests/version.sh: Likewise
	* tests/volume.sh: Likewise

	* tests/star: New directory
	* tests/star/README: New file
	* tests/star/gtarfail.sh: New file
	* tests/star/gtarfail2.sh: New file
	* tests/star/pax-big-10g.sh: New file
	* tests/star/qucktest.sh: New file
	* tests/star/ustar-big-2g.sh: New file
	* tests/star/ustar-big-8g.sh: New file

2004-02-26  Paul Eggert  <eggert@twinsun.com>

	* doc/tar.texi (dircategory Individual utilities): Append period,
	as suggested by Karl Berry.

2004-02-24  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c (decode_header): Call xheader_decode before
	the assignment to current_stat_info.archive_file_size.

2004-02-23  Paul Eggert  <eggert@twinsun.com>

	* configure.ac: Invoke AM_ICONV, to define ICONV_CONST if needed.

2004-02-23  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	1.13.93 released.

	* NEWS: Updated
	* tests/before: Move testing of the prerequisite archive formats
	to the separate function 'prereq'. Do not expect any arguments
	* tests/delete03.sh: Use prereq() instead of passing arguments
	to 'before'.
	* tests/incremen.sh: Likewise.
	* tests/listed01.sh: Likewise.
	* tests/multiv01.sh: Likewise.

2004-02-22  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Added UTF-8 support. Finished global extended header
	support.

	* NEWS: Minor fix
	* configure.ac: Detect libiconv
	* src/utf8.c: New file. Conversions to and from utf-8.
	* src/Makefile.am: Added utf8.c
	* src/create.c (write_header_name) In pax format, use
	"path" keyword if the file name is not ASCII
	(start_header): Likewise for uname and gname.
	* src/list.c: Decode encountered global headers.
	* src/xheader.c: Use keywords from the global
	headers.
	Correctly handle UTF-8 conversions.
	(xheader_list_destroy): New function.
	(xheader_set_single_keyword,xheader_set_keyword_equal): Added
	missing gettext markers
	(decode_record): Rewritten using caller-provided handler and
	data closure.
	* tests/listed01.sh: Give credit to Andreas Schuldei.

2004-02-21  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/create.c (dump_file0): The conditional at line
	1296 prevented incremental backups on individual files
	from working, as reported by Andreas Schuldei
	<andreas@schuldei.org>.

	This is due to the condition

	  (0 < top_level || !incremental_option)

	Removing it makes incremental backups work for individual
	files as well as for directories. On the other hand, it does
	not affect other functionality, as shown by the reasoning below:

	To begin with, the two parts of this condition are mutually
	superfluous, because

	  1) when top_level < 0, incremental_option == 1
	  so the condition yields false
	  2) when top_level >= 0, incremental_option == 0
	  so the condition yields true.

	In other words, it is completely equivalent to

	      (!incremental_option)

	Now, let's consider the effect of its removal. There are two cases:

	1) when incremental_option==1
	This means incremental backup in progress. In this case dump_file
	is invoked only for directories or for files marked with 'Y' by
	get_directory_contents. The latter are those that did not meet the
	condition in incremen.c:242, which is exactly the same condition
	as this at create.c:1296. So, for these files the check
	(!incremental_option) is useless, since the rest of the
	conditional will yield false anyway. On the other hand, if
	dump_file is invoked on a directory, the conditional will yield
	false due to !S_ISDIR assertion, so these will be processed as usual.

	Thus, for this case the extra condition (!incremental_option) is
	irrelevant, and its removal won't alter the behavior of tar,
	*except* that it will enable incremental backups on individual
	files, which is the wanted effect.

	2) when incremental_option==0
	In this case the condition yields true and its removal does not
	affect the functionality.

	* THANKS: Updated
	* configure.ac: Raised patchlevel to 93
	* src/incremen.c: Minor stylistic fixes.
	* tests/listed01.sh: New test. Check listed incremental
	backups on individual files.
	* tests/Makefile.am: Added listed01.sh

2004-02-20  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/common.h (simple_finish_header,start_private_header): New
	declarations
	(xheader_ghdr_name): Changed declaration
	* src/create.c (start_private_header): Removed static qualifier.
	(write_extended): Removed superfluous last argument. Use
	xheader_write()
	(simple_finish_header): New function.
	(finish_header): Use simple_finish_header() to break recursive
	dependency between this function and write_extended().
	* src/tar.c (assert_format): Do not bail out if several
	--format arguments are given. This is a common case when
	TAR_OPTIONS are used.
	(decode_options): New option --show-defaults displays the
	compiled-in defaults.
	Use POSIX format if no --format option was given and
	--pax-option was specified.
	Do not allow to use --pax-option unless the archive format is
	set to POSIX (or reading subcommand is requested).

	* src/update.c (update_archive): Write global extended header if
	constructed.
	* src/xheader.c (xheader_format_name): Bugfix.
	(xheader_xhdr_name): Changed the default extended header name
	to '%d/PaxHeaders.%p/%f', as POSIX requires.
	(xheader_ghdr_name): Removed unused argument.
	(xheader_write,xheader_write_global): New function.
	(xheader_decode): Modified to honor overrides whatever
	the current archive format is.

	* src/delete.c (delete_archive_members): Call xheader_decode
	unconditionally.
	* src/list.c (decode_header): Likewise.
	* src/incremen.c (sort_obstack): Fixed typo in the comment

	* doc/tar.texi: Document new default for extended
	header names.

	* tests/before: Accept an optional list of allowed archive
	formats. Exit with the status 77 if the current archive
	format does not match any of them.
	* tests/delete03.sh: Require gnu, oldgnu or posix format
	* tests/incremen.sh: Require gnu or oldgnu format
	* tests/multiv01.sh: Likewise

2004-02-20  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* doc/tar.texi (Option Summary): Documented --pax-option
	* src/tar.c: Likewise.
	* NEWS: Likewise.
	* src/create.c (to_chars): Added a comment.
	* src/tar.h: Comment to GNU_FORMAT

2004-02-18  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* README: Updated
	* configure.ac: Added stpcpy
	* bootstrap: Likewise
	* lib/Makefile.am: Likewise
	* src/common.h (xheader_xhdr_name,xheader_ghdr_name): New
	functions
	* src/create.c (write_extended): Call xheader_xhdr_name
	instead of using hardcoded "././@PaxHeader" name.
	* src/tar.c: New option --pax-option (equivalent to -o option
	of pax).
	* src/xheader.c: Implement pax -o option. Fixed misleading
	heading comment (introduced 2003-09-02).
	* src/incremen.c: Minor fixes
	* m4/.cvsignore: Updated

2004-02-17  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/incremen.c: Removed accumulator stuff in favor of obstack.
	(get_directory_contents): Split into two functions
	* src/update.c: Minor changes
	* doc/tar.texi: Fixed typo

2004-02-15  Paul Eggert  <eggert@twinsun.com>

	Fix Debian bug 230872, originally reported by Jeff King in
	<http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=230872>.

	* doc/tar.texi (posix compliance): Remove.  The whole section
	was a misunderstanding of what POSIXLY_CORRECT is supposed to
	mean.  The GNU Coding Standards says that POSIXLY_CORRECT
	is for disabling extensions that are incompatible with POSIX:
	it is not for disabling compatible extensions.  All references
	to this section removed.
	(posix): This format is created only if the posix format is
	specified; it is no longer created if gnu format is specified
	and POSIXLY_CORRECT is set.
	* src/tar.c (decode_options): Ignore POSIXLY_CORRECT.
	POSIX does not specify the behavior of tar, so we should
	not worry about POSIXLY_CORRECT here.

2004-01-21  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* Makefile.am: Removed m4
	* configure.ac: Require automake-1.8/autoconf-2.59. Removed
	m4/Makefile.
	* README-alpha: Updated
	* bootstrap: Updated TP URL, improved help output. Default
	to :ext:anoncvs and set CVS_RSH, unless already set.
	* m4/Makefile.am: Removed

2004-01-21  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Bugfix by Marco Gerards <metgerards@student.han.nl>:
	Use $option instead of $1 so all options will be parsed.

2004-01-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Started rewriting buffer.c ...

	* bootstrap: New option --no-po
	* src/buffer.c (new_volume,check_label_pattern): Changed return type.
	(time_to_start_writing): Changed data type
	(file_to_switch_to): Removed. Variable never assigned to.
	(open_archive) Moved option compatibility checks to tar.c
	Other minor changes.
	* src/common.h (maybe_backup_file): Changed return type
	* src/misc.c: Likewise.
	* src/create.c: Updated invocations of safer_name_suffix
	* src/extract.c: Likewise
	* src/delete.c: Updated assignment to write_archive_to_stdout
	* src/tar.c (decode_options): More option compatibility checks
	(moved from buffer.c)
	* src/update.c (time_to_start_writing): Changed data type.
	* tests/recurse.sh: New test case.
	* tests/mksparse.c: New file.
	* tests/Makefile.am: Added recurse.sh and mksparse.c

2004-01-02  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/sparse.c (sparse_diff_file): Bugfix. Thanks
	Martin Simmons for the patch.
	* src/create.c (dump_dir0): Bugfix. Thanks Piotr Czerwinski
	<pius@pld-linux.org> for the patch.

2003-12-26  Paul Eggert  <eggert@twinsun.com>

	Synchronize with Gettext 0.13.1, Automake 1.8, Autoconf 2.59,
	and translation website.

	* bootstrap: Don't bother skipping codeset.m4, glibc21.m4,
	intdiv0.m4, inttypes_h.m4, inttypes.m4, inttypes-pri.m4,
	isc-posix.m4, and lcmessage.m4 from gnulib.  This list of files is
	a bit obsolete anyway, now that gettext 0.13.1 is out.  Also, the
	files are replaced by autoreconf.  Also, there seems to be a bug
	in gettext/autoconf/automake if we try to omit these files after
	autoreconf has replaced them, even though the gettext manual says
	they're optional.  So give up and just include them for now, even
	though they make 'configure' longer and slower.

	Change translation URL from
	<http://www.iro.umontreal.ca/contrib/po/maint/tar/> to
	<http://www2.iro.umontreal.ca/~gnutra/po/maint/tar/> to
	accommodate translator website revamp.

	Fail if autoreconf fails.

	* m4/.cvsignore: Add intmax.m4, longdouble.m4, printf-posix.m4,
	signed.m4, size_max.m4, wchar_t.m4, wint_t.m4, xsize.m4, to
	ignore files now supplied by gettext 0.13.1.

2003-12-25  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Synchronized with the backup repository on Mirddin

2003-12-19  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Check for varios members of struct stat
	that may represent file modification times with a subsecond
	precision.
	Check for utimes (for future use)
	* src/buffer.c (short_read): Issue a warning on short reads.
	* src/common.h (sys_stat_nanoseconds): New function
	* src/create.c (dump_file0): Use sys_stat_nanoseconds().
	* src/list.c (read_and): Treat only two successive zero
	filled blocks as an EOF indicator. Issue a warning if
	a single one is encountered.
	* src/system.c (sys_stat_nanoseconds): New function
	* src/tar.h (tar_stat_info.atime_nsec,mtime_nsec,ctime_nsec): New
	members.
	* src/xheader.c (code_time,decode_time): Support for subsecond
	precision.
	(atime_coder,atime_decoder,ctime_coder,ctime_decoder)
	(mtime_coder,mtime_decoder): Update invocations of code_time and
	decode_time.
	(gid_decoder,size_decoder,uid_decoder,sparse_size_decoder)
	(sparse_numblocks_decoder,sparse_offset_decoder)
	(sparse_numbytes_decoder): Updated

2003-12-18  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/names.c (safer_name_suffix): Reverted change made
	2003-11-14. Reason: Discussion with Paul Eggert and
	Jean-Louis Martineau. See also ChangeLog entry from
	1999-08-14.
	* tests/delete03.sh: Likewise.
	* tests/extrac04.sh: Likewise.
	* tests/multiv01.sh: Likewise.

2003-12-12  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/incremen.c (write_directory_file): Use sys_truncate
	* src/list.c (print_header): Use archive_file_size member
	when printing real file size.
	* src/sparse.c (sparse_scan_file): Correctly handle files with
	a hole at the end.
	(sparse_dump_region,sparse_extract_region): Allow for zero size
	trailing blocks

2003-12-12  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Raised version number to 1.13.92
	* src/list.c (decode_header): Discern between pax and ustar
	formats
	Initialize current_stat_info.archive_file_size.

	NOTE: Modifications from this date on are temporarily
	stored on local CVS on mirddin. This repository will
	be synchronized with Savannah as soon as the latter
	becomes operational again.

2003-12-01  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* TODO: Updated
	* src/sparse.c: Initial implementation of GNU/pax sparse
	file format.
	* src/common.h (xheader_store): Changed prototype.
	* src/create.c: Update calls to xheader_store
	* src/extract.c (extract_archive): Check reported size vs.
	archive file size to determine if we have to do with a
	sparse file.
	* src/tar.c (usage): Cleaned up the sample argument to --newer
	option.
	(decode_options): Allow --sparse for POSIX_FORMAT archives.
	* src/xheader.c (struct xhdr_tab.coder; all coder function): Added
	extra argument
	Implemented GNU.sparse.* keywords.

2003-11-30  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Check for setlocale. Thanks Bruno Haible for
	reporting.

2003-11-25  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/create.c (write_gnu_long_link): Use oldgnu
	magic with @LongLink blocks.

2003-11-17  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.h: Support for star sparse format.
	* src/sparse.c: Likewise.

2003-11-17  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/sparse.c (sparse_diff_file): New function
	* src/common.h (sys_compare_uid,sys_compare_gid): New functions
	(sys_compare_uid_gid): Removed.
	(sys_compare_links,report_difference): Changed prototype
	(sparse_diff_file): New function
	* src/system.c (sys_compare_uid,sys_compare_gid): New functions
	(sys_compare_uid_gid): Removed.
	(sys_compare_links): Changed declaration
	* src/compare.c (diff_archive): Use sparse_diff_file.

2003-11-16  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Rewritten sparse file handling.

	* src/sparse.c: New file. Provides a universal framework
	for various methods for sparse files handling.
	* src/Makefile.am: Added sparse.c
	* src/common.h (struct sp_array,sparsearray,sp_array_size)
	(init_sparsearray,fill_in_sparse_array): Removed
	(enum dump_status): New data type
	(pad_archive,close_diag,open_diag,read_diag_details)
	(readlink_diag,savedir_diag,seek_diag_details,stat_diag): New
	functions.
	(sparse_file_p,sparse_dump_file,sparse_extract_file): New
	functions.
	(print_header): Changed prototype declaration.
	* src/tar.h (struct sp_array): Declaration from common.h
	(struct tar_stat_info): New members archive_file_size,
	sparse_map_avail,sparse_map.
	* src/create.c: Major rewrite.
	* src/extract.c: Use new sparse file interface.
	* src/compare.c (diff_sparse_files): Temporary placeholder.

	* src/buffer.c: Minor changes
	* src/tar.c: Likewise.
	* src/list.c: Likewise.
	* src/misc.c (close_diag,open_diag,read_diag_details)
	(readlink_diag,savedir_diag,seek_diag_details,stat_diag): New
	diagnostics functions.
	* src/incremen.c: Use new diagnostics functions.
	* src/names.c: Likewise.

2003-11-14  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Fixed check for setsockopt

	* src/create.c: Do not zero-terminate name field if
	the name is exactly 100 characters long.
	(write_ustar_long_name): Fixed cheking for unsplittable
	names.

2003-11-14  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/create.c (start_header): Removed debugging hook
	(dump_file): Fixed handling of linkname field.
	* src/names.c (safer_name_suffix): If the input
	file name ends with a slash, output one should do so
	as well.
	* doc/tar.texi: Documented --format=ustar

2003-11-14  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.h (archive_format): USTAR_FORMAT: New type.
	* src/create.c: Added POSIX.1-1988 support.
	* src/names.c (safer_name_suffix): Skip leading ./
	* src/tar.c: New option --format=ustar forces
	POSIX.1-1988 archive format.
	* tests/delete03.sh: Updated.
	* tests/extrac04.sh: Updated.
	* tests/multiv01.sh: Updated.

2003-11-13  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c (read_and): Initialize current_stat_info
	and extended_header at the start of the loop.
	* src/names.c (all_names_found): Check if the argument
	contains valid filename. Fixes coredump on `not_a_tar_file'
	* src/xheader.c (atime_decoder,gid_decoder,ctime_decoder)
	(mtime_decoder,size_decoder,uid_decoder): Use xstrtoumax.
	Fixes `pax-big-10g' bug.

2003-11-12  Paul Eggert  <eggert@twinsun.com>

	Fix some C compatibility bugs reported by Joerg Schilling.

	* src/common.h (stripped_prefix_len): Fix misspelling
	"stripped_path_len" in declaration.
	* src/rmt.c (main): Use "return FOO;" rather than
	"exit (FOO);"; we no longer have to worry about
	pre-ANSI hosts that mishandled returned values from "main".
	* src/tar.c (main): Likewise.  This avoids warnings on some
	compilers.
	* src/system.c: Include signal.h, for 'kill'.
	* src/system.h (DEV_BSIZE): Remove.
	(DEFAULT_ST_BLKSIZE): New macro.
	(ST_BLKSIZE): Use it, instead of DEV_BSIZE.
	* src/tar.c (enum): Remove comma just before }.

2003-11-12  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c (decode_header): Initialize st_atime and
	st_ctime.

2003-11-11  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac (tar_save_LIBS): Bugfix. Thanks Adrian
	Bunk <bunk@fs.tum.de> for reporting.
	* doc/tar.texi: Fixed spelling. Thanks Martin Buchholz
	<martin@xemacs.org> for spotting.

2003-11-04  Paul Eggert  <eggert@twinsun.com>

	* src/xheader.c (xhdr_tab): Make it extern, not static, as C89 and
	C99 require this.

2003-10-26  Paul Eggert  <eggert@twinsun.com>

	* src/system.c (sys_spawn_shell): Cast trailing null to (char *).
	Bug reported by Christian Weisgerber.

2003-10-19  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* AUTHORS: Updated
	* NEWS: Updated
	* src/tar.c (decode_options): Removed superfluous archive format
	check
	* doc/tar.texi: Documented new features.

2003-10-08  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* NEWS: Updated
	* THANKS: Added Wojciech Polak
	* configure.ac: Added checks for missing functions. Raised
	version number to indicate alpha release.
	* lib/Makefile.am: Added missing headers
	* lib/waitpid.c: Added missing includes.
	* src/extract.c: Likewise.
	* src/names.c: Removed spurious includes.
	* src/xheader.c: Likewise.
	* src/system.h [MSDOS]: Fixed spelling of EACCES. Added
	macro overriding broken mkdir prototypes.

2003-10-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Check for dev_t and ino_t.
	* m4/Makefile.am: Added missing files.
	* src/system.c: New file.
	* src/Makefile.am: Added system.c
	* src/common.h: Prototypes for functions from system.c
	* src/system.h (SET_BINARY_MODE, ERRNO_IS_EACCESS): New defines
	* src/buffer.c: Moved system dependencies to system.c
	* src/compare.c: Likewise.
	* src/create.c: Likewise.
	* src/delete.c: Likewise.
	* src/extract.c: Likewise.
	* src/rtapelib.c: Likewise.

2003-10-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Implemented --occurrence option.

	* NEWS: Updated.
	* src/tar.c: New option --occurrence.
	* src/common.h (occurrence_option): New global
	(struct name): Changed `found' member to `uintmax_t
	found_count'.
	(names_done): Removed
	(all_names_found): Changed prototype.
	(ISFOUND,WASFOUND): New macros
	* src/delete.c (delete_archive_members): Honor --occurrence
	option.
	* src/list.c (read_and): Likewise.
	* src/names.c: Count number of occurrences of each name in the
	archive.
	(name_match): Honor --occurrence option.
	(names_done): Removed
	(all_names_found,names_notfound): Rewritten.

2003-10-02  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/tar.c: Removed extra precaution regarding
	subcommand_option == CAT_SUBCOMMAND
	* lib/Makefile.am: Updated

2003-10-02  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/common.h (names_done): New function.
	* src/names.c: Likewise.
	* src/list.c (read_and): Use all_names_found() as `while'
	condition.
	* src/tar.c: New option --first-copy
	* NEWS: Updated

2003-09-24  Paul Eggert  <eggert@twinsun.com>

	* src/rmt.c (main): Don't translate Copyright string; international
	law says the word "Copyright" should be in English.
	* src/tar.c (decode_options): Likewise.

2003-09-22  Paul Eggert  <eggert@twinsun.com>

	* doc/tar.texi (extracting untrusted archives): New section.

	* src/common.h (stripped_path_len): Renamed from cut_path_elements.
	Return size_t, not pointer, so that we don't have to worry about
	violating the C standard by converting char const * to char *.
	All callers changed.
	* src/names.c (stripped_path_len): Likewise.  Strip file system
	prefix, too.  Count adjacent slashes as if they were one slash;
	that is the POSIX standard.

2003-09-17  Paul Eggert  <eggert@twinsun.com>

	* README-alpha: Document maintainer tool assumptions a bit.  GNU
	'sed' is no longer required.  For GNU m4 1.4, suggest the patch in
	Debian bug 211447.  Fix minor misspellings/whitespace nits.

	* configure.ac (AC_AIX, AC_MINIX): Remove; subsumed by
	gl_USE_SYSTEM_EXTENSIONS.

	* lib/.cvsignore: Add exit.h, time_r.c, time_r.h.
	* m4/.cvsignore: Add restrict.m4, time_r.m4.

2003-09-17  Paul Eggert  <eggert@twinsun.com>

	* bootstrap: Don't use "for option; do";
	Solaris 8 /bin/sh doesn't like that.

2003-09-17  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* README-alpha: Updated
	* bootstrap: Updated

2003-09-17  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* README-alpha: Updated
	* bootstrap: Updated
	* po/POTFILES.in: Added src/xheader.c
	* src/common.h (cut_path_elements): Added proto.

2003-09-05  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/buffer.c: Use ngettext where appropriate.
	* src/compare.c: Likewise.
	* src/create.c: Likewise.
	* src/misc.c: Likewise.
	* src/tar.c: Likewise.
	* src/update.c: Likewise.

2003-09-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* .cvsignore: Added *.shar.gz
	* NEWS: Updated
	* TODO: Updated
	* src/common.h (strip_path_elements): New variable.
	* src/extract.c (extract_archive): Implemented --strip-path
	* src/names.c (cut_path_elements): New function.
	* src/tar.c: New option --strip-path=NUM.
	(decode_options) Assign boolean values to bool variables.

2003-09-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/delete.c: Fixed deletion from the POSIX archives.
	* src/list.c (read_header): Minor change.
	* src/tar.c (main): Do not check for volume_label_option
	if subcommand_option is not CREATE_SUBCOMMAND.
	* src/xheader.c (xheader_decode): Store the header as
	well (for eventual delete).

	* tests/incremen.sh: Explicitly request GNU format. This will
	disappear when GNU extended header keywords are working.
	* tests/multiv01.sh: Likewise
	* tests/volume.sh: Likewise

2003-09-04  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/create.c: Support for "linkpath" extended keyword.
	* src/xheader.c (decode_record): Reversed the return
	condition.

2003-09-03  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Allow to redefine the default output format.
	* src/tar.c: Use DEFAULT_ARCHIVE_FORMAT macro
	(archive_format_string): New function.
	(usage): Updated help output.
	* README: Updated.
	* NEWS: Updated.
	* TODO: Updated.

2003-09-02  Paul Eggert  <eggert@twinsun.com>

	* src/common.h (destroy_stat, xheader_decode, xheader_store,
	xheader_read, xheader_finish, xheader_destroy): Add decls;
	C99 requires this.

	* src/create.c (write_extended): Remove unused local 'bufsize'.

	* src/delete.c (delete_archive_members): Handle case of
	HEADER_SUCCESS_EXTENDED followed by HEADER_FAILURE.
	* src/list.c (read_and): Abort if HEADER_SUCCESS_EXTENDED
	occurs, as it's not possible.
	* src/update.c (update_archive): Likewise.

	Use "const" when possible in new code.
	* src/tar.c (struct fmttab.name): Now char const *.  All uses changed.
	(fmttab): Now const.  All uses changed.
	* src/xheader.c (struct xhdr_tab.keyword): Now pointer to const.
	(struct xhdr_tab.coder, struct xhdr_tab.decoder, locate_handler,
	decode_record, xheader_store, xheader_print, code_string, code_time,
	code_num, dummy_coder, dummy_decoder, atime_coder, atime_decoder,
	gid_coder, gid_decoder, gname_coder, gname_decoder, linkpath_coder,
	linkpath_decoder, ctime_coder, ctime_decoder, mtime_coder,
	mtime_decoder, path_coder, path_decoder, size_coder, size_decoder,
	uid_coder, uid_decoder, uname_coder, uname_decoder):
	Use pointers to const when possible.
	(xhdr_tab): Now const.

	* src/tar.c (fmttab): Avoid GCC warning by not eliding initializers.
	(set_archive_format): Report an error if no format name matches,
	instead of returning an undefined value.

	* src/xheader.c (struct xhdr_tab.decoder, dummy_decoder,
	atime_decoder, gid_decoder, gname_decoder, linkpath_decoder,
	ctime_decoder, mtime_decoder, path_decoder, size_decoder,
	uid_decoder, uname_decoder): Remove unused keyword arg.
	All uses changed.

	* src/tar.c (set_archive_format): Now static.
	* src/xheader.c (xhdr_tab, format_uintmax): Now static.

	* src/xheader.c (dummy_coder, dummy_decoder, atime_coder,
	atime_decoder, gid_coder, gid_decoder, gname_coder, gname_decoder,
	linkpath_coder, linkpath_decoder, mtime_coder, mtime_decoder,
	ctime_coder, ctime_decoder, path_coder, path_decoder, size_coder,
	size_decoder, uid_coder, uid_decoder, uname_coder, uname_decoder):
	Remove forward decls; no longer needed.
	(xhdr_tab): Move to end, so that the forward decls aren't needed.
	Add a forward declaration.

	Use 'bool' in new code, when appropriate.
	* src/xheader.c (decode_record): Return bool, not int.
	* src/common.h (read_header): Since it accepts bool, change
	all callers to use false and true rather than 0 and 1.

	* src/xheader.c (decode_record): Fix misspelling in diagnostic
	"extended headed" -> "extended header".

	GNU coding style fixes.
	* src/xheader.c (decode_record, xheader_decode):
	Do not use decls like "char *p, *q;".

	Minor style fixes.
	(xheader_store): Avoid parentheses around object operand of sizeof.

2003-09-03  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/create.c (start_header): Store long file names
	in "path" keyword of an extended header if in POSIX
	mode.
	(finish_header): print header before calling write_extended().
	* src/list.c (list_archive): Always decode the header. This
	is necessary so the extended header is processed and the correct
	filename is printed no matter what the state of verbose_option.
	* src/xheader.c (xhdr_tab): Reserved GNU keywords (commented out
	for the time being).

2003-09-01  Paul Eggert  <eggert@twinsun.com>

	Update from gnulib, and correct fnmatch to fnmatch-gnu.
	* bootstrap (gnulib_modules): Change fnmatch to fnmatch-gnu.
	Sort.
	* configure.ac (gl_USE_SYSTEM_EXTENSIONS): Use this instead
	of AC_GNU_SOURCE.
	* lib/.cvsignore: Add alloca.h, stdbool.h.  Sort.  Append newline.
	* lib/Makefile.am (lib_OBJECTS): New macro, for convenience when
	copying rules from gnulib module descriptions.
	(BUILT_SOURCES, EXTRA_DIST, all-local, alloca.h):
	Update from gnulib modules alloca, fnmatch, getline, stdbool.
	* m4/.cvsignore: Add utimes-null.m4.  Sort.

2003-09-01  Sergey Poznyakoff

	Added initial support for creating POSIX headers.

	* src/common.h (MAXOCTAL11,MAXOCTAL7): New defines
	(string_to_chars): New functions
	(struct xheader): Changed structure
	(gid_to_gname,gname_to_gid,uid_to_uname,uname_to_uid): Changed
	prototypes.
	* src/create.c (string_to_chars): New function.
	(write_extended): New function
	(start_header): Create extended POSIX headers if necessary.
	(finish_header): Likewise.
	* src/list.c (print_header): Take user/group from
	current_stat_info.
	* src/names.c (gid_to_gname,gname_to_gid)
	(uid_to_uname,uname_to_uid): Changed prototypes.
	* src/tar.c: New option --format.
	* src/tar.h (OLDGNU_COMPATIBILITY): Removed
	(struct extra_header): Removed unused structure.
	(union block.extra_header): Removed unused member.
	* src/xheader.c: Implemented coder functions.
	* bootstrap: Added obstack.
	* lib/.cvsignore: Likewise.
	* configure.ac: Added 'gl_OBSTACK'
	* m4/Makefile.am: Added new files.
	* m4/.cvsignore: Likewise.
	* TODO: Minor formatting change

2003-08-31  Sergey Poznyakoff

	Added initial support for POSIX extended and STAR headers
	(only for listing/extracting).

	* src/xheader.c: New file.
	* src/Makefile.am: Added xheader.c
	* src/tar.h (struct star_header): New datatype
	(XHDTYPE,XGLTYPE): New defines
	(enum archive_format:STAR_FORMAT): New member
	(struct tar_stat_info): New datatype.
	(union block.star_header): New member.
	* src/common.h (orig_file_name,current_file_name)
	(current_trailing_slash,current_link_name): Removed variables.
	(current_stat_info): New variable
	(current_stat): Removed
	(extended_header): New variable
	(decode_header): Changed prototype.
	* src/list.c (decode_header): Added initial support for POSIX extended
	and STAR headers.
	(skip_member): Check oldgnu_header only if current_format is set
	to OLDGNU_FORMAT.
	* src/buffer.c: Use current_stat_info
	* src/compare.c: Likewise.
	* src/create.c: Likewise.
	* src/delete.c: Likewise.
	* src/incremen.c: Likewise.
	* src/mangle.c: Likewise.
	* src/update.c: Likewise.
	* src/extract.c: Likewise.
	(make_directories): Improved check for the existence of the directory
	* src/tar.c (destroy_stat): New function.

2003-08-29  Paul Eggert  <eggert@twinsun.com>

	* NEWS, bootstrap: Drop en_GB locale; it was more trouble than it
	was worth (e.g., different users in en_GB disagree about -ize
	versus -ise).
	* po/en_GB.po: Remove.

2003-07-28  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* TODO: Updated
	* NEWS: Updated
	* src/tar.c: Removed support for the obsolete command line
	options.
	* doc/tar.texi: Removed references to the obsolete command
	line options.

2003-07-27  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* TODO: Updated
	* NEWS: Updated
	* doc/tar.texi: Updated
	* src/common.h (check_links_option): New variable
	(orig_file_name): New variable
	(check_links): New proto.
	* src/create.c (struct link.nlink): New member
	(link_table): Static for the module.
	(dump_file): Update `link' member when adding new links
	to the link_table.
	(check_links): New function.
	* src/list.c (print_header): Use orig_file_name.
	* src/tar.c: New option --check-links. Changed semantics of
	-o to comply to UNIX98 when extracting and to its previous
	semantics otherwise.
	(main): Call check_links if --check-links. was given.

2003-07-25  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/list.c (print_header): Revised
	* NEWS: Started the entry for 1.13.26
	* doc/Makefile.am (tar.dvi): Fixed TEXINPUTS value.

2003-07-24  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* .cvsignore: Added to the repository.
	* doc/.cvsignore: Likewise.
	* lib/.cvsignore: Likewise.
	* m4/.cvsignore: Likewise.
	* po/.cvsignore: Likewise.
	* scripts/.cvsignore: Likewise.
	* src/.cvsignore: Likewise.
	* tests/.cvsignore: Likewise.

	* lib/Makefile.am: Added exitfail.[hc]
	* src/misc.c (chdir_do): Fixed call to restore_cwd
	* src/buffer.c (flush_read): Fixed behavior on short
	reads right after opening the new archive (multiv01.sh test).
	(new_volume): Special handling for "-".
	* src/list.c (print_header): Print trailing slash if
	current_trailing_slash was set (extrac03.sh,extrac04.sh tests).
	* tests/multiv01.sh: Minor changes.
	* m4/Makefile.am: Added missing files.

2003-07-05  Paul Eggert  <eggert@twinsun.com>

	Finish the checkin begin yesterday.

	* NEWS: Document the user-visible changes installed in the last
	two days.

	* TODO: New file (actually, resurrected; but with new contents).

	* src/list.c (read_and): Give full type for procedure arg.
	(read_header): Strip trailing slashes, setting current_trailing_slash.
	(tartime): Avoid int overflow when printing year (!).
	(print_header): New arg specifying block ordinal.  All uses changed.
	Print link as 'h' type.  Give labels for long links and names.

	* src/misc.c (contains_dot_dot): Moved to names.c
	(must_be_dot_or_slash): New function.
	(safer_rmdir): Use it.
	(remove_any_file): Now takes enum as option, not boolean.
	Check for (Linux) EISDIR as well as (POSIX) EPERM when attempting
	to unlink a directory.
	(deref_stat): Accept bool, not int.

	* src/names.c (namelist_match): Allow partial matches only if
	recursive.
	(hash_string_hasher): Renamed from hash_avoided_name.
	(hash_string_compare): Renamed from compare_avoided_anames.
	(hash_string_insert, hash_string_lookup): New functions.
	(add_avoided_name, is_avoided_name): Use them.
	(safer_name_suffix): New function.
	(contains_dot_dot): Moved here from misc.c.  Now returns bool, not int.

	* src/rmt.c: Don't include print-copyr.h.
	(prepare_input_buffer): New arg FD.
	Do not read more than INT_MAX bytes at once,
	since it breaks on some brain damaged Tru64 hosts.
	Divide size by two
	when retrying instead of subtracting 1024; for speed.
	(main): Use gettext to translate (C), not print_copyright.

	* src/system.h: Include <alloca.h> and <stdbool.h> unconditionally,
	now that gnulib handles this.
	Include <stddef.h> and <limits.h> unconditionally, now that we assume
	C89 or better.
	Assume that offsetof is defined in stddef.h.
	Do not include <sys/param.h>.
	(realloc, lseek): Do not declare.
	(HAVE_DECL_VALLOC): Renamed from HAVE_VALLOC.
	(CHAR_BIT, CHAR_MAX, UCHAR_MAX, LONG_MAX): Remove
	declarations, since we now assume C89 or better.
	(PARAMS): Remove, as we now assume C89.  All uses changed.
	(bindtextdomain, textdomain): Include <gettext.h> to define.
	Include <unlocked-io.h>.
	(valloc): Define if not defined, and if valloc is not declared.
	(xstrdup): Remove decl.

	* src/tar.c: Do not include <print-copyr.h>.
	Include <getdate.h>.
	(get_date): Remove decl.
	(ATIME_PRESERVE_OPTION, CHECKPOINT_OPTION, FORCE_LOCAL_OPTION,
	IGNORE_FAILED_READ_OPTION, INDEX_FILE_OPTION, NO_OVERWRITE_DIR_OPTION,
	NUMERIC_OWNER_OPTION, RECURSIVE_UNLINK_OPTION, REMOVE_FILES_OPTION,
	SHOW_OMITTED_DIRS_OPTION, TOTALS_OPTION): New constants.
	(long_options, decode_options): Use them.
	(OVERWRITE_DIR_OPTION): Remove.
	(long_options): New options --index-file, --no-overwrite-dir.
	Remove --overwrite-dir option.
	(usage): Use PACKAGE_BUGREPORT.
	(decode_options): Terminate new argv properly.
	Use PACKAGE_NAME, PACKAGE_VERSION.
	If verbose, report how we grokked any textual date option.
	(main): Add support for index-file.

	* tests/Makefile.am: Convert to UTF-8.
	(AUTOMAKE_OPTIONS): Remove.
	(TESTS): Add delete04.sh, multiv01.sh, options.sh.
	(INCLUDES): Remove ../intl.
	(LDADD): Don't link libtar.a twice.

	* tests/genfile.c: Convert to UTF-8.
	Don't include <print-copyr.h>.
	(DEFAULT_PATTERN): Renamed from DEFAULT.
	(ZEROS_PATTERN): Renamed from ZEROS.
	(main): Use gettext to translate (C), not print_copyright.

2003-07-04  Paul Eggert  <eggert@twinsun.com>

	Revamp to meet current standards of autoconf, automake,
	gettext, and gnulib, and incorporate new translations.

	* config/config.guess, config/config.sub, config/depcomp,
	config/install-sh, config/mdate-sh, config/missing,
	config/mkinstalldirs, config/texinfo.texi:
	Moved here from parent directory, or from doc.
	* config.hin: Renamed from config.h.in.
	* config/config.rpath: New file.

	* intl: Remove this subdirectory.

	* lib/fnmatch_.h: Renamed from lib/fnmatch.hin.

	* lib/getstr.c, lib/getstr.h, lib/msleep.c, lib/print-copyr.c,
	lib/print-copyr.h, lib/readutmp.c, lib/rename.c, lib/stpcpy.c,
	lib/strstr.c, lib/strtoimax.c, lib/strtoll.c, lib/strtoull.c,
	lib/strtoumax.c, lib/unicodeio.c, lib/unicodeio.h,
	lib/xstrtoimax.c, m4/c-bs-a.m4, m4/ccstdc.m4, m4/check-decl.m4,
	m4/decl.m4, m4/jm-mktime.m4, m4/prereq.m4, m4/xstrtoimax.m4,
	stamp-h.in: Remove.

	* lib/alloca_.h, lib/fnmatch_loop.c, lib/gettext.h, lib/pathmax.h,
	lib/safe-write.c, lib/safe-write.h, lib/stdbool_.h, lib/strcase.h,
	lib/stripslash.c, lib/unlocked-io.h, lib/xgetcwd.h, m4/alloca.m4,
	m4/backupfile.m4, m4/bison.m4, m4/chown.m4, m4/dirname.m4,
	m4/dos.m4, m4/exclude.m4, m4/fileblocks.m4, m4/ftruncate.m4,
	m4/getdate.m4, m4/getopt.m4, m4/hash.m4, m4/human.m4,
	m4/intdiv0.m4, m4/intmax_t.m4, m4/inttypes-pri.m4,
	m4/inttypes_h.m4, m4/isc-posix.m4, m4/lchown.m4, m4/lib-ld.m4,
	m4/lib-link.m4, m4/lib-prefix.m4, m4/memset.m4, m4/mktime.m4,
	m4/modechange.m4, m4/nls.m4, m4/onceonly.m4, m4/pathmax.m4,
	m4/po.m4, m4/quote.m4, m4/quotearg.m4, m4/rmdir.m4,
	m4/safe-read.m4, m4/safe-write.m4, m4/save-cwd.m4, m4/savedir.m4,
	m4/ssize_t.m4, m4/stdbool.m4, m4/stdint_h.m4, m4/strcase.m4,
	m4/strtoimax.m4, m4/strtol.m4, m4/strtoll.m4, m4/strtoul.m4,
	m4/strtoull.m4, m4/strtoumax.m4, m4/tm_gmtoff.m4, m4/uintmax_t.m4,
	m4/unlocked-io.m4, m4/xalloc.m4, m4/xgetcwd.m4, m4/xstrtol.m4,
	po/LINGUAS, po/Makevars, po/Rules-quot, po/boldquot.sed,
	po/en@boldquot.header, po/en@quot.header, po/en_GB.po,
	po/insert-header.sin, po/remove-potcdate.sin, po/stamp-po: New files.

	* ABOUT-NLS, INSTALL, lib/addext.c, lib/alloca.c, lib/argmatch.c,
	lib/argmatch.h, lib/backupfile.c, lib/backupfile.h, lib/dirname.c,
	lib/dirname.h, lib/error.c, lib/exclude.c, lib/exclude.h,
	lib/fnmatch.h, lib/full-write.c, lib/full-write.h, lib/getdate.h,
	lib/getdate.y, lib/getline.c, lib/getline.h, lib/getopt.c,
	lib/getopt.h, lib/getopt1.c, lib/hash.c, lib/hash.h, lib/human.c,
	lib/human.h, lib/lchown.c, lib/malloc.c, lib/mktime.c,
	lib/modechange.c, lib/modechange.h, lib/quote.c, lib/quote.h,
	lib/quotearg.c, lib/quotearg.h, lib/realloc.c, lib/safe-read.c,
	lib/safe-read.h, lib/save-cwd.c, lib/save-cwd.h, lib/savedir.c,
	lib/savedir.h, lib/strcasecmp.c, lib/utime.c, lib/xalloc.h,
	lib/xgetcwd.c, lib/xmalloc.c, lib/xstrdup.c, lib/xstrtol.c,
	lib/xstrtol.h, lib/xstrtoumax.c, m4/codeset.m4, m4/d-ino.m4,
	m4/error.m4, m4/fnmatch.m4, m4/getcwd.m4, m4/getline.m4, m4/gettext.m4,
	m4/glibc21.m4, m4/iconv.m4, m4/inttypes.m4, m4/lcmessage.m4,
	m4/longlong.m4, m4/malloc.m4, m4/mbrtowc.m4, m4/mbstate_t.m4,
	m4/progtest.m4, m4/realloc.m4, m4/strerror_r.m4, m4/ulonglong.m4,
	m4/utimbuf.m4, m4/utime.m4, m4/utimes.m4, m4/xstrtoumax.m4,
	po/Makefile.in.in:
	Upgrade to latest version from external source.  The file "bootstrap"
	now grabs these automatically, so we needn't keep track of them
	in this change long any longer.

	* Makefile.am (AUTOMAKE_OPTIONS): Remove.  Now done by configure.ac.
	(SUBDIRS): Remove intl.
	* PORTS: Update for star, Macintosh.
	* README, README-alpha: Suggest Autoconf 2.57, Automake 1.7.5,
	Bison 1.875, gettext 0.12.1.
	* THANKS: Add Bernhard Rosenkraenzer, Solar Designer.
	* configure.ac (AC_INIT, AM_INIT_AUTOMAKE): Convert to modern form.
	(AC_CONFIG_AUX_DIR): New.
	(AC_CONFIG_HEADERS): Rename config.h.in to config.hin, to be more
	like coreutils.
	(AC_PREREQ): Bump from 2.52 to 2.57.
	(AC_GNU_SOURCE): New.
	(AC_PROG_GCC_TRADITIONAL, AM_C_PROTOTYPES, AC_C_CONST): Remove;
